//------------------------- Geneated Java Class File For AddressDAO Class ---------------------------------

package hu.bme.mit.contactbook.dbutility;

import hu.bme.mit.contactbook.entities.Address;
import hu.bme.mit.contactbook.entities.Person;
import java.util.List;
import com.j256.ormlite.dao.Dao;
import java.sql.SQLException;

//
public class AddressDAO implements AddressDAOInterface {
	
	// Property declarations
	
	//
	private static Dao<Address, Integer> addressDAO = null;
	
	// Constructor
	
	public AddressDAO(){
		try {
			addressDAO = DatabaseFactory.getAddressDAO();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
	
	@Override
	public boolean createAddress(Person person, Address address) {
		try {
			address.setPerson(person);
			addressDAO.create(address);
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}
	@Override
		public boolean createAddress(Address address){
			try {
				addressDAO.create(address);
			} catch (SQLException e) {
				e.printStackTrace();
				return false;
			}
			return true;
		}
	
	@Override
	public boolean updateAddress(Address address) {
		try {
			addressDAO.update(address);
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}
	
	public boolean deleteAddress(Address address) {
		try {
			addressDAO.delete(address);
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}
	
	@Override
	public boolean deleteAddresss(List<Address> addresss) {
		try {
			addressDAO.delete(addresss);
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}
	
	@Override
	public boolean refreshAddress(Address address) {
		try {
			addressDAO.refresh(address);
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}
	
	@Override
	public List<Address> getAddresss() {
		try {
			return addressDAO.queryForAll();
		} catch (SQLException e) {
			e.printStackTrace();
			return null;
		}
	}
	
	@Override
	public List<Address> getAddresssByPersonContainment(Person person) {
		try {
			List<Address> addressList = addressDAO.query(addressDAO.queryBuilder().where().eq(Address.PERSON_ID_FIELD_NAME, person.getId()).prepare());
			return addressList;
		} catch (SQLException e) {
			e.printStackTrace();
			return null;
		}
	}
	
	
	@Override
	public Address getAddressByID(int id) {
		try {
			return addressDAO.queryForId(id);
		} catch (SQLException e) {
			e.printStackTrace();
			return null;
		}
	}
	
	@Override
	public Dao<Address, Integer> getDAO() {
		return addressDAO;
	}
	
	
	
}
