//------------------------- Geneated Java Class File For DatabaseFactory Class ---------------------------------

package hu.bme.mit.contactbook.dbutility;

import hu.bme.mit.contactbook.entities.Email;
import hu.bme.mit.contactbook.entities.Address;
import hu.bme.mit.contactbook.entities.Note;
import hu.bme.mit.contactbook.entities.PhoneNumber;
import hu.bme.mit.contactbook.entities.Person;
import hu.bme.mit.contactbook.entities.Profile;
import java.sql.SQLException;
import android.content.Context;
import com.j256.ormlite.android.apptools.OpenHelperManager;
import com.j256.ormlite.dao.Dao;

//
class DatabaseFactory {
	
	//
	private static DatabaseHelper dbHelper = null;
	
	//
	private static Dao<Email, Integer> emailDAO = null;
	
	//
	private static Dao<Address, Integer> addressDAO = null;
	
	//
	private static Dao<Note, Integer> noteDAO = null;
	
	//
	private static Dao<PhoneNumber, Integer> phoneNumberDAO = null;
	
	//
	private static Dao<Person, Integer> personDAO = null;
	
	//
	private static Dao<Profile, Integer> profileDAO = null;
	
	
	//
	static void initDatabase(Context c){
		if(dbHelper == null){
			dbHelper = OpenHelperManager.getHelper(c, DatabaseHelper.class);
		}
	};
	
	//
	static void colseDatabase(){
		if(dbHelper != null){
			OpenHelperManager.releaseHelper();
			dbHelper = null;
		}
	}
	
	//
	static String getDBName(){
		return DatabaseHelper.DATABASE_NAME;
	}
	
	//
	static int getDBVersion(){
		return DatabaseHelper.DATABASE_VERSION;
	}
	
	//
	static Dao<Email, Integer> getEmailDAO() throws SQLException{
		if(emailDAO == null){
			emailDAO = dbHelper.getDao(Email.class);
		}
		return emailDAO;
	}
	
	//
	static Dao<Address, Integer> getAddressDAO() throws SQLException{
		if(addressDAO == null){
			addressDAO = dbHelper.getDao(Address.class);
		}
		return addressDAO;
	}
	
	//
	static Dao<Note, Integer> getNoteDAO() throws SQLException{
		if(noteDAO == null){
			noteDAO = dbHelper.getDao(Note.class);
		}
		return noteDAO;
	}
	
	//
	static Dao<PhoneNumber, Integer> getPhoneNumberDAO() throws SQLException{
		if(phoneNumberDAO == null){
			phoneNumberDAO = dbHelper.getDao(PhoneNumber.class);
		}
		return phoneNumberDAO;
	}
	
	//
	static Dao<Person, Integer> getPersonDAO() throws SQLException{
		if(personDAO == null){
			personDAO = dbHelper.getDao(Person.class);
		}
		return personDAO;
	}
	
	//
	static Dao<Profile, Integer> getProfileDAO() throws SQLException{
		if(profileDAO == null){
			profileDAO = dbHelper.getDao(Profile.class);
		}
		return profileDAO;
	}
	
	
	//
	static <T> Dao<T, Integer> getGenericDAO(Class<T> t) throws SQLException{
		return dbHelper.getDao(t);
	}
}
