//------------------------- Geneated Java Class File For DatabaseHelper Class ---------------------------------

package hu.bme.mit.contactbook.dbutility;

import hu.bme.mit.contactbook.entities.Email;
import hu.bme.mit.contactbook.entities.Address;
import hu.bme.mit.contactbook.entities.Note;
import hu.bme.mit.contactbook.entities.PhoneNumber;
import hu.bme.mit.contactbook.entities.Person;
import hu.bme.mit.contactbook.entities.Profile;
import java.sql.SQLException;
import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import com.j256.ormlite.android.apptools.OrmLiteSqliteOpenHelper;
import com.j256.ormlite.support.ConnectionSource;
import com.j256.ormlite.table.TableUtils;

//
class DatabaseHelper extends OrmLiteSqliteOpenHelper {
	
	// Property declarations
	
	//
	public static final String DATABASE_NAME = "Default_DB";
	//
	public static final int DATABASE_VERSION = 1;
	
	// Constructor
	
	//
	public DatabaseHelper(Context context) {
		super(context, DATABASE_NAME, null, DATABASE_VERSION);
	}
	
	//
	@Override
	public void onCreate(SQLiteDatabase db, ConnectionSource connectionSource) {
		try {
			TableUtils.createTable(connectionSource, Email.class);
			TableUtils.createTable(connectionSource, Address.class);
			TableUtils.createTable(connectionSource, Note.class);
			TableUtils.createTable(connectionSource, PhoneNumber.class);
			TableUtils.createTable(connectionSource, Person.class);
			TableUtils.createTable(connectionSource, Profile.class);
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
	
	//
	@Override
	public void onUpgrade(SQLiteDatabase db, ConnectionSource connectionSource, int oldVersion, int newVersion) {
		try {
			TableUtils.dropTable(connectionSource, Email.class, true);
			TableUtils.dropTable(connectionSource, Address.class, true);
			TableUtils.dropTable(connectionSource, Note.class, true);
			TableUtils.dropTable(connectionSource, PhoneNumber.class, true);
			TableUtils.dropTable(connectionSource, Person.class, true);
			TableUtils.dropTable(connectionSource, Profile.class, true);
			onCreate(db, connectionSource);
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
	
	//
	@Override
	public void close() {
		super.close();
	}
	
}
