//------------------------- Geneated Java Class File For EmailDAO Class ---------------------------------

package hu.bme.mit.contactbook.dbutility;

import hu.bme.mit.contactbook.entities.Email;
import hu.bme.mit.contactbook.entities.Person;
import java.util.List;
import com.j256.ormlite.dao.Dao;
import java.sql.SQLException;

//
public class EmailDAO implements EmailDAOInterface {
	
	// Property declarations
	
	//
	private static Dao<Email, Integer> emailDAO = null;
	
	// Constructor
	
	public EmailDAO(){
		try {
			emailDAO = DatabaseFactory.getEmailDAO();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
	
	@Override
	public boolean createEmail(Person person, Email email) {
		try {
			email.setPerson(person);
			emailDAO.create(email);
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}
	@Override
		public boolean createEmail(Email email){
			try {
				emailDAO.create(email);
			} catch (SQLException e) {
				e.printStackTrace();
				return false;
			}
			return true;
		}
	
	@Override
	public boolean updateEmail(Email email) {
		try {
			emailDAO.update(email);
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}
	
	public boolean deleteEmail(Email email) {
		try {
			emailDAO.delete(email);
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}
	
	@Override
	public boolean deleteEmails(List<Email> emails) {
		try {
			emailDAO.delete(emails);
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}
	
	@Override
	public boolean refreshEmail(Email email) {
		try {
			emailDAO.refresh(email);
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}
	
	@Override
	public List<Email> getEmails() {
		try {
			return emailDAO.queryForAll();
		} catch (SQLException e) {
			e.printStackTrace();
			return null;
		}
	}
	
	@Override
	public List<Email> getEmailsByPersonContainment(Person person) {
		try {
			List<Email> emailList = emailDAO.query(emailDAO.queryBuilder().where().eq(Email.PERSON_ID_FIELD_NAME, person.getId()).prepare());
			return emailList;
		} catch (SQLException e) {
			e.printStackTrace();
			return null;
		}
	}
	
	
	@Override
	public Email getEmailByID(int id) {
		try {
			return emailDAO.queryForId(id);
		} catch (SQLException e) {
			e.printStackTrace();
			return null;
		}
	}
	
	@Override
	public Dao<Email, Integer> getDAO() {
		return emailDAO;
	}
	
	
	
}
