//------------------------- Geneated Java Class File For NoteDAO Class ---------------------------------

package hu.bme.mit.contactbook.dbutility;

import hu.bme.mit.contactbook.entities.Note;
import hu.bme.mit.contactbook.entities.Person;
import java.util.List;
import com.j256.ormlite.dao.Dao;
import java.sql.SQLException;

//
public class NoteDAO implements NoteDAOInterface {
	
	// Property declarations
	
	//
	private static Dao<Note, Integer> noteDAO = null;
	
	// Constructor
	
	public NoteDAO(){
		try {
			noteDAO = DatabaseFactory.getNoteDAO();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
	
	@Override
	public boolean createNote(Person person, Note note) {
		try {
			note.setPerson(person);
			noteDAO.create(note);
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}
	@Override
		public boolean createNote(Note note){
			try {
				noteDAO.create(note);
			} catch (SQLException e) {
				e.printStackTrace();
				return false;
			}
			return true;
		}
	
	@Override
	public boolean updateNote(Note note) {
		try {
			noteDAO.update(note);
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}
	
	public boolean deleteNote(Note note) {
		try {
			noteDAO.delete(note);
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}
	
	@Override
	public boolean deleteNotes(List<Note> notes) {
		try {
			noteDAO.delete(notes);
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}
	
	@Override
	public boolean refreshNote(Note note) {
		try {
			noteDAO.refresh(note);
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}
	
	@Override
	public List<Note> getNotes() {
		try {
			return noteDAO.queryForAll();
		} catch (SQLException e) {
			e.printStackTrace();
			return null;
		}
	}
	
	@Override
	public Note getNoteByPersonContainment(Person person) {
		try {
			List<Note> noteList = noteDAO.query(noteDAO.queryBuilder().where().eq(Note.PERSON_ID_FIELD_NAME, person.getId()).prepare());
			if(noteList.size() > 0){
				return noteList.get(0);
			}
			else{
				return null;
			}
		} catch (SQLException e) {
			e.printStackTrace();
			return null;
		}
	}
	
	
	@Override
	public Note getNoteByID(int id) {
		try {
			return noteDAO.queryForId(id);
		} catch (SQLException e) {
			e.printStackTrace();
			return null;
		}
	}
	
	@Override
	public Dao<Note, Integer> getDAO() {
		return noteDAO;
	}
	
	
	
}
