//------------------------- Geneated Java Class File For PersonDAO Class ---------------------------------

package hu.bme.mit.contactbook.dbutility;

import hu.bme.mit.contactbook.entities.Person;
import hu.bme.mit.contactbook.entities.Profile;
import hu.bme.mit.contactbook.entities.Address;
import hu.bme.mit.contactbook.entities.Email;
import hu.bme.mit.contactbook.entities.PhoneNumber;
import hu.bme.mit.contactbook.entities.Note;
import java.util.List;
import com.j256.ormlite.dao.Dao;
import java.sql.SQLException;

//
public class PersonDAO implements PersonDAOInterface {
	
	// Property declarations
	
	//
	private static Dao<Person, Integer> personDAO = null;
	
	// Constructor
	
	public PersonDAO(){
		try {
			personDAO = DatabaseFactory.getPersonDAO();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
	
	@Override
	public boolean createPerson(Profile profile, Person person) {
		try {
			person.setProfile(profile);
			personDAO.create(person);
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}
	@Override
		public boolean createPerson(Person person){
			try {
				personDAO.create(person);
			} catch (SQLException e) {
				e.printStackTrace();
				return false;
			}
			return true;
		}
	
	@Override
	public boolean updatePerson(Person person) {
		try {
			personDAO.update(person);
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}
	
	public boolean deletePerson(Person person) {
		try {
			List<Address> addresslist = DAOFactory.getAddressDAO().getAddresssByPersonContainment(person);
			DAOFactory.getAddressDAO().deleteAddresss(addresslist);
			
			List<Email> emaillist = DAOFactory.getEmailDAO().getEmailsByPersonContainment(person);
			DAOFactory.getEmailDAO().deleteEmails(emaillist);
			
			List<PhoneNumber> phoneNumberlist = DAOFactory.getPhoneNumberDAO().getPhoneNumbersByPersonContainment(person);
			DAOFactory.getPhoneNumberDAO().deletePhoneNumbers(phoneNumberlist);
			
			Note note = DAOFactory.getNoteDAO().getNoteByPersonContainment(person);
			DAOFactory.getNoteDAO().deleteNote(note);
			
			personDAO.delete(person);
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}
	
	public boolean deletePersons(List<Person> persons) {
		try {
			for(Person person : persons){
				List<Address> addresslist = DAOFactory.getAddressDAO().getAddresssByPersonContainment(person);
				DAOFactory.getAddressDAO().deleteAddresss(addresslist);
				
				List<Email> emaillist = DAOFactory.getEmailDAO().getEmailsByPersonContainment(person);
				DAOFactory.getEmailDAO().deleteEmails(emaillist);
				
				List<PhoneNumber> phoneNumberlist = DAOFactory.getPhoneNumberDAO().getPhoneNumbersByPersonContainment(person);
				DAOFactory.getPhoneNumberDAO().deletePhoneNumbers(phoneNumberlist);
				
				Note note = DAOFactory.getNoteDAO().getNoteByPersonContainment(person);
				DAOFactory.getNoteDAO().deleteNote(note);
				
				personDAO.delete(person);
			}
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}
	
	@Override
	public boolean refreshPerson(Person person) {
		try {
			personDAO.refresh(person);
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}
	
	@Override
	public List<Person> getPersons() {
		try {
			return personDAO.queryForAll();
		} catch (SQLException e) {
			e.printStackTrace();
			return null;
		}
	}
	
	@Override
	public List<Person> getPersonsByProfileContainment(Profile profile) {
		try {
			List<Person> personList = personDAO.query(personDAO.queryBuilder().where().eq(Person.PROFILE_ID_FIELD_NAME, profile.getId()).prepare());
			return personList;
		} catch (SQLException e) {
			e.printStackTrace();
			return null;
		}
	}
	
	
	@Override
	public Person getPersonByID(int id) {
		try {
			return personDAO.queryForId(id);
		} catch (SQLException e) {
			e.printStackTrace();
			return null;
		}
	}
	
	@Override
	public Dao<Person, Integer> getDAO() {
		return personDAO;
	}
	
	
	
}
