//------------------------- Geneated Java Class File For PhoneNumberDAO Class ---------------------------------

package hu.bme.mit.contactbook.dbutility;

import hu.bme.mit.contactbook.entities.PhoneNumber;
import hu.bme.mit.contactbook.entities.Person;
import java.util.List;
import com.j256.ormlite.dao.Dao;
import java.sql.SQLException;

//
public class PhoneNumberDAO implements PhoneNumberDAOInterface {
	
	// Property declarations
	
	//
	private static Dao<PhoneNumber, Integer> phoneNumberDAO = null;
	
	// Constructor
	
	public PhoneNumberDAO(){
		try {
			phoneNumberDAO = DatabaseFactory.getPhoneNumberDAO();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
	
	@Override
	public boolean createPhoneNumber(Person person, PhoneNumber phoneNumber) {
		try {
			phoneNumber.setPerson(person);
			phoneNumberDAO.create(phoneNumber);
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}
	@Override
		public boolean createPhoneNumber(PhoneNumber phoneNumber){
			try {
				phoneNumberDAO.create(phoneNumber);
			} catch (SQLException e) {
				e.printStackTrace();
				return false;
			}
			return true;
		}
	
	@Override
	public boolean updatePhoneNumber(PhoneNumber phoneNumber) {
		try {
			phoneNumberDAO.update(phoneNumber);
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}
	
	public boolean deletePhoneNumber(PhoneNumber phoneNumber) {
		try {
			phoneNumberDAO.delete(phoneNumber);
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}
	
	@Override
	public boolean deletePhoneNumbers(List<PhoneNumber> phoneNumbers) {
		try {
			phoneNumberDAO.delete(phoneNumbers);
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}
	
	@Override
	public boolean refreshPhoneNumber(PhoneNumber phoneNumber) {
		try {
			phoneNumberDAO.refresh(phoneNumber);
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}
	
	@Override
	public List<PhoneNumber> getPhoneNumbers() {
		try {
			return phoneNumberDAO.queryForAll();
		} catch (SQLException e) {
			e.printStackTrace();
			return null;
		}
	}
	
	@Override
	public List<PhoneNumber> getPhoneNumbersByPersonContainment(Person person) {
		try {
			List<PhoneNumber> phoneNumberList = phoneNumberDAO.query(phoneNumberDAO.queryBuilder().where().eq(PhoneNumber.PERSON_ID_FIELD_NAME, person.getId()).prepare());
			return phoneNumberList;
		} catch (SQLException e) {
			e.printStackTrace();
			return null;
		}
	}
	
	
	@Override
	public PhoneNumber getPhoneNumberByID(int id) {
		try {
			return phoneNumberDAO.queryForId(id);
		} catch (SQLException e) {
			e.printStackTrace();
			return null;
		}
	}
	
	@Override
	public Dao<PhoneNumber, Integer> getDAO() {
		return phoneNumberDAO;
	}
	
	
	
}
