//------------------------- Geneated Java Class File For ProfileDAO Class ---------------------------------

package hu.bme.mit.contactbook.dbutility;

import hu.bme.mit.contactbook.entities.Profile;
import hu.bme.mit.contactbook.entities.Person;
import java.util.List;
import com.j256.ormlite.dao.Dao;
import java.sql.SQLException;

//
public class ProfileDAO implements ProfileDAOInterface {
	
	// Property declarations
	
	//
	private static Dao<Profile, Integer> profileDAO = null;
	
	// Constructor
	
	public ProfileDAO(){
		try {
			profileDAO = DatabaseFactory.getProfileDAO();
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}
	
	@Override
		public boolean createProfile(Profile profile){
			try {
				profileDAO.create(profile);
			} catch (SQLException e) {
				e.printStackTrace();
				return false;
			}
			return true;
		}
	
	@Override
	public boolean updateProfile(Profile profile) {
		try {
			profileDAO.update(profile);
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}
	
	public boolean deleteProfile(Profile profile) {
		try {
			List<Person> personlist = DAOFactory.getPersonDAO().getPersonsByProfileContainment(profile);
			DAOFactory.getPersonDAO().deletePersons(personlist);
			
			profileDAO.delete(profile);
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}
	
	public boolean deleteProfiles(List<Profile> profiles) {
		try {
			for(Profile profile : profiles){
				List<Person> personlist = DAOFactory.getPersonDAO().getPersonsByProfileContainment(profile);
				DAOFactory.getPersonDAO().deletePersons(personlist);
				
				profileDAO.delete(profile);
			}
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}
	
	@Override
	public boolean refreshProfile(Profile profile) {
		try {
			profileDAO.refresh(profile);
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		}
		return true;
	}
	
	@Override
	public List<Profile> getProfiles() {
		try {
			return profileDAO.queryForAll();
		} catch (SQLException e) {
			e.printStackTrace();
			return null;
		}
	}
	
	
	
	@Override
	public Profile getProfileByID(int id) {
		try {
			return profileDAO.queryForId(id);
		} catch (SQLException e) {
			e.printStackTrace();
			return null;
		}
	}
	
	@Override
	public Dao<Profile, Integer> getDAO() {
		return profileDAO;
	}
	
	
	
}
