//------------------------- Geneated Java Class File For Entity - Note ---------------------------------
//------------------------- Model Implementation In /CBModelingTestX/src/test3.dm Resource File --------------

package hu.bme.mit.contactbook.entities;

import android.os.Parcel;
import android.os.Parcelable;
import com.j256.ormlite.field.DatabaseField;
import com.j256.ormlite.table.DatabaseTable;

//
@DatabaseTable(tableName = "note")
public class Note implements Parcelable {
	
	// Property declarations
	
	public static final String NOTE_FIELD_NAME = "note";
	public static final String PERSON_ID_FIELD_NAME = "person_id";
	@DatabaseField(columnName = "id", generatedId = true)
	private int id;
	
	//
	@DatabaseField(columnName = NOTE_FIELD_NAME, canBeNull = false)
	protected String note;
	
	
	// Association declarations
	
	//
	@DatabaseField(foreign = true, columnName = PERSON_ID_FIELD_NAME, unique = true)
	protected Person person;
	
	
	// Parcelable creator
	
	//
	public static final Parcelable.Creator<Note> CREATOR = new Parcelable.Creator<Note>() {
		public Note createFromParcel(Parcel pc) {
			return new Note(pc);
		}
		public Note[] newArray(int size) {
			return new Note[size];
		}
	};
	
	// Constructor
	
	//
	protected Note(){
		super();
	}
	
	protected Note(Note note){
		super();
	}
	
	public Note(Parcel pc){
		super();
		
		note = pc.readString();
		person = (Person) pc.readValue(Person.class.getClassLoader());
	}
	
	
	// Parcel methods
	
	
	@Override
	public int describeContents() {
		return 0;
	}
	
	@Override
	public void writeToParcel(Parcel dest, int flags) {
		dest.writeString(note);
		dest.writeValue(person);
	}
	
	
	// Getter-setters
	
	//
	public int getId() {
		return id;
	}
	
	//
	public String getNote(){
		return this.note;
	}
	
	//
	public void setNote(String note){
		this.note = note;
	}
	
	//
	public Person getPerson(){
		return this.person;
	}
	
	//
	public void setPerson(Person person){
		this.person = person;
	}
	
}
