//------------------------- Geneated Java Class File For Entity - Person ---------------------------------
//------------------------- Model Implementation In /CBModelingTestX/src/test2.dm Resource File --------------

package hu.bme.mit.contactbook.entities;

import android.os.Parcel;
import android.os.Parcelable;
import com.j256.ormlite.field.DatabaseField;
import com.j256.ormlite.table.DatabaseTable;

//
@DatabaseTable(tableName = "person")
public class Person implements Parcelable {
	
	// Property declarations
	
	public static final String PERSONNAME_FIELD_NAME = "personname";
	public static final String CREATIONDATE_FIELD_NAME = "creationdate";
	public static final String PROFILE_ID_FIELD_NAME = "profile_id";
	@DatabaseField(columnName = "id", generatedId = true)
	private int id;
	
	//
	@DatabaseField(columnName = PERSONNAME_FIELD_NAME, canBeNull = false)
	protected String personName;
	
	//
	@DatabaseField(columnName = CREATIONDATE_FIELD_NAME, canBeNull = false)
	protected String creationDate;
	
	
	// Association declarations
	
	//
	@DatabaseField(foreign = true, columnName = PROFILE_ID_FIELD_NAME)
	protected Profile profile;
	
	
	// Parcelable creator
	
	//
	public static final Parcelable.Creator<Person> CREATOR = new Parcelable.Creator<Person>() {
		public Person createFromParcel(Parcel pc) {
			return new Person(pc);
		}
		public Person[] newArray(int size) {
			return new Person[size];
		}
	};
	
	// Constructor
	
	//
	protected Person(){
		super();
	}
	
	protected Person(Person person){
		super();
	}
	
	public Person(Parcel pc){
		super();
		
		personName = pc.readString();
		creationDate = pc.readString();
		profile = (Profile) pc.readValue(Profile.class.getClassLoader());
	}
	
	
	// Parcel methods
	
	
	@Override
	public int describeContents() {
		return 0;
	}
	
	@Override
	public void writeToParcel(Parcel dest, int flags) {
		dest.writeString(personName);
		dest.writeString(creationDate);
		dest.writeValue(profile);
	}
	
	
	// Getter-setters
	
	//
	public int getId() {
		return id;
	}
	
	//
	public String getPersonName(){
		return this.personName;
	}
	
	//
	public void setPersonName(String personName){
		this.personName = personName;
	}
	
	//
	public String getCreationDate(){
		return this.creationDate;
	}
	
	//
	public void setCreationDate(String creationDate){
		this.creationDate = creationDate;
	}
	
	//
	public Profile getProfile(){
		return this.profile;
	}
	
	//
	public void setProfile(Profile profile){
		this.profile = profile;
	}
	
}
