package hu.bme.mit.contactbook.activities;

import hu.bme.mit.contactbook.R;
import hu.bme.mit.contactbook.adapters.AddressAdapter;
import hu.bme.mit.contactbook.application.CBApplication;
import hu.bme.mit.contactbook.dbutility.DAOFactory;
import hu.bme.mit.contactbook.entities.Address;
import android.os.Bundle;
import android.view.ContextMenu;
import android.view.ContextMenu.ContextMenuInfo;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;

public class AddressActivity extends AddressActivityG {
	
	AddressAdapter addressAdapter;
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
	
		
		addressAdapter = new AddressAdapter(getApplicationContext());
		setListAdapter(addressAdapter);

		registerForContextMenu(getListView());
	}
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.address_menu, menu);
		return true;
	}
	
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch(item.getItemId()){
		case R.id.item1:
			startAddAddressActivityG(AddAddress.class);
//			Intent i = new Intent(getApplicationContext(), AddAddress.class);
//    		startActivity(i);
			return true;
		default:
			return false;
		}
	}
	
	@Override
	protected void onResume() {
		super.onResume();
		((AddressAdapter) getListAdapter()).refreshList();
		((AddressAdapter) getListAdapter()).notifyDataSetChanged();
	}
	
	@Override
	public void onCreateContextMenu(ContextMenu menu, View v,
			ContextMenuInfo menuInfo) {
		if (v.equals(getListView())) {
			menu.setHeaderTitle("Address");
			String[] menuItems = getResources()
					.getStringArray(R.array.profile_menu_items);
			for (int i = 0; i < menuItems.length; i++) {
				menu.add(Menu.NONE, i, i, menuItems[i]);
			}
		}
	}

	@Override
	public boolean onContextItemSelected(MenuItem item) {
		AdapterView.AdapterContextMenuInfo info = (AdapterView.AdapterContextMenuInfo) item
				.getMenuInfo();
		int menuItemIndex = item.getItemId();
		 if (menuItemIndex == 0) {
			int pos = info.position;
			CBApplication.setCurrentAddress((Address)addressAdapter.getItem(pos));
			
			startEditAddressActivityG(EditAddress.class);
//			Intent i = new Intent(getApplicationContext(), EditAddress.class);
//			startActivity(i);
		}
		else if (menuItemIndex == 1) {
			int pos = info.position;
			Address a = (Address)addressAdapter.getItem(pos);
			DAOFactory.getAddressDAO().deleteAddress(a);
			((AddressAdapter) getListAdapter()).refreshList();
			((AddressAdapter) getListAdapter()).notifyDataSetChanged();
		}
		return true;
	}
	
}