package hu.bme.mit.contactbook.activities;

import hu.bme.mit.contactbook.R;
import hu.bme.mit.contactbook.application.CBApplication;
import hu.bme.mit.contactbook.dbutility.DAOFactory;
import hu.bme.mit.contactbook.dbutility.DataCache;
import hu.bme.mit.contactbook.entities.MyPerson;
import hu.bme.mit.contactbook.entities.Person;
import hu.bme.mit.contactbook.entities.Profile;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.AutoCompleteTextView;
import android.widget.Button;

import com.j256.ormlite.dao.Dao;

public class CopyPerson extends CopyPersonActivityG {
	
	private Button CopyBtn;
	private Button CancelBtn;
	private AutoCompleteTextView searchfield;
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.copy_person);
        
        searchfield = (AutoCompleteTextView)findViewById(R.id.profileName);
        
        List<Profile> profs = DataCache.getProfiles();
        List<String> list = new ArrayList<String>();
        for(Profile p : profs){
        	list.add(p.getProfileName());
        }
        String[] stringlist = list.toArray(new String[list.size()]);
        ArrayAdapter<String> searchAdapter =
        		new ArrayAdapter<String>(this,
        		android.R.layout.
        		simple_dropdown_item_1line, stringlist);
        		searchfield.setAdapter(searchAdapter);
        
        CopyBtn = (Button)findViewById(R.id.btnCopyPerson);
        CancelBtn = (Button)findViewById(R.id.btnCancelCopyPerson);
        
        CancelBtn.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				navigateBack();
			}
		});
        
        CopyBtn.setOnClickListener(enterPerson);
    }
    
    OnClickListener enterPerson = new OnClickListener() {
		
		@Override
		public void onClick(View v) {
			String s = searchfield.getText().toString();
			Dao<Profile,Integer> dao = DAOFactory.getProfileDAO().getDAO();
			List<Profile> pList = null;
			try {
				pList = dao.query(dao.queryBuilder().where().eq(Profile.PROFILENAME_FIELD_NAME, s).prepare());
			} catch (SQLException e) {
				e.printStackTrace();
			}
			if(pList.size() == 0 || pList.size() > 1){
				searchfield.setError("No such profile!");
			}
			else if(pList.get(0).getProfileName().equals(CBApplication.getCurrentProfile().getProfileName())){
				searchfield.setError("It's the current profile!");
			}
			else{
				Dao<Person,Integer> dao2 = DAOFactory.getPersonDAO().getDAO();
				List<Person> perList = null;
				try {
					perList = dao2.query(dao2.queryBuilder().where().eq(Person.PROFILE_ID_FIELD_NAME, pList.get(0)).prepare());
				} catch (SQLException e) {
					e.printStackTrace();
				}
				boolean exists = false;
				for(Person p : perList){
					if(p.getPersonName().equals(CBApplication.getCurrentPerson())){
						exists = true;
						break;
					}
				}
				if(!exists){
					CBApplication.setCurrentProfile(pList.get(0));
					new MyPerson(CBApplication.getCurrentPerson());
					
					startPersonListActivityGWithoutReturn(PersonListActivity.class);
//					Intent i = new Intent(getApplicationContext(), PersonListActivity.class);
//					startActivity(i);
//					finish();
				}
				else{
					searchfield.setError("Selected contact exists in this profile!");
				}
			}
		}
	};
   
}