package hu.bme.mit.contactbook.activities;

import hu.bme.mit.contactbook.R;
import hu.bme.mit.contactbook.application.CBApplication;
import hu.bme.mit.contactbook.dbutility.DAOFactory;
import hu.bme.mit.contactbook.entities.EntityFactory;
import hu.bme.mit.contactbook.entities.Note;
import hu.bme.mit.contactbook.entities.Person;
import hu.bme.mit.contactbook.utility.Utility;

import java.sql.SQLException;
import java.util.Date;
import java.util.List;

import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;

import com.j256.ormlite.dao.Dao;

public class CreatePersonActivity extends CreatePersonActivityG {

	private EditText editPersonName;
	private Button OkBtn;
	private Button CancelBtn;
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_create_person);
        
        editPersonName = (EditText)this.findViewById(R.id.personName);

        OkBtn = (Button)findViewById(R.id.btnCreatePerson);
        CancelBtn = (Button)findViewById(R.id.btnCancelCreatePerson);
        
        CancelBtn.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				navigateBack();
			}
		});
        
        OkBtn.setOnClickListener(returnPerson);
    }
    
    OnClickListener returnPerson = new OnClickListener() {
		
		@Override
		public void onClick(View v) {
			String name = editPersonName.getText().toString();
			Dao<Person,Integer> dao = DAOFactory.getPersonDAO().getDAO();
			List<Person> pList = null;
			try {
				pList = dao.query(dao.queryBuilder().where().eq(Person.PERSONNAME_FIELD_NAME, name).prepare());
			} catch (SQLException e) {
				e.printStackTrace();
			}
			if(pList.size() > 0){
				editPersonName.setError("Person already exists!");
			}
			else{
				Person p = EntityFactory.createPerson(name, Utility.formatDate(new Date()));
				DAOFactory.getPersonDAO().createPerson(CBApplication.getCurrentProfile(), p);
				Note n = EntityFactory.createNote("");
				DAOFactory.getNoteDAO().createNote(p, n);
				navigateBack();
			}
		}
	};
}