package hu.bme.mit.contactbook.activities;

import hu.bme.mit.contactbook.R;
import hu.bme.mit.contactbook.dbutility.DAOFactory;
import hu.bme.mit.contactbook.dbutility.DataCache;
import hu.bme.mit.contactbook.entities.EntityFactory;
import hu.bme.mit.contactbook.entities.Profile;
import hu.bme.mit.contactbook.utility.Utility;

import java.sql.SQLException;
import java.util.Date;
import java.util.List;

import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;

import com.j256.ormlite.dao.Dao;

public class CreateProfileActivity extends CreateProfileActivityG {

	private EditText editProfileName;
	private Button OkBtn;
	private Button CancelBtn;
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_create_profile);
        
        editProfileName = (EditText)this.findViewById(R.id.profileName);

        OkBtn = (Button)findViewById(R.id.btnCreateProfile);
        CancelBtn = (Button)findViewById(R.id.btnCancelCreateProfile);
        
        CancelBtn.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				navigateBack();
			}
		});
        
        OkBtn.setOnClickListener(returnProfile);
    }
    
    OnClickListener returnProfile = new OnClickListener() {
		
		@Override
		public void onClick(View v) {
			String name = editProfileName.getText().toString();
			Dao<Profile,Integer> dao = DAOFactory.getProfileDAO().getDAO();
			List<Profile> pList = null;
			try {
				pList = dao.query(dao.queryBuilder().where().eq(Profile.PROFILENAME_FIELD_NAME, name).prepare());
			} catch (SQLException e) {
				e.printStackTrace();
			}
			if(pList.size() > 0){
				editProfileName.setError("Profile already exists!");
			}
			else{
				Profile p = EntityFactory.createProfile(name, Utility.formatDate(new Date()));
				DAOFactory.getProfileDAO().createProfile(p);
				DataCache.loadProfiles();
				navigateBack();
			}
		}
	};
}
