package hu.bme.mit.contactbook.activities;

import hu.bme.mit.contactbook.R;
import hu.bme.mit.contactbook.adapters.EmailAdapter;
import hu.bme.mit.contactbook.application.CBApplication;
import hu.bme.mit.contactbook.dbutility.DAOFactory;
import hu.bme.mit.contactbook.entities.Email;
import android.os.Bundle;
import android.view.ContextMenu;
import android.view.ContextMenu.ContextMenuInfo;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;

public class EmailActivity extends EmailActivityG {
	
	EmailAdapter emailAdapter;
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		emailAdapter = new EmailAdapter(getApplicationContext());
		setListAdapter(emailAdapter);

		registerForContextMenu(getListView());
	}
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.email_menu, menu);
		return true;
	}
	
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch(item.getItemId()){
		case R.id.item1:
			startAddEmailActivityG(AddEmail.class);
//			Intent i = new Intent(getApplicationContext(), AddEmail.class);
//    		startActivity(i);
			return true;
		default:
			return false;
		}
	}
	
	@Override
	protected void onResume() {
		super.onResume();
		((EmailAdapter) getListAdapter()).refreshList();
		((EmailAdapter) getListAdapter()).notifyDataSetChanged();
	}
	
	@Override
	public void onCreateContextMenu(ContextMenu menu, View v,
			ContextMenuInfo menuInfo) {
		if (v.equals(getListView())) {
			menu.setHeaderTitle("Email");
			String[] menuItems = getResources()
					.getStringArray(R.array.profile_menu_items);
			for (int i = 0; i < menuItems.length; i++) {
				menu.add(Menu.NONE, i, i, menuItems[i]);
			}
		}
	}

	@Override
	public boolean onContextItemSelected(MenuItem item) {
		AdapterView.AdapterContextMenuInfo info = (AdapterView.AdapterContextMenuInfo) item
				.getMenuInfo();
		int menuItemIndex = item.getItemId();
		 if (menuItemIndex == 0) {
			int pos = info.position;
			CBApplication.setCurrentEmail((Email)emailAdapter.getItem(pos));
			
			startEditEmailActivityG(EditEmail.class);
//			Intent i = new Intent(getApplicationContext(), EditEmail.class);
//			startActivity(i);
		}
		else if (menuItemIndex == 1) {
			int pos = info.position;
			Email e = (Email)emailAdapter.getItem(pos);
			DAOFactory.getEmailDAO().deleteEmail(e);
			((EmailAdapter) getListAdapter()).refreshList();
			((EmailAdapter) getListAdapter()).notifyDataSetChanged();
		}
		return true;
	}
	
}