package hu.bme.mit.contactbook.activities;

import hu.bme.mit.contactbook.R;
import hu.bme.mit.contactbook.dbutility.DAOFactory;
import hu.bme.mit.contactbook.entities.EntityFactory;
import hu.bme.mit.contactbook.entities.Person;
import hu.bme.mit.contactbook.entities.PhoneNumber;
import hu.bme.mit.contactbook.entities.Profile;
import hu.bme.mit.contactbook.utility.Utility;

import java.io.File;
import java.util.Date;

import android.content.Intent;
import android.database.Cursor;
import android.os.Bundle;
import android.os.Environment;
import android.provider.ContactsContract;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.Toast;

public class MainActivity extends MainActivityG {

	Button profilesButton, createProfileButton, ImportButton;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		setContentView(R.layout.activity_main);
		
        profilesButton = (Button) findViewById(R.id.profiles_button);
        createProfileButton = (Button) findViewById(R.id.create_profile_button);
        ImportButton = (Button) findViewById(R.id.importButton);
        
        profilesButton.setOnClickListener(ProfileMenuActivityClick);
        createProfileButton.setOnClickListener(CreateProfileActivityClick);
        ImportButton.setOnClickListener(ImportClick);
        
        File folder = new File(Environment.getExternalStorageDirectory() + "/ContactBook");
        if (!folder.exists()) {
            folder.mkdir();
        }
    }
    
	OnClickListener ProfileMenuActivityClick = new OnClickListener() {
    	public void onClick(View v) {
//    		Intent i = new Intent(getApplicationContext(), ProfileListActivity.class);
//    		startActivity(i);
    		startProfileListActivityG(ProfileListActivity.class);
    	}
    };
    
    OnClickListener CreateProfileActivityClick = new OnClickListener() {
    	public void onClick(View v) {
//    		Intent i = new Intent(getApplicationContext(), CreateProfileActivity.class);
//    		startActivity(i);
    		startCreateProfileActivityG(CreateProfileActivity.class);
    	}
    };
    
    OnClickListener ImportClick = new OnClickListener() {
    	public void onClick(View v) {
    		Profile p = EntityFactory.createProfile(Utility.formatDate(new Date()), "Import" + Utility.formatTime(new Date()));
    		DAOFactory.getProfileDAO().createProfile(p);
    		Cursor cursor = getContentResolver().query(ContactsContract.Contacts.CONTENT_URI,null,null, null,null);
    		while (cursor.moveToNext()) {
    			Person pers = EntityFactory.createPerson(Utility.formatDate(new Date()), cursor.getString(cursor.getColumnIndex(ContactsContract.Contacts.DISPLAY_NAME)));
    		    DAOFactory.getPersonDAO().createPerson(p, pers);
    			if (Integer.parseInt(cursor.getString(cursor.getColumnIndex(ContactsContract.Contacts.HAS_PHONE_NUMBER))) > 0) {                
    		        Cursor pCur = getContentResolver().query(
    		        ContactsContract.CommonDataKinds.Phone.CONTENT_URI, null,ContactsContract.CommonDataKinds.Phone.CONTACT_ID +" = "+cursor.getString(cursor.getColumnIndex(ContactsContract.Contacts._ID)),null, null);
    		        while (pCur.moveToNext()) {
    		            PhoneNumber pn = EntityFactory.createPhoneNumber(pCur.getString(pCur.getColumnIndex("DATA1")));
    		            DAOFactory.getPhoneNumberDAO().createPhoneNumber(pers, pn);
    		        } 
    		        pCur.close();
    		    }
    		}              
    		Toast.makeText(MainActivity.this, "Import successfull!", Toast.LENGTH_LONG).show();
    	}
    };

	 @Override
	 protected void onActivityResult(int requestCode, int resultCode, Intent data) {
	    super.onActivityResult(requestCode, resultCode, data);
	 }
	 
	 @Override
	 protected void onPause(){
		 super.onPause();
	 }
	 
	 @Override
	 protected void onDestroy() {
		super.onDestroy();
	 }
	 
}