package hu.bme.mit.contactbook.activities;

import hu.bme.mit.contactbook.R;
import hu.bme.mit.contactbook.application.CBApplication;

import java.io.File;

import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;

public class PersonActivity extends PersonActivityG {
	
	TextView t;
	Button phoneButton, emailButton, addressButton, noteButton, cameraButton;
	String filepath;
	
	private final int CAMERA_IMAGE_REQUEST = 1;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.person);
		phoneButton = (Button) findViewById(R.id.phonenumbers_button);
	    emailButton = (Button) findViewById(R.id.emails_button);
	    addressButton = (Button) findViewById(R.id.addresses_button);
	    noteButton = (Button) findViewById(R.id.notes_button);
	    cameraButton = (Button) findViewById(R.id.camera_button);
	    
	    phoneButton.setOnClickListener(PhoneActivityClick);
	    emailButton.setOnClickListener(EmailActivityClick);
	    addressButton.setOnClickListener(AddressActivityClick);
	    noteButton.setOnClickListener(NoteActivityClick);
	    cameraButton.setOnClickListener(CameraClick);
		
		t = (TextView)findViewById(R.id.personName);
		t.setText(CBApplication.getCurrentPerson().getPersonName());
		
	}
	
	OnClickListener PhoneActivityClick = new OnClickListener() {
		public void onClick(View v) {
			startPhoneActivityG(PhoneActivity.class);
//			Intent i = new Intent(getApplicationContext(), PhoneActivity.class);
//			startActivity(i);
		}
	};
	
	OnClickListener EmailActivityClick = new OnClickListener() {
		public void onClick(View v) {
			startEmailActivityG(EmailActivity.class);
//			Intent i = new Intent(getApplicationContext(), EmailActivity.class);
//			startActivity(i);
		}
	};
		
	OnClickListener AddressActivityClick = new OnClickListener() {
		public void onClick(View v) {
			startAddressActivityG(AddressActivity.class);
//			Intent i = new Intent(getApplicationContext(), AddressActivity.class);
//			startActivity(i);
		}
	};
		
	OnClickListener NoteActivityClick = new OnClickListener() {
		public void onClick(View v) {
			startNoteActivityG(NoteActivity.class);
//			Intent i = new Intent(getApplicationContext(), NoteActivity.class);
//			startActivity(i);
		}
	};
	
		OnClickListener CameraClick = new OnClickListener() {
			public void onClick(View v) {
				String name = CBApplication.getCurrentPerson().getPersonName();
				
				
				File folder = new File(Environment.getExternalStorageDirectory() + "/ContactBook/" + name);
				if (!folder.exists()) {
				    folder.mkdir();
				}
				
				filepath = Environment.getExternalStorageDirectory().getAbsolutePath() + "/ContactBook/" + name + "/photo.jpg";
				File imageFile = new File(filepath);
				Uri imageFileUri = Uri.fromFile(imageFile);
				Intent cameraIntent = new Intent(android.provider.MediaStore.ACTION_IMAGE_CAPTURE); 
				cameraIntent.putExtra(android.provider.MediaStore.EXTRA_OUTPUT, imageFileUri);
				startActivityForResult(cameraIntent, CAMERA_IMAGE_REQUEST);
			}
		};
}