package hu.bme.mit.contactbook.activities;

import hu.bme.mit.contactbook.R;
import hu.bme.mit.contactbook.adapters.PersonAdapter;
import hu.bme.mit.contactbook.application.CBApplication;
import hu.bme.mit.contactbook.dbutility.DAOFactory;
import hu.bme.mit.contactbook.entities.Person;
import hu.bme.mit.contactbook.entities.PhoneNumber;

import java.util.List;

import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.view.ContextMenu;
import android.view.ContextMenu.ContextMenuInfo;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ListView;

public class PersonListActivity extends PersonListActivityG {
	
	PersonAdapter personAdapter;
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		personAdapter = new PersonAdapter(getApplicationContext());
		setListAdapter(personAdapter);

		registerForContextMenu(getListView());
	}

	@Override
	public void onListItemClick(ListView l, View v, int position, long id){
		super.onListItemClick(l, v, position, id);
		CBApplication.setCurrentPerson((Person)personAdapter.getItem(position));
		
		startPersonActivityG(PersonActivity.class);
//		Intent i = new Intent(getApplicationContext(), PersonActivity.class);
//		startActivity(i);
	}
	
	
	@Override
	public void onCreateContextMenu(ContextMenu menu, View v,
			ContextMenuInfo menuInfo) {
		if (v.equals(getListView())) {
			AdapterView.AdapterContextMenuInfo info = (AdapterView.AdapterContextMenuInfo) menuInfo;
			menu.setHeaderTitle(((Person) getListAdapter().getItem(info.position))
					.getPersonName());
			String[] menuItems = getResources()
					.getStringArray(R.array.person_menu_items);
			for (int i = 0; i < menuItems.length; i++) {
				menu.add(Menu.NONE, i, i, menuItems[i]);
			}
		}
	}

	@Override
	public boolean onContextItemSelected(MenuItem item) {
		AdapterView.AdapterContextMenuInfo info = (AdapterView.AdapterContextMenuInfo) item
				.getMenuInfo();
		int menuItemIndex = item.getItemId();
		if (menuItemIndex == 0) {
			int pos = info.position;
			CBApplication.setCurrentPerson((Person)personAdapter.getItem(pos));
			
			startEditPersonActivityG(EditPersonActivity.class);
//			Intent i = new Intent(getApplicationContext(), EditPersonActivity.class);
//			startActivity(i);
		}
		else if (menuItemIndex == 1) {
			int pos = info.position;
			Person p = (Person)personAdapter.getItem(pos);
			DAOFactory.getPersonDAO().deletePerson(p);
			((PersonAdapter) getListAdapter()).refreshList();
			((PersonAdapter) getListAdapter()).notifyDataSetChanged();
		}
		else if (menuItemIndex == 2) {
			int pos = info.position;
			CBApplication.setCurrentPerson((Person)personAdapter.getItem(pos));
			
			startCopyPersonActivityG(CopyPerson.class);
//			Intent i = new Intent(getApplicationContext(), CopyPerson.class);
//			startActivity(i);
		}
		else if (menuItemIndex == 3) {
			int pos = info.position;
			CBApplication.setCurrentPerson((Person)personAdapter.getItem(pos));
			
			startMovePersonActivityG(MovePerson.class);
//			Intent i = new Intent(getApplicationContext(), MovePerson.class);
//			startActivity(i);
		}
		else if (menuItemIndex == 4) {
			int pos = info.position;
			CBApplication.setCurrentPerson((Person)personAdapter.getItem(pos));
			Intent i = new Intent();
			List<PhoneNumber> pn = DAOFactory.getPhoneNumberDAO().getPhoneNumbersByPersonContainment(CBApplication.getCurrentPerson());
			if(pn.size() > 0){
				String phonenumber = pn.get(0).getPhoneNumber();
				i.setData(Uri.parse("tel:" + phonenumber));
				i.setAction(Intent.ACTION_CALL);
				startActivity(i);
			}
		}
		
		return true;
	}
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.person_menu, menu);
		return true;
	}
	
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch(item.getItemId()){
		case R.id.item1:
			startCreatePersonActivityG(CreatePersonActivity.class);
//			Intent i = new Intent(getApplicationContext(), CreatePersonActivity.class);
//    		startActivity(i);
			return true;
		case R.id.item2:
			startSearchPersonActivityG(SearchPerson.class);
//			Intent i2 = new Intent(getApplicationContext(), SearchPerson.class);
//			startActivity(i2);
			return true;
		default:
			return false;
		}
	}
	
	@Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
    	super.onActivityResult(requestCode, resultCode, data);
    }
	
	@Override
	protected void onResume() {
		super.onResume();
		((PersonAdapter) getListAdapter()).refreshList();
		((PersonAdapter) getListAdapter()).notifyDataSetChanged();
	}
}