package hu.bme.mit.contactbook.activities;

import hu.bme.mit.contactbook.R;
import hu.bme.mit.contactbook.adapters.PhoneAdapter;
import hu.bme.mit.contactbook.application.CBApplication;
import hu.bme.mit.contactbook.dbutility.DAOFactory;
import hu.bme.mit.contactbook.entities.PhoneNumber;

import java.util.List;

import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.view.ContextMenu;
import android.view.ContextMenu.ContextMenuInfo;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ListView;

public class PhoneActivity extends PhoneActivityG {
	
	PhoneAdapter phoneAdapter;
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		phoneAdapter = new PhoneAdapter(getApplicationContext());
		setListAdapter(phoneAdapter);

		registerForContextMenu(getListView());
	}
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.phone_menu, menu);
		return true;
	}
	
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch(item.getItemId()){
		case R.id.item1:
			startAddPhoneActivityG(AddPhone.class);
//			Intent i = new Intent(getApplicationContext(), AddPhone.class);
//    		startActivity(i);
			return true;
		default:
			return false;
		}
	}
	
	@Override
	protected void onResume() {
		super.onResume();
		((PhoneAdapter) getListAdapter()).refreshList();
		((PhoneAdapter) getListAdapter()).notifyDataSetChanged();
	}
	
	@Override
	public void onCreateContextMenu(ContextMenu menu, View v,
			ContextMenuInfo menuInfo) {
		if (v.equals(getListView())) {
			menu.setHeaderTitle("Phone");
			String[] menuItems = getResources()
					.getStringArray(R.array.phone_menu_items);
			for (int i = 0; i < menuItems.length; i++) {
				menu.add(Menu.NONE, i, i, menuItems[i]);
			}
		}
	}

	@Override
	public boolean onContextItemSelected(MenuItem item) {
		AdapterView.AdapterContextMenuInfo info = (AdapterView.AdapterContextMenuInfo) item
				.getMenuInfo();
		int menuItemIndex = item.getItemId();
		if (menuItemIndex == 0) {
			int pos = info.position;
			CBApplication.setCurrentPhone((PhoneNumber)phoneAdapter.getItem(pos));
			Intent i = new Intent();
			List<PhoneNumber> pn = DAOFactory.getPhoneNumberDAO().getPhoneNumbersByPersonContainment(CBApplication.getCurrentPerson());
			String phonenumber = pn.get(0).getPhoneNumber();
			i.setData(Uri.parse("tel:" + phonenumber));
			i.setAction(Intent.ACTION_CALL);
			startActivity(i);
		}
		else if (menuItemIndex == 1) {
			int pos = info.position;
			CBApplication.setCurrentPhone((PhoneNumber)phoneAdapter.getItem(pos));
			
			startEditPhoneActivityG(EditPhone.class);
//			Intent i = new Intent(getApplicationContext(), EditPhone.class);
//			startActivity(i);
		}
		else if (menuItemIndex == 2) {
			int pos = info.position;
			PhoneNumber p = (PhoneNumber)phoneAdapter.getItem(pos);
			DAOFactory.getPhoneNumberDAO().deletePhoneNumber(p);
			((PhoneAdapter) getListAdapter()).refreshList();
			((PhoneAdapter) getListAdapter()).notifyDataSetChanged();
		}
		return true;
	}
	
	@Override
	public void onListItemClick(ListView l, View v, int position, long id){
		super.onListItemClick(l, v, position, id);
		Intent i = new Intent();
		List<PhoneNumber> pn = DAOFactory.getPhoneNumberDAO().getPhoneNumbersByPersonContainment(CBApplication.getCurrentPerson());
		String phonenumber = pn.get(0).getPhoneNumber();
		i.setData(Uri.parse("tel:" + phonenumber));
		i.setAction(Intent.ACTION_CALL);
		startActivity(i);
	}
	
}