package hu.bme.mit.contactbook.activities;

import hu.bme.mit.contactbook.R;
import hu.bme.mit.contactbook.adapters.ProfileAdapter;
import hu.bme.mit.contactbook.application.CBApplication;
import hu.bme.mit.contactbook.dbutility.DAOFactory;
import hu.bme.mit.contactbook.entities.Profile;
import android.content.Intent;
import android.os.Bundle;
import android.view.ContextMenu;
import android.view.ContextMenu.ContextMenuInfo;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ListView;

public class ProfileListActivity extends ProfileListActivityG {
	
	ProfileAdapter profileAdapter;
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		profileAdapter = new ProfileAdapter(getApplicationContext());
		setListAdapter(profileAdapter);

		registerForContextMenu(getListView());
	}

	@Override
	public void onListItemClick(ListView l, View v, int position, long id){
		super.onListItemClick(l, v, position, id);
		
		CBApplication.setCurrentProfile((Profile)profileAdapter.getItem(position));
		
		startPersonListActivityG(PersonListActivity.class);
//		Intent i = new Intent(getApplicationContext(), PersonListActivity.class);
//		startActivity(i);
	}
	
	@Override
	public void onCreateContextMenu(ContextMenu menu, View v,
			ContextMenuInfo menuInfo) {
		if (v.equals(getListView())) {
			AdapterView.AdapterContextMenuInfo info = (AdapterView.AdapterContextMenuInfo) menuInfo;
			menu.setHeaderTitle(((Profile) getListAdapter().getItem(info.position))
					.getProfileName());
			String[] menuItems = getResources()
					.getStringArray(R.array.profile_menu_items);
			for (int i = 0; i < menuItems.length; i++) {
				menu.add(Menu.NONE, i, i, menuItems[i]);
			}
		}
	}

	@Override
	public boolean onContextItemSelected(MenuItem item) {
		AdapterView.AdapterContextMenuInfo info = (AdapterView.AdapterContextMenuInfo) item
				.getMenuInfo();
		int menuItemIndex = item.getItemId();
		if (menuItemIndex == 0) {
			int pos = info.position;
			
			CBApplication.setCurrentProfile((Profile)profileAdapter.getItem(pos));
			
			startEditProfileActivityG(EditProfileActivity.class);
//			Intent i = new Intent(getApplicationContext(), EditProfileActivity.class);
//			startActivity(i);
		}
		else if (menuItemIndex == 1) {
			int pos = info.position;
			Profile p = (Profile)profileAdapter.getItem(pos);
			DAOFactory.getProfileDAO().deleteProfile(p);
			((ProfileAdapter) getListAdapter()).refreshList();
			((ProfileAdapter) getListAdapter()).notifyDataSetChanged();
		}
		return true;
	}
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.profile_menu, menu);
		return true;
	}
	
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch(item.getItemId()){
		case R.id.item1:
			startCreateProfileActivityG(CreateProfileActivity.class);
//			Intent i = new Intent(getApplicationContext(), CreateProfileActivity.class);
//			startActivity(i);
			return true;
		case R.id.item2:
			startSearchProfileActivityG(SearchProfile.class);
//			Intent i2 = new Intent(getApplicationContext(), SearchProfile.class);
//			startActivity(i2);
		default:
			return false;
		}
	}
	
	@Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
    	super.onActivityResult(requestCode, resultCode, data);
    }
	
	@Override
	protected void onResume() {
		super.onResume();
		((ProfileAdapter) getListAdapter()).refreshList();
		((ProfileAdapter) getListAdapter()).notifyDataSetChanged();
	}
}