package hu.bme.mit.contactbook.activities;

import hu.bme.mit.contactbook.R;
import hu.bme.mit.contactbook.application.CBApplication;
import hu.bme.mit.contactbook.dbutility.DAOFactory;
import hu.bme.mit.contactbook.entities.Person;

import java.util.ArrayList;
import java.util.List;

import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.AutoCompleteTextView;
import android.widget.Button;

public class SearchPerson extends SearchPersonActivityG {
	
	private Button EnterBtn;
	private Button CancelBtn;
	private AutoCompleteTextView searchfield;
	
	List<Person> persons;
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.search_person);
        
        searchfield = (AutoCompleteTextView)findViewById(R.id.personName);
        
        persons = DAOFactory.getPersonDAO().getPersonsByProfileContainment(CBApplication.getCurrentProfile());
        List<String> list = new ArrayList<String>();
        for(Person p : persons){
        	list.add(p.getPersonName());
        }
        String[] stringlist = list.toArray(new String[list.size()]);
        ArrayAdapter<String> searchAdapter =
        		new ArrayAdapter<String>(this,
        		R.layout.search,R.id.item, stringlist);
        		searchfield.setAdapter(searchAdapter);
        
        EnterBtn = (Button)findViewById(R.id.btnEnterPerson);
        CancelBtn = (Button)findViewById(R.id.btnCancelSearchPerson);
        
        CancelBtn.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				navigateBack();
			}
		});
        
        EnterBtn.setOnClickListener(enterPerson);
    }
    
    OnClickListener enterPerson = new OnClickListener() {
		
		@Override
		public void onClick(View v) {
			String s = searchfield.getText().toString();
			List<Person> pList = new ArrayList<Person>();
			for(Person p : persons){
				if(p.getPersonName().equals(s)){
					pList.add(p);
				}
			}
			if(pList.size() == 0 || pList.size() > 1){
				searchfield.setError("No such person!");
			}
			else{
				CBApplication.setCurrentPerson(pList.get(0));
				
				startPersonActivityGWithoutReturn(PersonActivity.class);
//				Intent i = new Intent(getApplicationContext(), PersonActivity.class);
//				startActivity(i);
//				finish();
			}
		}
	};
	
}