package hu.bme.mit.contactbook.activities;

import hu.bme.mit.contactbook.R;
import hu.bme.mit.contactbook.application.CBApplication;
import hu.bme.mit.contactbook.dbutility.DAOFactory;
import hu.bme.mit.contactbook.dbutility.DataCache;
import hu.bme.mit.contactbook.entities.Profile;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.AutoCompleteTextView;
import android.widget.Button;

import com.j256.ormlite.dao.Dao;

public class SearchProfile extends SearchProfileActivityG {

	private Button EnterBtn;
	private Button CancelBtn;
	private AutoCompleteTextView searchfield;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.search_profile);
        
        searchfield = (AutoCompleteTextView)findViewById(R.id.profileName);
        
        List<Profile> profs = DataCache.getProfiles();
        List<String> list = new ArrayList<String>();
        for(Profile p : profs){
        	list.add(p.getProfileName());
        }
        String[] stringlist = list.toArray(new String[list.size()]);
        ArrayAdapter<String> searchAdapter =
        		new ArrayAdapter<String>(this,
        		R.layout.search,R.id.item, stringlist);
        		searchfield.setAdapter(searchAdapter);
        EnterBtn = (Button)findViewById(R.id.btnEnterProfile);
        CancelBtn = (Button)findViewById(R.id.btnCancelSearchProfile);
        
        CancelBtn.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				navigateBack();
			}
		});
        
        EnterBtn.setOnClickListener(enterProfile);
    }
    
    OnClickListener enterProfile = new OnClickListener() {
		
		@Override
		public void onClick(View v) {
			String s = searchfield.getText().toString();
			Dao<Profile,Integer> dao = DAOFactory.getProfileDAO().getDAO();
			List<Profile> pList = null;
			try {
				pList = dao.query(dao.queryBuilder().where().eq(Profile.PROFILENAME_FIELD_NAME, s).prepare());
			} catch (SQLException e) {
				e.printStackTrace();
			}
			if(pList.size() == 0 || pList.size() > 1){
				searchfield.setError("No such profile!");
			}
			else{
				CBApplication.setCurrentProfile(pList.get(0));
				
				startPersonListActivityGWithoutReturn(PersonListActivity.class);
//				Intent i = new Intent(getApplicationContext(), PersonListActivity.class);
//				startActivity(i);
//				finish();
			}
		}
	};
	
}