package hu.bme.mit.contactbook.adapters;

import hu.bme.mit.contactbook.R;
import hu.bme.mit.contactbook.application.CBApplication;
import hu.bme.mit.contactbook.comparators.PersonComparator;
import hu.bme.mit.contactbook.dbutility.DAOFactory;
import hu.bme.mit.contactbook.entities.Person;
import hu.bme.mit.contactbook.entities.PhoneNumber;
import hu.bme.mit.contactbook.entities.Profile;

import java.util.Collections;
import java.util.List;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;





public class PersonAdapter extends BaseAdapter{
	private List<Person> contacts;
	private Profile p;

    public PersonAdapter(final Context context) {
    	contacts = DAOFactory.getPersonDAO().getPersonsByProfileContainment(CBApplication.getCurrentProfile());
    	Collections.sort(contacts, new PersonComparator());
    	p = CBApplication.getCurrentProfile();
    }

    public int getCount() {
        return contacts.size();
    }

    public Object getItem(int position) {
        return contacts.get(position);
    }

    public long getItemId(int position) {
        return position;
    }
    
    
    public View getView(int position, View convertView, ViewGroup parent) {

        final Person pers = contacts.get(position);
        
        List<PhoneNumber> pn = DAOFactory.getPhoneNumberDAO().getPhoneNumbersByPersonContainment(pers);

        LayoutInflater inflater = (LayoutInflater) parent.getContext().getSystemService(
    		Context.LAYOUT_INFLATER_SERVICE);
        View itemView = inflater.inflate(R.layout.personrow, null);

        ImageView imageViewIcon = (ImageView) itemView.findViewById(R.id.imageProfile);
        imageViewIcon.setImageResource(R.drawable.profile);
        
        TextView textViewTitle = (TextView) itemView.findViewById(R.id.textViewPersonName);
        textViewTitle.setText(pers.getPersonName());
        
        TextView textViewPhone = (TextView) itemView.findViewById(R.id.textViewPhoneNumber);
        if(pn.isEmpty()){
        	textViewPhone.setText("-");
        }
        else{
        	textViewPhone.setText(pn.get(0).getPhoneNumber());
        }
        
        TextView textViewDate = (TextView) itemView.findViewById(R.id.textViewDate);
        textViewDate.setText(pers.getCreationDate());
        
        return itemView;
    }
    
    public void refreshList() {
    	contacts = DAOFactory.getPersonDAO().getPersonsByProfileContainment(p);
    	Collections.sort(contacts, new PersonComparator());
    }
    
}
