package hu.bme.mit.contactbook.adapters;

import hu.bme.mit.contactbook.R;
import hu.bme.mit.contactbook.application.CBApplication;
import hu.bme.mit.contactbook.dbutility.DAOFactory;
import hu.bme.mit.contactbook.entities.Person;
import hu.bme.mit.contactbook.entities.PhoneNumber;

import java.util.List;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;



public class PhoneAdapter extends BaseAdapter{
	private List<PhoneNumber> numbers;
	
    public PhoneAdapter(final Context context) {
    	Person p = CBApplication.getCurrentPerson();
    	numbers = DAOFactory.getPhoneNumberDAO().getPhoneNumbersByPersonContainment(p);
    }

    public int getCount() {
        return numbers.size();
    }

    public Object getItem(int position) {
        return numbers.get(position);
    }

    public long getItemId(int position) {
        return position;
    }
    
    
    public View getView(int position, View convertView, ViewGroup parent) {

        final PhoneNumber number = numbers.get(position);

        LayoutInflater inflater = (LayoutInflater) parent.getContext().getSystemService(
    		Context.LAYOUT_INFLATER_SERVICE);
        View itemView = inflater.inflate(R.layout.data, null);

        ImageView imageViewIcon = (ImageView) itemView.findViewById(R.id.imageProfile);
        imageViewIcon.setImageResource(R.drawable.profile);
        
        TextView textViewTitle = (TextView) itemView.findViewById(R.id.textViewPersonName);
        textViewTitle.setText(CBApplication.getCurrentPerson().getPersonName());
        
        TextView textViewPhone = (TextView) itemView.findViewById(R.id.textViewPhoneNumber);
        textViewPhone.setText(number.getPhoneNumber());
        
        return itemView;
    }
    
    public void refreshList() {
    	Person p = CBApplication.getCurrentPerson();
    	numbers = DAOFactory.getPhoneNumberDAO().getPhoneNumbersByPersonContainment(p);
    }
    
}
