package hu.bme.mit.contactbook.adapters;

import hu.bme.mit.contactbook.R;
import hu.bme.mit.contactbook.comparators.ProfileComparator;
import hu.bme.mit.contactbook.dbutility.DAOFactory;
import hu.bme.mit.contactbook.entities.Profile;

import java.util.Collections;
import java.util.List;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;




public class ProfileAdapter extends BaseAdapter{
	private List<Profile> profiles;

    public ProfileAdapter(final Context context) {
    	profiles = DAOFactory.getProfileDAO().getProfiles();
    	Collections.sort(profiles, new ProfileComparator());
    }

    public int getCount() {
        return profiles.size();
    }

    public Object getItem(int position) {
        return profiles.get(position);
    }

    public long getItemId(int position) {
        return position;
    }
    
    
    public View getView(int position, View convertView, ViewGroup parent) {

        final Profile prof = profiles.get(position);

        LayoutInflater inflater = (LayoutInflater) parent.getContext().getSystemService(
    		Context.LAYOUT_INFLATER_SERVICE);
        View itemView = inflater.inflate(R.layout.profilerow, null);

        ImageView imageViewIcon = (ImageView) itemView.findViewById(R.id.imageProfile);
        imageViewIcon.setImageResource(R.drawable.profile);
        
        TextView textViewTitle = (TextView) itemView.findViewById(R.id.textViewProfileName);
        textViewTitle.setText(prof.getProfileName());
        
        TextView textViewDate = (TextView) itemView.findViewById(R.id.textViewDate);
        textViewDate.setText(prof.getCreationDate());
        
        return itemView;
    }
    
    public void refreshList() {
        profiles = DAOFactory.getProfileDAO().getProfiles();
       Collections.sort(profiles, new ProfileComparator());
    }
    
}
