package hu.bme.mit.contactbook.application;

import hu.bme.mit.contactbook.dbutility.DAOFactory;
import hu.bme.mit.contactbook.dbutility.DataCache;
import hu.bme.mit.contactbook.entities.Address;
import hu.bme.mit.contactbook.entities.Email;
import hu.bme.mit.contactbook.entities.Note;
import hu.bme.mit.contactbook.entities.Person;
import hu.bme.mit.contactbook.entities.PhoneNumber;
import hu.bme.mit.contactbook.entities.Profile;

public class CBApplication extends ContactBookApplication {
	
	private static Profile currentProfile = null;
	private static Person currentPerson = null;
	private static Address currentAddress = null;
	private static Email currentEmail = null;
	private static PhoneNumber currentPhone = null;
	private static Note currentNote = null;

	public static Profile getCurrentProfile() {
		return currentProfile;
	}

	public static void setCurrentProfile(Profile currentProfile) {
		CBApplication.currentProfile = currentProfile;
	}

	public static Person getCurrentPerson() {
		return currentPerson;
	}

	public static void setCurrentPerson(Person currentPerson) {
		CBApplication.currentPerson = currentPerson;
	}

	public static Address getCurrentAddress() {
		return currentAddress;
	}

	public static void setCurrentAddress(Address currentAddress) {
		CBApplication.currentAddress = currentAddress;
	}

	public static Email getCurrentEmail() {
		return currentEmail;
	}

	public static void setCurrentEmail(Email currentEmail) {
		CBApplication.currentEmail = currentEmail;
	}

	public static PhoneNumber getCurrentPhone() {
		return currentPhone;
	}

	public static void setCurrentPhone(PhoneNumber currentPhone) {
		CBApplication.currentPhone = currentPhone;
	}

	public static Note getCurrentNote() {
		return currentNote;
	}

	public static void setCurrentNote(Note currentNote) {
		CBApplication.currentNote = currentNote;
	}

	@Override
	public void onCreate() {
		super.onCreate();
		DAOFactory.initDatabase(getApplicationContext());
		DataCache.initCache();
	}

	@Override
	public void onTerminate() {
		DAOFactory.closeDatabase();
		super.onTerminate();
	}
	
}
