package hu.bme.mit.contactbook.entities;

import hu.bme.mit.contactbook.application.CBApplication;
import hu.bme.mit.contactbook.dbutility.DAOFactory;
import hu.bme.mit.contactbook.utility.Utility;

import java.util.Date;
import java.util.List;



public class MyPerson extends Person{
	
	public MyPerson(){
		
	}
	
	public MyPerson(Person p){
		personName = p.getPersonName();
		creationDate = Utility.formatDate(new Date());
		DAOFactory.getPersonDAO().createPerson(CBApplication.getCurrentProfile(), this);
		
		List<PhoneNumber> pList = DAOFactory.getPhoneNumberDAO().getPhoneNumbersByPersonContainment(p);
		List<Email> eList =  DAOFactory.getEmailDAO().getEmailsByPersonContainment(p);
		List<Address> aList =  DAOFactory.getAddressDAO().getAddresssByPersonContainment(p);
		Note n =  DAOFactory.getNoteDAO().getNoteByPersonContainment(p);
		
		for(PhoneNumber pn : pList){
			PhoneNumber num =EntityFactory.createPhoneNumber(pn.getPhoneNumber());
			DAOFactory.getPhoneNumberDAO().createPhoneNumber(this, num);
		}
		
		for(Email e : eList){
			Email em = EntityFactory.createEmail(e.getEmail());
			DAOFactory.getEmailDAO().createEmail(this, em);
		}
		
		for(Address ad : aList){
			Address a = EntityFactory.createAddress(ad.getAddress());
			DAOFactory.getAddressDAO().createAddress(this, a);
		}
		if(n != null){
			Note no = EntityFactory.createNote(n.getNote());
			DAOFactory.getNoteDAO().createNote(this, no);
		}
	}
	
}