//------------------------- Geneated Java Class File For Async Task - http ---------------------------------

package hu.bme.aut.mercury.mercuryclientandroid.network;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.HttpStatus;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;

import android.content.Context;
import android.content.Intent;
import android.os.AsyncTask;
import android.support.v4.content.LocalBroadcastManager;

import hu.bme.aut.mercury.mercuryclientandroid.application.MercuryClientAndroidApplication;

public class HttpAsyncTask extends AsyncTask<String, Void, String> {
	
	private Context context = null;
	
	public HttpAsyncTask(Context context) {
		this.context = context;
	}
	
	@Override
	protected void onPreExecute() {
		super.onPreExecute();
	}
	
	@Override
	protected String doInBackground(String... params) {
		if(params.length > 0){
			
			HttpClient httpclient = new DefaultHttpClient();
			HttpGet httpget = new HttpGet(params[0]);
			HttpResponse response = null;
	
			String result = "";
			InputStream is = null;
			
			try {
				response = httpclient.execute(httpget);
	
				System.out.println(response.getStatusLine().getStatusCode());
				if (response.getStatusLine().getStatusCode() == HttpStatus.SC_OK) {
					HttpEntity entity = response.getEntity();
					if (entity != null) {
						is = entity.getContent();
	
						BufferedReader reader = new BufferedReader(new InputStreamReader(is));
						StringBuilder sb = new StringBuilder();
						String line = null;
	
						while ((line = reader.readLine()) != null) {
							sb.append(line + "\n");
						}
						
						System.out.println(sb.toString());
						result = sb.toString();
					}
				}
	
			} catch (Exception e) {
				e.printStackTrace();
				result = e.getMessage();
			} finally {
				if (is != null) {
					try {
						is.close();
					} catch (Exception e) {
						e.printStackTrace();
					}
				}
			}
			return result;
		}
		
		return "";
	}
	
	@Override
	protected void onPostExecute(String result) {
		super.onPostExecute(result);
		System.out.println(result);
		Intent respIntent = new Intent(MercuryClientAndroidApplication.INTENT_FILTER);
	
		respIntent.putExtra(MercuryClientAndroidApplication.HTTP, result);
		LocalBroadcastManager.getInstance(context).sendBroadcast(respIntent);
	}
}
