package hu.bme.aut.mercury.mercuryclientandroid.activities;

import hu.bme.aut.mercury.mercuryclientandroid.R;
import hu.bme.aut.mercury.mercuryclientandroid.entities.Student;
import hu.bme.aut.mercury.mercuryclientandroid.network.GsonParser;
import hu.bme.aut.mercury.mercuryclientandroid.network.ServerURIs;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

public class LoginActivity extends LoginActivityG {
	
    private EditText inputUsername = null;
    private EditText inputPassword = null;
    private TextView responseMessage = null;
    private Button btnLogin = null;
    
    @Override
    protected void resultHTTP(String result){
    	student = GsonParser.getParser().fromJson(result, Student.class);
    	
    	if(student == null){
    		responseMessage.setText("Authentikcis hiba!");
    	}
    	else{
    		responseMessage.setText("Bejelentkezve!");
    		startMainMenuActivityG(MainMenuActivity.class);
    	}
    	
    }

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		setContentView(R.layout.login_activity);
		
		inputUsername = (EditText) findViewById(R.id.usernameText);
        inputPassword = (EditText) findViewById(R.id.passwordText);
        btnLogin = (Button) findViewById(R.id.btnLogin);
        responseMessage = (TextView) findViewById(R.id.responseText);
        
        btnLogin.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				if(!"".equals(inputUsername.getText().toString()) && !"".equals(inputPassword.getText().toString())){
					startHttpAsyncTask(ServerURIs.AUTHENTICATE + inputUsername.getText().toString() + "/" + inputPassword.getText().toString());
				}
				else{
					responseMessage.setText("Felhasznlnv s jelsz megadsa ktelez!");
				}
			}
			
		});
		
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.login, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		int id = item.getItemId();
		
		if (id == R.id.action_settings) {
			return true;
		}
		
		return super.onOptionsItemSelected(item);
	}
	
	@Override
	public void onResume() {
		super.onResume();
	}

	@Override
	public void onPause() {
		super.onPause();
	}

}
