package hu.bme.mit.mobilegen.componentmodel.ui.handler;

import hu.bme.mit.mobilegen.componentmodel.ui.builder.ComponentmodelBuilder;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.IHandler;
import org.eclipse.core.resources.IFile;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.handlers.HandlerUtil;

import com.google.inject.Inject;

/**
 * 
 * Componentmodel Generator From XMI Resource Handler
 * 
 */
public class ComponentmodelGeneratorFromXMIHandler extends AbstractHandler implements IHandler {

	@Inject
	private ComponentmodelBuilder builder;

	/**
	 * 
	 * Handler
	 * @param: Event
	 * 
	 */
	@Override
	public Object execute(ExecutionEvent event) throws ExecutionException {

		ISelection selection = HandlerUtil.getCurrentSelection(event);

		if (selection instanceof IStructuredSelection) {

			IStructuredSelection structuredSelection = (IStructuredSelection) selection;
			Object firstElement = structuredSelection.getFirstElement();

			if (firstElement instanceof IFile) {
				IFile file = (IFile) firstElement;
				builder.generateComponentmodelFromXMI(file);
			}
		}

		return null;
	}
	
	@Override
	public boolean isEnabled() {
		return true;
	}

}
