/*
 * generated by Xtext
 */
package hu.bme.mit.mobilegen.componentmodel.formatting

import com.google.inject.Inject
import hu.bme.mit.mobilegen.componentmodel.services.ComponentmodelGrammarAccess
import org.eclipse.xtext.formatting.impl.AbstractDeclarativeFormatter
import org.eclipse.xtext.formatting.impl.FormattingConfig

// import com.google.inject.Inject;
// import hu.bme.mit.mobilegen.componentmodel.services.ComponentmodelGrammarAccess

/**
 * This class contains custom formatting description.
 * 
 * see : http://www.eclipse.org/Xtext/documentation.html#formatting
 * on how and when to use it 
 * 
 * Also see {@link org.eclipse.xtext.xtext.XtextFormattingTokenSerializer} as an example
 */
class ComponentmodelFormatter extends AbstractDeclarativeFormatter {

	@Inject extension ComponentmodelGrammarAccess
	
	override protected void configureFormatting(FormattingConfig c) {
		
		c.setLinewrap(0, 1, 2).before(SL_COMMENTRule)
		c.setLinewrap(0, 1, 2).before(ML_COMMENTRule)
		c.setLinewrap(0, 1, 1).after(ML_COMMENTRule)

		val con = contentAccess;
		
		c.setLinewrap(2).after(con.nameAssignment_1);
		c.setLinewrap(1).after(con.importsAssignment_2);
		c.setLinewrap(2).before(con.elementAssignment_3);
		
		val act = activityAccess
		
		c.setLinewrap(2).after(act.activitiesAssignment_5_3_3);
		c.setLinewrap(2).after(act.leftCurlyBracketKeyword_2);
		c.setLinewrap(2).after(act.leftCurlyBracketKeyword_2);
		c.setIndentationIncrement.after(act.leftCurlyBracketKeyword_2);
		
		c.setLinewrap(2).after(act.typeAssignment_4);
		
		c.setLinewrap(1).after(act.leftCurlyBracketKeyword_5_0_1);
		c.setIndentationIncrement.after(act.leftCurlyBracketKeyword_5_0_1);
		c.setLinewrap(1).before(act.rightCurlyBracketKeyword_5_0_4);
		c.setIndentationDecrement.before(act.rightCurlyBracketKeyword_5_0_4);
		c.setLinewrap(2).after(act.rightCurlyBracketKeyword_5_0_4);
		
		c.setLinewrap(1).after(act.leftCurlyBracketKeyword_5_1_1);
		c.setIndentationIncrement.after(act.leftCurlyBracketKeyword_5_1_1);
		c.setLinewrap(1).before(act.rightCurlyBracketKeyword_5_1_4);
		c.setIndentationDecrement.before(act.rightCurlyBracketKeyword_5_1_4);
		c.setLinewrap(2).after(act.rightCurlyBracketKeyword_5_1_4);
		
		c.setLinewrap(1).after(act.leftCurlyBracketKeyword_5_2_3);
		c.setIndentationIncrement.after(act.leftCurlyBracketKeyword_5_2_3);
		c.setLinewrap(1).after(act.fragmentsFragmentCrossReference_5_2_4_0);
		c.setLinewrap(1).before(act.rightCurlyBracketKeyword_5_2_6);
		c.setIndentationDecrement.before(act.rightCurlyBracketKeyword_5_2_6);
		c.setLinewrap(2).after(act.rightCurlyBracketKeyword_5_2_6);
		
		c.setLinewrap(1).after(act.leftCurlyBracketKeyword_5_3_1);
		c.setIndentationIncrement.after(act.leftCurlyBracketKeyword_5_3_1);
		
		val sact = startActivityAccess
		
		c.setLinewrap(1).after(sact.noReturnAssignment_0_0);
		c.setLinewrap(1).before(sact.sendPropertyKeyword_0_2_0);
		c.setLinewrap(1).before(sact.sendEntityKeyword_0_1_0);
		c.setLinewrap(1).before(sact.showFragmentKeyword_0_3_0);
		c.setLinewrap(1).before(sact.activityActivityCrossReference_1_0);
		
		c.setLinewrap(2).before(act.activitiesStartActivityParserRuleCall_5_3_2_0);
		c.setLinewrap(2).after(act.activitiesStartActivityParserRuleCall_5_3_2_0);
		c.setLinewrap(1).before(act.rightCurlyBracketKeyword_5_3_4);
		c.setIndentationDecrement.before(act.rightCurlyBracketKeyword_5_3_4);
		c.setLinewrap(2).after(act.rightCurlyBracketKeyword_5_3_4);
		
		c.setLinewrap(1).after(act.leftCurlyBracketKeyword_5_4_1);
		c.setIndentationIncrement.after(act.leftCurlyBracketKeyword_5_4_1);
		c.setLinewrap(1).after(act.async_tasksAsyncTaskCrossReference_5_4_2_0);
		c.setLinewrap(1).before(act.rightCurlyBracketKeyword_5_4_4);
		c.setIndentationDecrement.before(act.rightCurlyBracketKeyword_5_4_4);
		c.setLinewrap(2).after(act.rightCurlyBracketKeyword_5_4_4);
		
		c.setLinewrap(1).after(act.leftCurlyBracketKeyword_5_5_1);
		c.setIndentationIncrement.after(act.leftCurlyBracketKeyword_5_5_1);
		c.setLinewrap(1).after(act.result_async_tasksAsyncTaskCrossReference_5_5_2_0);
		c.setLinewrap(1).before(act.rightCurlyBracketKeyword_5_5_4);
		c.setIndentationDecrement.before(act.rightCurlyBracketKeyword_5_5_4);
		c.setLinewrap(2).after(act.rightCurlyBracketKeyword_5_5_4);
		
		c.setIndentationDecrement.before(act.rightCurlyBracketKeyword_6);
		
		val frag = fragmentAccess;
		
		c.setLinewrap(1).after(frag.leftCurlyBracketKeyword_2);
		c.setIndentationIncrement.after(frag.leftCurlyBracketKeyword_2);
		c.setIndentationDecrement.before(frag.rightCurlyBracketKeyword_5);
		c.setLinewrap(1).before(frag.rightCurlyBracketKeyword_5);
		
	}
}
