package hu.bme.mit.mobilegen.componentmodel.generator

import com.google.inject.Inject
import hu.bme.mit.mobilegen.componentmodel.generator.activity.ActivitiesGenerator
import hu.bme.mit.mobilegen.componentmodel.generator.application.ApplicationUnitGenerator
import hu.bme.mit.mobilegen.componentmodel.generator.asynctask.AsyncTasksGenerator
import hu.bme.mit.mobilegen.componentmodel.generator.fragment.FragmentsGenerator
import hu.bme.mit.mobilegen.componentmodel.helper.WrappedModel
import org.eclipse.xtext.generator.IFileSystemAccess

class ComponentmodelGeneratorMain implements IComponentmodelGenerator {
	
	@Inject
	ApplicationUnitGenerator applicationUnitGenerator;
	
	@Inject
	ActivitiesGenerator activitiesGenerator;
	
	@Inject
	FragmentsGenerator fragmentsGenerator;
	
	@Inject
	AsyncTasksGenerator asyncTasksGenerator;
	
	override generate(WrappedModel wm, IFileSystemAccess fsa) {
		applicationUnitGenerator.generateApplicationUnit(wm, fsa);
		
		activitiesGenerator.generateActivities(wm, fsa);
		
		fragmentsGenerator.generateFragments(wm, fsa);
		
		asyncTasksGenerator.generateAsyncTasks(wm, fsa);
	}
	
}