package hu.bme.mit.mobilegen.componentmodel.generator.application

import com.google.inject.Inject
import hu.bme.mit.mobilegen.componentmodel.componentmodel.Activity
import hu.bme.mit.mobilegen.componentmodel.componentmodel.Association
import hu.bme.mit.mobilegen.componentmodel.componentmodel.AsyncTask
import hu.bme.mit.mobilegen.componentmodel.componentmodel.Fragment
import hu.bme.mit.mobilegen.componentmodel.componentmodel.Property
import hu.bme.mit.mobilegen.componentmodel.componentmodel.StartActivity
import hu.bme.mit.mobilegen.componentmodel.helper.WrappedModel
import java.util.HashSet
import java.util.Set
import org.eclipse.xtext.generator.IFileSystemAccess

class ApplicationUnitGenerator {
	
	@Inject
	ApplicationGenerator applicationGenerator;
	
	Set<String> constants;
	
	def generateApplicationUnit(WrappedModel wm, IFileSystemAccess fsa){
		
		constants = new HashSet<String>();
		
		for(AsyncTask a : wm.asyncTasks){
			constants.add(a.name);
		}
		
		for(Fragment f: wm.fragments){
			constants.add(f.name);
		}
		
		for(Activity a : wm.activities){
			for(StartActivity startAct : a.activities){
				for(Association assoc : startAct.sendAssoc){
					constants.add(a.name + "_" + assoc.name);
				}
				for(Property p : startAct.sendProp){
					constants.add(a.name + "_" + p.name);
				}
			}
		}
		
		applicationGenerator.generateApplication(wm.fragments, constants, fsa);
		
	}
	
}
