package hu.bme.mit.mobilegen.componentmodel.generator.fragment

import hu.bme.mit.mobilegen.componentmodel.componentmodel.Fragment
import hu.bme.mit.mobilegen.componentmodel.componentmodel.FragmentType
import hu.bme.mit.mobilegen.componentmodel.generator.GeneratorConstants
import hu.bme.mit.mobilegen.componentmodel.generator.GeneratorData
import hu.bme.mit.mobilegen.componentmodel.logger.Log
import org.eclipse.xtext.generator.IFileSystemAccess

class FragmentGenerator {
	
	def generateFragmentUnit(Fragment f, IFileSystemAccess fsa){
		Log.info("Generating " + f.name.toFirstUpper + ".java");
		fsa.generateFile(f.name.toFirstUpper + ".java", GeneratorConstants.SRC_GEN_FRAG, generateFragment(f));
	}
	
	def private generateFragment(Fragment f) '''
		«f.classHeader»
		
		«packageDeclaration»
		
		«f.classImports»
		
		«f.classDeclaration»
	'''
	
	def private classHeader(Fragment f) '''
		//------------------------- Geneated Java Class File For Fragment - «f.name» ---------------------------------
	'''
	
	def private packageDeclaration() '''
		package «GeneratorData.packageName».«GeneratorConstants.SRC_GEN_FRAG»;
	'''
	
	def private classImports(Fragment f) '''
		«IF f.type.equals(FragmentType.LIST_FRAGMENT)»
			import android.support.v4.app.ListFragment;
		«ELSE»
			import android.support.v4.app.Fragment;
		«ENDIF»
		
		import android.os.Bundle;
		import android.app.Activity;
		import android.view.LayoutInflater;
		import android.view.View;
		import android.view.ViewGroup;
	'''
	
	def private classDeclaration(Fragment f) '''
		public class «f.name.toFirstUpper» extends «IF f.type.equals(FragmentType.LIST_FRAGMENT)»List«ENDIF»Fragment {
			
			«f.overrideMethods»
		}
	'''
	
	def private overrideMethods(Fragment f) '''
		@Override
		public void onAttach(Activity activity) {
			super.onAttach(activity);
		}
		
		@Override
		public void onCreate(Bundle savedInstanceState) {
			super.onCreate(savedInstanceState);
		}
		
		@Override
		public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
			return super.onCreateView(inflater, container, savedInstanceState);
		}
		
		@Override
		public void onActivityCreated(Bundle savedInstanceState) {
			super.onActivityCreated(savedInstanceState);
		}
		
		@Override
		public void onStart() {
			super.onStart();
		}
		
		@Override
		public void onResume() {
			super.onResume();
		}
		
		@Override
		public void onPause() {
			super.onPause();
		}
		
		@Override
		public void onStop() {
			super.onStop();
		}
		
		@Override
		public void onDestroyView() {
			super.onDestroyView();
		}
		
		@Override
		public void onDestroy() {
			super.onDestroy();
		}
		
		@Override
		public void onDetach() {
			super.onDetach();
		}
	'''
	
}