package hu.bme.mit.mobilegen.componentmodel.generator;

import com.google.inject.Inject;
import hu.bme.mit.mobilegen.componentmodel.generator.IComponentmodelGenerator;
import hu.bme.mit.mobilegen.componentmodel.generator.activity.ActivitiesGenerator;
import hu.bme.mit.mobilegen.componentmodel.generator.application.ApplicationUnitGenerator;
import hu.bme.mit.mobilegen.componentmodel.generator.asynctask.AsyncTasksGenerator;
import hu.bme.mit.mobilegen.componentmodel.generator.fragment.FragmentsGenerator;
import hu.bme.mit.mobilegen.componentmodel.helper.WrappedModel;
import org.eclipse.xtext.generator.IFileSystemAccess;

@SuppressWarnings("all")
public class ComponentmodelGeneratorMain implements IComponentmodelGenerator {
  @Inject
  private ApplicationUnitGenerator applicationUnitGenerator;
  
  @Inject
  private ActivitiesGenerator activitiesGenerator;
  
  @Inject
  private FragmentsGenerator fragmentsGenerator;
  
  @Inject
  private AsyncTasksGenerator asyncTasksGenerator;
  
  public void generate(final WrappedModel wm, final IFileSystemAccess fsa) {
    this.applicationUnitGenerator.generateApplicationUnit(wm, fsa);
    this.activitiesGenerator.generateActivities(wm, fsa);
    this.fragmentsGenerator.generateFragments(wm, fsa);
    this.asyncTasksGenerator.generateAsyncTasks(wm, fsa);
  }
}
