package hu.bme.mit.mobilegen.componentmodel.generator.activity;

import com.google.common.base.Objects;
import hu.bme.mit.mobilegen.componentmodel.componentmodel.Activity;
import hu.bme.mit.mobilegen.componentmodel.componentmodel.ActivityType;
import hu.bme.mit.mobilegen.componentmodel.componentmodel.Association;
import hu.bme.mit.mobilegen.componentmodel.componentmodel.AsyncTask;
import hu.bme.mit.mobilegen.componentmodel.componentmodel.ConnectionType;
import hu.bme.mit.mobilegen.componentmodel.componentmodel.Fragment;
import hu.bme.mit.mobilegen.componentmodel.componentmodel.Property;
import hu.bme.mit.mobilegen.componentmodel.componentmodel.PropertyType;
import hu.bme.mit.mobilegen.componentmodel.componentmodel.StartActivity;
import hu.bme.mit.mobilegen.componentmodel.generator.GeneratorConstants;
import hu.bme.mit.mobilegen.componentmodel.generator.GeneratorData;
import hu.bme.mit.mobilegen.componentmodel.helper.FormatPropertyType;
import hu.bme.mit.mobilegen.componentmodel.logger.Log;
import org.eclipse.emf.common.util.EList;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.common.types.JvmType;
import org.eclipse.xtext.generator.IFileSystemAccess;
import org.eclipse.xtext.xbase.lib.Conversions;
import org.eclipse.xtext.xbase.lib.StringExtensions;

@SuppressWarnings("all")
public class ActivityGenerator {
  public void generateActivityUnit(final Activity a, final IFileSystemAccess fsa) {
    String _name = a.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    String _plus = ("Generating " + _firstUpper);
    String _plus_1 = (_plus + ".java");
    Log.info(_plus_1);
    String _name_1 = a.getName();
    String _firstUpper_1 = StringExtensions.toFirstUpper(_name_1);
    String _plus_2 = (_firstUpper_1 + ".java");
    CharSequence _generateActivity = this.generateActivity(a);
    fsa.generateFile(_plus_2, GeneratorConstants.SRC_GEN_ACT, _generateActivity);
  }
  
  private CharSequence generateActivity(final Activity a) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.newLine();
    CharSequence _classHeader = this.classHeader(a);
    _builder.append(_classHeader, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _packageDeclaration = this.packageDeclaration();
    _builder.append(_packageDeclaration, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _classImports = this.classImports(a);
    _builder.append(_classImports, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _classDeclaration = this.classDeclaration(a);
    _builder.append(_classDeclaration, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence classHeader(final Activity a) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//------------------------- Geneated Java Class File For Activity - ");
    String _name = a.getName();
    _builder.append(_name, "");
    _builder.append(" ---------------------------------");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence packageDeclaration() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("package ");
    String _packageName = GeneratorData.getPackageName();
    _builder.append(_packageName, "");
    _builder.append(".");
    _builder.append(GeneratorConstants.SRC_GEN_ACT, "");
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence classImports(final Activity a) {
    StringConcatenation _builder = new StringConcatenation();
    {
      ActivityType _type = a.getType();
      boolean _equals = _type.equals(ActivityType.LIST_ACTIVITY);
      if (_equals) {
        _builder.append("import android.app.ListActivity;");
        _builder.newLine();
      } else {
        _builder.append("import android.app.Activity;");
        _builder.newLine();
      }
    }
    _builder.append("import android.os.Bundle;");
    _builder.newLine();
    _builder.newLine();
    _builder.append("import android.content.BroadcastReceiver;");
    _builder.newLine();
    _builder.append("import android.content.Context;");
    _builder.newLine();
    _builder.append("import android.content.Intent;");
    _builder.newLine();
    _builder.append("import android.support.v4.content.LocalBroadcastManager;");
    _builder.newLine();
    _builder.append("import android.content.IntentFilter;");
    _builder.newLine();
    _builder.append("import java.util.List;");
    _builder.newLine();
    _builder.append("import android.support.v4.app.Fragment;");
    _builder.newLine();
    _builder.append("import android.support.v4.app.FragmentActivity;");
    _builder.newLine();
    _builder.append("import android.support.v4.app.FragmentManager;");
    _builder.newLine();
    _builder.append("import ");
    String _packageName = GeneratorData.getPackageName();
    _builder.append(_packageName, "");
    _builder.append(".");
    _builder.append(GeneratorConstants.SRC_GEN_APP, "");
    _builder.append(".");
    String _projectName = GeneratorData.getProjectName();
    String _plus = (_projectName + "Application");
    _builder.append(_plus, "");
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    {
      EList<Fragment> _fragments = a.getFragments();
      int _length = ((Object[])Conversions.unwrapArray(_fragments, Object.class)).length;
      boolean _greaterThan = (_length > 0);
      if (_greaterThan) {
        _builder.append("import ");
        String _packageName_1 = GeneratorData.getPackageName();
        _builder.append(_packageName_1, "");
        _builder.append(".");
        _builder.append(GeneratorConstants.SRC_GEN_FRAG, "");
        _builder.append(".*;");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("import ");
    String _packageName_2 = GeneratorData.getPackageName();
    _builder.append(_packageName_2, "");
    _builder.append(".R;");
    _builder.newLineIfNotEmpty();
    {
      EList<AsyncTask> _async_tasks = a.getAsync_tasks();
      for(final AsyncTask f : _async_tasks) {
        _builder.append("import ");
        String _packageName_3 = GeneratorData.getPackageName();
        _builder.append(_packageName_3, "");
        _builder.append(".");
        _builder.append(GeneratorConstants.SRC_GEN_ASYNC, "");
        _builder.append(".");
        String _name = f.getName();
        String _firstUpper = StringExtensions.toFirstUpper(_name);
        _builder.append(_firstUpper, "");
        _builder.append("AsyncTask;");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence classDeclaration(final Activity a) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("public class ");
    String _name = a.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    _builder.append(_firstUpper, "");
    _builder.append(" extends ");
    {
      EList<Fragment> _fragments = a.getFragments();
      int _length = ((Object[])Conversions.unwrapArray(_fragments, Object.class)).length;
      boolean _greaterThan = (_length > 0);
      if (_greaterThan) {
        _builder.append("Fragment");
      } else {
        ActivityType _type = a.getType();
        boolean _equals = _type.equals(ActivityType.LIST_ACTIVITY);
        if (_equals) {
          _builder.append("List");
        }
      }
    }
    _builder.append("Activity {");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    CharSequence _properties = this.properties(a);
    _builder.append(_properties, "\t");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    CharSequence _associations = this.associations(a);
    _builder.append(_associations, "\t");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    CharSequence _resultAsyncTasks = this.resultAsyncTasks(a);
    _builder.append(_resultAsyncTasks, "\t");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    CharSequence _overrideMethods = this.overrideMethods(a);
    _builder.append(_overrideMethods, "\t");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    CharSequence _startActivities = this.startActivities(a);
    _builder.append(_startActivities, "\t");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    CharSequence _startAsyncTasks = this.startAsyncTasks(a);
    _builder.append(_startAsyncTasks, "\t");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    CharSequence _finishActivity = this.finishActivity(a);
    _builder.append(_finishActivity, "\t");
    _builder.newLineIfNotEmpty();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence properties(final Activity a) {
    StringConcatenation _builder = new StringConcatenation();
    {
      EList<Property> _property = a.getProperty();
      for(final Property f : _property) {
        CharSequence _propertyDeclaration = this.propertyDeclaration(f);
        _builder.append(_propertyDeclaration, "");
        _builder.newLineIfNotEmpty();
      }
    }
    return _builder;
  }
  
  private CharSequence propertyDeclaration(final Property p) {
    StringConcatenation _builder = new StringConcatenation();
    {
      ConnectionType _connectionType = p.getConnectionType();
      boolean _equals = _connectionType.equals(ConnectionType.ONE);
      if (_equals) {
        CharSequence _simpleProperty = this.simpleProperty(p);
        _builder.append(_simpleProperty, "");
        _builder.newLineIfNotEmpty();
      } else {
        CharSequence _listProperty = this.listProperty(p);
        _builder.append(_listProperty, "");
        _builder.newLineIfNotEmpty();
      }
    }
    return _builder;
  }
  
  private CharSequence simpleProperty(final Property p) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("protected ");
    PropertyType _type = p.getType();
    String _formatPrimitive = FormatPropertyType.formatPrimitive(_type);
    _builder.append(_formatPrimitive, "");
    _builder.append(" ");
    String _name = p.getName();
    String _firstLower = StringExtensions.toFirstLower(_name);
    _builder.append(_firstLower, "");
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence listProperty(final Property p) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("protected List<");
    PropertyType _type = p.getType();
    String _formatClass = FormatPropertyType.formatClass(_type);
    _builder.append(_formatClass, "");
    _builder.append("> ");
    String _name = p.getName();
    String _firstLower = StringExtensions.toFirstLower(_name);
    _builder.append(_firstLower, "");
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence associations(final Activity a) {
    StringConcatenation _builder = new StringConcatenation();
    {
      EList<Association> _association = a.getAssociation();
      for(final Association f : _association) {
        CharSequence _associationDeclaration = this.associationDeclaration(f);
        _builder.append(_associationDeclaration, "");
        _builder.newLineIfNotEmpty();
      }
    }
    return _builder;
  }
  
  private CharSequence associationDeclaration(final Association a) {
    StringConcatenation _builder = new StringConcatenation();
    {
      ConnectionType _connectionType = a.getConnectionType();
      boolean _equals = _connectionType.equals(ConnectionType.ONE);
      if (_equals) {
        CharSequence _simpleAssociation = this.simpleAssociation(a);
        _builder.append(_simpleAssociation, "");
        _builder.newLineIfNotEmpty();
      } else {
        CharSequence _listAssociation = this.listAssociation(a);
        _builder.append(_listAssociation, "");
        _builder.newLineIfNotEmpty();
      }
    }
    return _builder;
  }
  
  private CharSequence simpleAssociation(final Association a) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("protected ");
    JvmType _connectTo = a.getConnectTo();
    String _qualifiedName = _connectTo.getQualifiedName();
    _builder.append(_qualifiedName, "");
    _builder.append(" ");
    String _name = a.getName();
    String _firstLower = StringExtensions.toFirstLower(_name);
    _builder.append(_firstLower, "");
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence listAssociation(final Association a) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("protected List<");
    JvmType _connectTo = a.getConnectTo();
    String _qualifiedName = _connectTo.getQualifiedName();
    _builder.append(_qualifiedName, "");
    _builder.append("> ");
    String _name = a.getName();
    String _firstLower = StringExtensions.toFirstLower(_name);
    _builder.append(_firstLower, "");
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence overrideMethods(final Activity a) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("protected void onCreate(Bundle savedInstanceState){");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("super.onCreate(savedInstanceState);");
    _builder.newLine();
    {
      EList<Fragment> _fragments = a.getFragments();
      int _length = ((Object[])Conversions.unwrapArray(_fragments, Object.class)).length;
      boolean _greaterThan = (_length > 0);
      if (_greaterThan) {
        _builder.append("\t");
        _builder.append("String fragment = getIntent().getExtras().getString(");
        String _projectName = GeneratorData.getProjectName();
        String _plus = (_projectName + "Application");
        _builder.append(_plus, "\t");
        _builder.append(".INTENT_FRAGMENT);");
        _builder.newLineIfNotEmpty();
        _builder.append("\t");
        _builder.newLine();
        {
          EList<Fragment> _fragments_1 = a.getFragments();
          for(final Fragment f : _fragments_1) {
            _builder.append("\t");
            String _fargment_frame = a.getFargment_frame();
            CharSequence _fragments_2 = this.fragments(f, _fargment_frame);
            _builder.append(_fragments_2, "\t");
            _builder.newLineIfNotEmpty();
          }
        }
      }
    }
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    _builder.append("protected void onStart(){");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("super.onStart();");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    _builder.append("protected void onRestart(){");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("super.onRestart();");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    _builder.append("protected void onResume(){");
    _builder.newLine();
    {
      EList<AsyncTask> _result_async_tasks = a.getResult_async_tasks();
      int _length_1 = ((Object[])Conversions.unwrapArray(_result_async_tasks, Object.class)).length;
      boolean _greaterThan_1 = (_length_1 > 0);
      if (_greaterThan_1) {
        _builder.append("\t");
        _builder.append("LocalBroadcastManager.getInstance(this).registerReceiver(messageReceiver, new IntentFilter(");
        String _projectName_1 = GeneratorData.getProjectName();
        String _plus_1 = (_projectName_1 + "Application");
        _builder.append(_plus_1, "\t");
        _builder.append(".INTENT_FILTER));");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("\t");
    _builder.append("super.onResume();");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    _builder.append("protected void onPause(){");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("super.onPause();");
    _builder.newLine();
    {
      EList<AsyncTask> _result_async_tasks_1 = a.getResult_async_tasks();
      int _length_2 = ((Object[])Conversions.unwrapArray(_result_async_tasks_1, Object.class)).length;
      boolean _greaterThan_2 = (_length_2 > 0);
      if (_greaterThan_2) {
        _builder.append("\t");
        _builder.append("LocalBroadcastManager.getInstance(this).unregisterReceiver(messageReceiver);");
        _builder.newLine();
      }
    }
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    _builder.append("protected void onStop(){");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("super.onStop();");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    _builder.append("protected void onDestroy(){");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("super.onDestroy();");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence fragments(final Fragment f, final String fragmentFrame) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("if(");
    String _projectName = GeneratorData.getProjectName();
    String _plus = (_projectName + "Application");
    _builder.append(_plus, "");
    _builder.append(".");
    String _name = f.getName();
    String _upperCase = _name.toUpperCase();
    _builder.append(_upperCase, "");
    _builder.append(".equals(fragment)){");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("try {");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("FragmentManager fragmentManager = getSupportFragmentManager();");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("fragmentManager.beginTransaction().replace(R.id.");
    _builder.append(fragmentFrame, "\t\t");
    _builder.append(", (Fragment) ");
    String _projectName_1 = GeneratorData.getProjectName();
    String _plus_1 = (_projectName_1 + "Application");
    _builder.append(_plus_1, "\t\t");
    _builder.append(".get");
    String _name_1 = f.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name_1);
    _builder.append(_firstUpper, "\t\t");
    _builder.append("Class().newInstance()).commit();");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("} catch (InstantiationException e) {");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("e.printStackTrace();");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("} catch (IllegalAccessException e) {");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("e.printStackTrace();");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence startActivities(final Activity a) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("// Strating other atcivities");
    _builder.newLine();
    _builder.newLine();
    {
      EList<StartActivity> _activities = a.getActivities();
      for(final StartActivity f : _activities) {
        CharSequence _startActivity = this.startActivity(f, a);
        _builder.append(_startActivity, "");
        _builder.newLineIfNotEmpty();
        _builder.newLine();
      }
    }
    return _builder;
  }
  
  private CharSequence startActivity(final StartActivity sa, final Activity a) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("protected void start");
    Activity _activity = sa.getActivity();
    String _name = _activity.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    _builder.append(_firstUpper, "");
    {
      Fragment _showFragment = sa.getShowFragment();
      boolean _notEquals = (!Objects.equal(_showFragment, null));
      if (_notEquals) {
        Fragment _showFragment_1 = sa.getShowFragment();
        String _name_1 = _showFragment_1.getName();
        String _firstUpper_1 = StringExtensions.toFirstUpper(_name_1);
        _builder.append(_firstUpper_1, "");
      }
    }
    {
      boolean _isNoReturn = sa.isNoReturn();
      if (_isNoReturn) {
        _builder.append("WithoutReturn");
      }
    }
    _builder.append("(Class<? extends ");
    Activity _activity_1 = sa.getActivity();
    String _name_2 = _activity_1.getName();
    String _firstUpper_2 = StringExtensions.toFirstUpper(_name_2);
    _builder.append(_firstUpper_2, "");
    _builder.append("> clazz){");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("Intent i = new Intent(getApplicationContext(), clazz);");
    _builder.newLine();
    {
      EList<Association> _sendAssoc = sa.getSendAssoc();
      for(final Association f : _sendAssoc) {
        _builder.append("\t");
        _builder.append("i.putExtra(");
        String _projectName = GeneratorData.getProjectName();
        String _plus = (_projectName + "Application");
        _builder.append(_plus, "\t");
        _builder.append(".");
        String _name_3 = a.getName();
        String _upperCase = _name_3.toUpperCase();
        String _plus_1 = (_upperCase + "_");
        String _name_4 = f.getName();
        String _firstLower = StringExtensions.toFirstLower(_name_4);
        String _upperCase_1 = _firstLower.toUpperCase();
        String _plus_2 = (_plus_1 + _upperCase_1);
        _builder.append(_plus_2, "\t");
        _builder.append(", ");
        String _name_5 = f.getName();
        String _firstLower_1 = StringExtensions.toFirstLower(_name_5);
        _builder.append(_firstLower_1, "\t");
        _builder.append(");");
        _builder.newLineIfNotEmpty();
      }
    }
    {
      Fragment _showFragment_2 = sa.getShowFragment();
      boolean _notEquals_1 = (!Objects.equal(_showFragment_2, null));
      if (_notEquals_1) {
        _builder.append("\t");
        _builder.append("i.putExtra(");
        String _projectName_1 = GeneratorData.getProjectName();
        String _plus_3 = (_projectName_1 + "Application");
        _builder.append(_plus_3, "\t");
        _builder.append(".INTENT_FRAGMENT, ");
        String _projectName_2 = GeneratorData.getProjectName();
        String _plus_4 = (_projectName_2 + "Application");
        _builder.append(_plus_4, "\t");
        _builder.append(".");
        Fragment _showFragment_3 = sa.getShowFragment();
        String _name_6 = _showFragment_3.getName();
        String _upperCase_2 = _name_6.toUpperCase();
        _builder.append(_upperCase_2, "\t");
        _builder.append(");");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("\t");
    _builder.append("startActivity(i);");
    _builder.newLine();
    _builder.append("\t");
    {
      boolean _isNoReturn_1 = sa.isNoReturn();
      if (_isNoReturn_1) {
        _builder.append("finish();");
      }
    }
    _builder.newLineIfNotEmpty();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence startAsyncTasks(final Activity a) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("// Strating other async tasks");
    _builder.newLine();
    _builder.newLine();
    {
      EList<AsyncTask> _async_tasks = a.getAsync_tasks();
      for(final AsyncTask f : _async_tasks) {
        CharSequence _startAsyncTask = this.startAsyncTask(f);
        _builder.append(_startAsyncTask, "");
        _builder.newLineIfNotEmpty();
        _builder.newLine();
      }
    }
    return _builder;
  }
  
  private CharSequence startAsyncTask(final AsyncTask a) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("protected void start");
    String _name = a.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    _builder.append(_firstUpper, "");
    _builder.append("AsyncTask(String param){");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("new ");
    String _name_1 = a.getName();
    String _firstUpper_1 = StringExtensions.toFirstUpper(_name_1);
    _builder.append(_firstUpper_1, "\t");
    _builder.append("AsyncTask(getApplicationContext()).execute(param);");
    _builder.newLineIfNotEmpty();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence resultAsyncTasks(final Activity a) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("// Strating other result");
    _builder.newLine();
    _builder.newLine();
    {
      EList<AsyncTask> _result_async_tasks = a.getResult_async_tasks();
      int _length = ((Object[])Conversions.unwrapArray(_result_async_tasks, Object.class)).length;
      boolean _greaterThan = (_length > 0);
      if (_greaterThan) {
        _builder.append("protected BroadcastReceiver messageReceiver = new BroadcastReceiver() {");
        _builder.newLine();
        _builder.append("\t");
        _builder.newLine();
        _builder.append("\t");
        _builder.append("@Override");
        _builder.newLine();
        _builder.append("\t");
        _builder.append("public void onReceive(Context context, Intent intent) {");
        _builder.newLine();
        {
          EList<AsyncTask> _result_async_tasks_1 = a.getResult_async_tasks();
          for(final AsyncTask f : _result_async_tasks_1) {
            _builder.append("\t\t");
            _builder.append("{");
            _builder.newLine();
            _builder.append("\t\t");
            _builder.append("\t");
            CharSequence _resultAsyncTask = this.resultAsyncTask(f);
            _builder.append(_resultAsyncTask, "\t\t\t");
            _builder.newLineIfNotEmpty();
            _builder.append("\t\t");
            _builder.append("}");
            _builder.newLine();
          }
        }
        _builder.append("\t");
        _builder.append("}");
        _builder.newLine();
        _builder.append("};");
        _builder.newLine();
        _builder.newLine();
        {
          EList<AsyncTask> _result_async_tasks_2 = a.getResult_async_tasks();
          for(final AsyncTask f_1 : _result_async_tasks_2) {
            CharSequence _resultAsyncTaskMethod = this.resultAsyncTaskMethod(f_1);
            _builder.append(_resultAsyncTaskMethod, "");
            _builder.newLineIfNotEmpty();
          }
        }
        _builder.newLine();
      }
    }
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence resultAsyncTask(final AsyncTask a) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("String result = intent.getStringExtra(");
    String _projectName = GeneratorData.getProjectName();
    String _plus = (_projectName + "Application");
    _builder.append(_plus, "");
    _builder.append(".");
    String _name = a.getName();
    String _upperCase = _name.toUpperCase();
    _builder.append(_upperCase, "");
    _builder.append(");");
    _builder.newLineIfNotEmpty();
    _builder.append("if(result != null){");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("result");
    String _name_1 = a.getName();
    String _upperCase_1 = _name_1.toUpperCase();
    _builder.append(_upperCase_1, "\t");
    _builder.append("(result);");
    _builder.newLineIfNotEmpty();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence resultAsyncTaskMethod(final AsyncTask a) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("protected void result");
    String _name = a.getName();
    String _upperCase = _name.toUpperCase();
    _builder.append(_upperCase, "");
    _builder.append("(String result){");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence finishActivity(final Activity a) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("protected void navigateBack(){");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("finish();");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
}
