package hu.bme.mit.mobilegen.componentmodel.generator.application;

import hu.bme.mit.mobilegen.componentmodel.componentmodel.Fragment;
import hu.bme.mit.mobilegen.componentmodel.generator.GeneratorConstants;
import hu.bme.mit.mobilegen.componentmodel.generator.GeneratorData;
import hu.bme.mit.mobilegen.componentmodel.logger.Log;
import java.util.List;
import java.util.Set;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.generator.IFileSystemAccess;
import org.eclipse.xtext.xbase.lib.StringExtensions;

@SuppressWarnings("all")
public class ApplicationGenerator {
  private Set<String> consts;
  
  private List<Fragment> frags;
  
  public void generateApplication(final List<Fragment> fragments, final Set<String> constants, final IFileSystemAccess fsa) {
    this.frags = fragments;
    this.consts = constants;
    String _projectName = GeneratorData.getProjectName();
    String _plus = ("Generating " + _projectName);
    String _plus_1 = (_plus + "Application");
    String _plus_2 = (_plus_1 + ".java");
    Log.info(_plus_2);
    String _projectName_1 = GeneratorData.getProjectName();
    String _plus_3 = (_projectName_1 + "Application");
    String _plus_4 = (_plus_3 + ".java");
    CharSequence _generateApplication = this.generateApplication();
    fsa.generateFile(_plus_4, GeneratorConstants.SRC_GEN_APP, _generateApplication);
  }
  
  private CharSequence generateApplication() {
    StringConcatenation _builder = new StringConcatenation();
    CharSequence _classHeader = this.classHeader();
    _builder.append(_classHeader, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _packageDeclaration = this.packageDeclaration();
    _builder.append(_packageDeclaration, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _classImports = this.classImports();
    _builder.append(_classImports, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _classDeclaration = this.classDeclaration();
    _builder.append(_classDeclaration, "");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence classHeader() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//------------------------- Geneated Java Class File For Application - ");
    String _projectName = GeneratorData.getProjectName();
    String _plus = (_projectName + "Application");
    _builder.append(_plus, "");
    _builder.append(" ---------------------------------");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence packageDeclaration() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("package ");
    String _packageName = GeneratorData.getPackageName();
    _builder.append(_packageName, "");
    _builder.append(".");
    _builder.append(GeneratorConstants.SRC_GEN_APP, "");
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence classImports() {
    StringConcatenation _builder = new StringConcatenation();
    {
      int _size = this.frags.size();
      boolean _greaterThan = (_size > 0);
      if (_greaterThan) {
        _builder.append("import ");
        String _packageName = GeneratorData.getPackageName();
        _builder.append(_packageName, "");
        _builder.append(".");
        _builder.append(GeneratorConstants.SRC_GEN_FRAG, "");
        _builder.append(".*;");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.newLine();
    _builder.append("import android.app.Application;");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence classDeclaration() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("public class ");
    String _projectName = GeneratorData.getProjectName();
    String _plus = (_projectName + "Application");
    _builder.append(_plus, "");
    _builder.append(" extends Application {");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    CharSequence _constants = this.constants();
    _builder.append(_constants, "\t");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    CharSequence _fragmentsClass = this.fragmentsClass();
    _builder.append(_fragmentsClass, "\t");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    CharSequence _callbacks = this.callbacks();
    _builder.append(_callbacks, "\t");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    CharSequence _fragmentsGetterSetters = this.fragmentsGetterSetters();
    _builder.append(_fragmentsGetterSetters, "\t");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence constants() {
    StringConcatenation _builder = new StringConcatenation();
    {
      for(final String f : this.consts) {
        _builder.append("public static final String ");
        String _upperCase = f.toUpperCase();
        _builder.append(_upperCase, "");
        _builder.append(" = \"");
        String _lowerCase = f.toLowerCase();
        _builder.append(_lowerCase, "");
        _builder.append("\";");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.newLine();
    _builder.append("public static final String INTENT_FILTER = \"async_response_filter\";");
    _builder.newLine();
    _builder.newLine();
    _builder.append("public static final String INTENT_FRAGMENT = \"fragment\";");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence fragmentsClass() {
    StringConcatenation _builder = new StringConcatenation();
    {
      for(final Fragment f : this.frags) {
        _builder.append("private static Class<? extends ");
        String _name = f.getName();
        String _firstUpper = StringExtensions.toFirstUpper(_name);
        _builder.append(_firstUpper, "");
        _builder.append("> ");
        String _name_1 = f.getName();
        String _firstLower = StringExtensions.toFirstLower(_name_1);
        _builder.append(_firstLower, "");
        _builder.append("Class;");
        _builder.newLineIfNotEmpty();
      }
    }
    return _builder;
  }
  
  private CharSequence callbacks() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("@Override");
    _builder.newLine();
    _builder.append("public void onCreate() {");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("super.onCreate();");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    _builder.append("@Override");
    _builder.newLine();
    _builder.append("public void onTerminate() {");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("super.onTerminate();");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence fragmentsGetterSetters() {
    StringConcatenation _builder = new StringConcatenation();
    {
      for(final Fragment f : this.frags) {
        CharSequence _fragmentGetter = this.fragmentGetter(f);
        _builder.append(_fragmentGetter, "");
        _builder.newLineIfNotEmpty();
        _builder.newLine();
        CharSequence _fragmentSetter = this.fragmentSetter(f);
        _builder.append(_fragmentSetter, "");
        _builder.newLineIfNotEmpty();
        _builder.newLine();
      }
    }
    return _builder;
  }
  
  private CharSequence fragmentGetter(final Fragment f) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("public static Class<? extends ");
    String _name = f.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    _builder.append(_firstUpper, "");
    _builder.append("> get");
    String _name_1 = f.getName();
    String _firstUpper_1 = StringExtensions.toFirstUpper(_name_1);
    _builder.append(_firstUpper_1, "");
    _builder.append("Class() {");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("return ");
    String _name_2 = f.getName();
    String _firstLower = StringExtensions.toFirstLower(_name_2);
    _builder.append(_firstLower, "\t");
    _builder.append("Class;");
    _builder.newLineIfNotEmpty();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence fragmentSetter(final Fragment f) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("protected static void set");
    String _name = f.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    _builder.append(_firstUpper, "");
    _builder.append("Class(Class<? extends ");
    String _name_1 = f.getName();
    String _firstUpper_1 = StringExtensions.toFirstUpper(_name_1);
    _builder.append(_firstUpper_1, "");
    _builder.append("> ");
    String _name_2 = f.getName();
    String _firstLower = StringExtensions.toFirstLower(_name_2);
    _builder.append(_firstLower, "");
    _builder.append("Class) {");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    String _projectName = GeneratorData.getProjectName();
    String _plus = (_projectName + "Application");
    _builder.append(_plus, "\t");
    _builder.append(".");
    String _name_3 = f.getName();
    String _firstLower_1 = StringExtensions.toFirstLower(_name_3);
    _builder.append(_firstLower_1, "\t");
    _builder.append("Class = ");
    String _name_4 = f.getName();
    String _firstLower_2 = StringExtensions.toFirstLower(_name_4);
    _builder.append(_firstLower_2, "\t");
    _builder.append("Class;");
    _builder.newLineIfNotEmpty();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
}
