package hu.bme.mit.mobilegen.componentmodel.generator.application;

import com.google.inject.Inject;
import hu.bme.mit.mobilegen.componentmodel.componentmodel.Activity;
import hu.bme.mit.mobilegen.componentmodel.componentmodel.Association;
import hu.bme.mit.mobilegen.componentmodel.componentmodel.AsyncTask;
import hu.bme.mit.mobilegen.componentmodel.componentmodel.Fragment;
import hu.bme.mit.mobilegen.componentmodel.componentmodel.Property;
import hu.bme.mit.mobilegen.componentmodel.componentmodel.StartActivity;
import hu.bme.mit.mobilegen.componentmodel.generator.application.ApplicationGenerator;
import hu.bme.mit.mobilegen.componentmodel.helper.WrappedModel;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import org.eclipse.emf.common.util.EList;
import org.eclipse.xtext.generator.IFileSystemAccess;

@SuppressWarnings("all")
public class ApplicationUnitGenerator {
  @Inject
  private ApplicationGenerator applicationGenerator;
  
  private Set<String> constants;
  
  public void generateApplicationUnit(final WrappedModel wm, final IFileSystemAccess fsa) {
    HashSet<String> _hashSet = new HashSet<String>();
    this.constants = _hashSet;
    List<AsyncTask> _asyncTasks = wm.getAsyncTasks();
    for (final AsyncTask a : _asyncTasks) {
      String _name = a.getName();
      this.constants.add(_name);
    }
    List<Fragment> _fragments = wm.getFragments();
    for (final Fragment f : _fragments) {
      String _name_1 = f.getName();
      this.constants.add(_name_1);
    }
    List<Activity> _activities = wm.getActivities();
    for (final Activity a_1 : _activities) {
      EList<StartActivity> _activities_1 = a_1.getActivities();
      for (final StartActivity startAct : _activities_1) {
        {
          EList<Association> _sendAssoc = startAct.getSendAssoc();
          for (final Association assoc : _sendAssoc) {
            String _name_2 = a_1.getName();
            String _plus = (_name_2 + "_");
            String _name_3 = assoc.getName();
            String _plus_1 = (_plus + _name_3);
            this.constants.add(_plus_1);
          }
          EList<Property> _sendProp = startAct.getSendProp();
          for (final Property p : _sendProp) {
            String _name_4 = a_1.getName();
            String _plus_2 = (_name_4 + "_");
            String _name_5 = p.getName();
            String _plus_3 = (_plus_2 + _name_5);
            this.constants.add(_plus_3);
          }
        }
      }
    }
    List<Fragment> _fragments_1 = wm.getFragments();
    this.applicationGenerator.generateApplication(_fragments_1, this.constants, fsa);
  }
}
