package hu.bme.mit.mobilegen.componentmodel.generator.asynctask;

import hu.bme.mit.mobilegen.componentmodel.componentmodel.AsyncTask;
import hu.bme.mit.mobilegen.componentmodel.generator.GeneratorConstants;
import hu.bme.mit.mobilegen.componentmodel.generator.GeneratorData;
import hu.bme.mit.mobilegen.componentmodel.logger.Log;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.generator.IFileSystemAccess;
import org.eclipse.xtext.xbase.lib.StringExtensions;

@SuppressWarnings("all")
public class AsyncTaskGenerator {
  public void generateAsyncTaskUnit(final AsyncTask a, final IFileSystemAccess fsa) {
    String _name = a.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    String _plus = ("Generating " + _firstUpper);
    String _plus_1 = (_plus + "AsyncTask.java");
    Log.info(_plus_1);
    String _name_1 = a.getName();
    String _firstUpper_1 = StringExtensions.toFirstUpper(_name_1);
    String _plus_2 = (_firstUpper_1 + "AsyncTask.java");
    CharSequence _generateAsyncTask = this.generateAsyncTask(a);
    fsa.generateFile(_plus_2, GeneratorConstants.SRC_GEN_ASYNC, _generateAsyncTask);
  }
  
  private CharSequence generateAsyncTask(final AsyncTask a) {
    StringConcatenation _builder = new StringConcatenation();
    CharSequence _classHeader = this.classHeader(a);
    _builder.append(_classHeader, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _packageDeclaration = this.packageDeclaration();
    _builder.append(_packageDeclaration, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _classImports = this.classImports();
    _builder.append(_classImports, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _classDeclaration = this.classDeclaration(a);
    _builder.append(_classDeclaration, "");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence classHeader(final AsyncTask a) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//------------------------- Geneated Java Class File For Async Task - ");
    String _name = a.getName();
    _builder.append(_name, "");
    _builder.append(" ---------------------------------");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence packageDeclaration() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("package ");
    String _packageName = GeneratorData.getPackageName();
    _builder.append(_packageName, "");
    _builder.append(".");
    _builder.append(GeneratorConstants.SRC_GEN_ASYNC, "");
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence classImports() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("import java.io.BufferedReader;");
    _builder.newLine();
    _builder.append("import java.io.InputStream;");
    _builder.newLine();
    _builder.append("import java.io.InputStreamReader;");
    _builder.newLine();
    _builder.newLine();
    _builder.append("import org.apache.http.HttpEntity;");
    _builder.newLine();
    _builder.append("import org.apache.http.HttpResponse;");
    _builder.newLine();
    _builder.append("import org.apache.http.HttpStatus;");
    _builder.newLine();
    _builder.append("import org.apache.http.client.HttpClient;");
    _builder.newLine();
    _builder.append("import org.apache.http.client.methods.HttpGet;");
    _builder.newLine();
    _builder.append("import org.apache.http.impl.client.DefaultHttpClient;");
    _builder.newLine();
    _builder.newLine();
    _builder.append("import android.content.Context;");
    _builder.newLine();
    _builder.append("import android.content.Intent;");
    _builder.newLine();
    _builder.append("import android.os.AsyncTask;");
    _builder.newLine();
    _builder.append("import android.support.v4.content.LocalBroadcastManager;");
    _builder.newLine();
    _builder.newLine();
    _builder.append("import ");
    String _packageName = GeneratorData.getPackageName();
    _builder.append(_packageName, "");
    _builder.append(".");
    _builder.append(GeneratorConstants.SRC_GEN_APP, "");
    _builder.append(".");
    String _projectName = GeneratorData.getProjectName();
    String _plus = (_projectName + "Application");
    _builder.append(_plus, "");
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence classDeclaration(final AsyncTask a) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("public class ");
    String _name = a.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    _builder.append(_firstUpper, "");
    _builder.append("AsyncTask extends AsyncTask<String, Void, String> {");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    CharSequence _asyncTaskMethods = this.asyncTaskMethods(a);
    _builder.append(_asyncTaskMethods, "\t");
    _builder.newLineIfNotEmpty();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence asyncTaskMethods(final AsyncTask a) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("private Context context = null;");
    _builder.newLine();
    _builder.newLine();
    _builder.append("public ");
    String _name = a.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    _builder.append(_firstUpper, "");
    _builder.append("AsyncTask(Context context) {");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("this.context = context;");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    _builder.append("@Override");
    _builder.newLine();
    _builder.append("protected void onPreExecute() {");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("super.onPreExecute();");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    _builder.append("@Override");
    _builder.newLine();
    _builder.append("protected String doInBackground(String... params) {");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("if(params.length > 0){");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("HttpClient httpclient = new DefaultHttpClient();");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("HttpGet httpget = new HttpGet(params[0]);");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("HttpResponse response = null;");
    _builder.newLine();
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("String result = \"\";");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("InputStream is = null;");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("try {");
    _builder.newLine();
    _builder.append("\t\t\t");
    _builder.append("response = httpclient.execute(httpget);");
    _builder.newLine();
    _builder.newLine();
    _builder.append("\t\t\t");
    _builder.append("System.out.println(response.getStatusLine().getStatusCode());");
    _builder.newLine();
    _builder.append("\t\t\t");
    _builder.append("if (response.getStatusLine().getStatusCode() == HttpStatus.SC_OK) {");
    _builder.newLine();
    _builder.append("\t\t\t\t");
    _builder.append("HttpEntity entity = response.getEntity();");
    _builder.newLine();
    _builder.append("\t\t\t\t");
    _builder.append("if (entity != null) {");
    _builder.newLine();
    _builder.append("\t\t\t\t\t");
    _builder.append("is = entity.getContent();");
    _builder.newLine();
    _builder.newLine();
    _builder.append("\t\t\t\t\t");
    _builder.append("BufferedReader reader = new BufferedReader(new InputStreamReader(is));");
    _builder.newLine();
    _builder.append("\t\t\t\t\t");
    _builder.append("StringBuilder sb = new StringBuilder();");
    _builder.newLine();
    _builder.append("\t\t\t\t\t");
    _builder.append("String line = null;");
    _builder.newLine();
    _builder.newLine();
    _builder.append("\t\t\t\t\t");
    _builder.append("while ((line = reader.readLine()) != null) {");
    _builder.newLine();
    _builder.append("\t\t\t\t\t\t");
    _builder.append("sb.append(line + \"\\n\");");
    _builder.newLine();
    _builder.append("\t\t\t\t\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("\t\t\t\t\t");
    _builder.newLine();
    _builder.append("\t\t\t\t\t");
    _builder.append("System.out.println(sb.toString());");
    _builder.newLine();
    _builder.append("\t\t\t\t\t");
    _builder.append("result = sb.toString();");
    _builder.newLine();
    _builder.append("\t\t\t\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("\t\t\t");
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("} catch (Exception e) {");
    _builder.newLine();
    _builder.append("\t\t\t");
    _builder.append("e.printStackTrace();");
    _builder.newLine();
    _builder.append("\t\t\t");
    _builder.append("result = e.getMessage();");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("} finally {");
    _builder.newLine();
    _builder.append("\t\t\t");
    _builder.append("if (is != null) {");
    _builder.newLine();
    _builder.append("\t\t\t\t");
    _builder.append("try {");
    _builder.newLine();
    _builder.append("\t\t\t\t\t");
    _builder.append("is.close();");
    _builder.newLine();
    _builder.append("\t\t\t\t");
    _builder.append("} catch (Exception e) {");
    _builder.newLine();
    _builder.append("\t\t\t\t\t");
    _builder.append("e.printStackTrace();");
    _builder.newLine();
    _builder.append("\t\t\t\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("\t\t\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("return result;");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("return \"\";");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    _builder.append("@Override");
    _builder.newLine();
    _builder.append("protected void onPostExecute(String result) {");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("super.onPostExecute(result);");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("System.out.println(result);");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("Intent respIntent = new Intent(");
    String _projectName = GeneratorData.getProjectName();
    String _plus = (_projectName + "Application");
    _builder.append(_plus, "\t");
    _builder.append(".INTENT_FILTER);");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("\t");
    _builder.append("respIntent.putExtra(");
    String _projectName_1 = GeneratorData.getProjectName();
    String _plus_1 = (_projectName_1 + "Application");
    _builder.append(_plus_1, "\t");
    _builder.append(".");
    String _name_1 = a.getName();
    String _upperCase = _name_1.toUpperCase();
    _builder.append(_upperCase, "\t");
    _builder.append(", result);");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("LocalBroadcastManager.getInstance(context).sendBroadcast(respIntent);");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
}
