package hu.bme.mit.mobilegen.componentmodel.generator.fragment;

import hu.bme.mit.mobilegen.componentmodel.componentmodel.Fragment;
import hu.bme.mit.mobilegen.componentmodel.componentmodel.FragmentType;
import hu.bme.mit.mobilegen.componentmodel.generator.GeneratorConstants;
import hu.bme.mit.mobilegen.componentmodel.generator.GeneratorData;
import hu.bme.mit.mobilegen.componentmodel.logger.Log;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.generator.IFileSystemAccess;
import org.eclipse.xtext.xbase.lib.StringExtensions;

@SuppressWarnings("all")
public class FragmentGenerator {
  public void generateFragmentUnit(final Fragment f, final IFileSystemAccess fsa) {
    String _name = f.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    String _plus = ("Generating " + _firstUpper);
    String _plus_1 = (_plus + ".java");
    Log.info(_plus_1);
    String _name_1 = f.getName();
    String _firstUpper_1 = StringExtensions.toFirstUpper(_name_1);
    String _plus_2 = (_firstUpper_1 + ".java");
    CharSequence _generateFragment = this.generateFragment(f);
    fsa.generateFile(_plus_2, GeneratorConstants.SRC_GEN_FRAG, _generateFragment);
  }
  
  private CharSequence generateFragment(final Fragment f) {
    StringConcatenation _builder = new StringConcatenation();
    CharSequence _classHeader = this.classHeader(f);
    _builder.append(_classHeader, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _packageDeclaration = this.packageDeclaration();
    _builder.append(_packageDeclaration, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _classImports = this.classImports(f);
    _builder.append(_classImports, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _classDeclaration = this.classDeclaration(f);
    _builder.append(_classDeclaration, "");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence classHeader(final Fragment f) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//------------------------- Geneated Java Class File For Fragment - ");
    String _name = f.getName();
    _builder.append(_name, "");
    _builder.append(" ---------------------------------");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence packageDeclaration() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("package ");
    String _packageName = GeneratorData.getPackageName();
    _builder.append(_packageName, "");
    _builder.append(".");
    _builder.append(GeneratorConstants.SRC_GEN_FRAG, "");
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence classImports(final Fragment f) {
    StringConcatenation _builder = new StringConcatenation();
    {
      FragmentType _type = f.getType();
      boolean _equals = _type.equals(FragmentType.LIST_FRAGMENT);
      if (_equals) {
        _builder.append("import android.support.v4.app.ListFragment;");
        _builder.newLine();
      } else {
        _builder.append("import android.support.v4.app.Fragment;");
        _builder.newLine();
      }
    }
    _builder.newLine();
    _builder.append("import android.os.Bundle;");
    _builder.newLine();
    _builder.append("import android.app.Activity;");
    _builder.newLine();
    _builder.append("import android.view.LayoutInflater;");
    _builder.newLine();
    _builder.append("import android.view.View;");
    _builder.newLine();
    _builder.append("import android.view.ViewGroup;");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence classDeclaration(final Fragment f) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("public class ");
    String _name = f.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    _builder.append(_firstUpper, "");
    _builder.append(" extends ");
    {
      FragmentType _type = f.getType();
      boolean _equals = _type.equals(FragmentType.LIST_FRAGMENT);
      if (_equals) {
        _builder.append("List");
      }
    }
    _builder.append("Fragment {");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    CharSequence _overrideMethods = this.overrideMethods(f);
    _builder.append(_overrideMethods, "\t");
    _builder.newLineIfNotEmpty();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence overrideMethods(final Fragment f) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("@Override");
    _builder.newLine();
    _builder.append("public void onAttach(Activity activity) {");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("super.onAttach(activity);");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    _builder.append("@Override");
    _builder.newLine();
    _builder.append("public void onCreate(Bundle savedInstanceState) {");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("super.onCreate(savedInstanceState);");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    _builder.append("@Override");
    _builder.newLine();
    _builder.append("public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("return super.onCreateView(inflater, container, savedInstanceState);");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    _builder.append("@Override");
    _builder.newLine();
    _builder.append("public void onActivityCreated(Bundle savedInstanceState) {");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("super.onActivityCreated(savedInstanceState);");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    _builder.append("@Override");
    _builder.newLine();
    _builder.append("public void onStart() {");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("super.onStart();");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    _builder.append("@Override");
    _builder.newLine();
    _builder.append("public void onResume() {");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("super.onResume();");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    _builder.append("@Override");
    _builder.newLine();
    _builder.append("public void onPause() {");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("super.onPause();");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    _builder.append("@Override");
    _builder.newLine();
    _builder.append("public void onStop() {");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("super.onStop();");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    _builder.append("@Override");
    _builder.newLine();
    _builder.append("public void onDestroyView() {");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("super.onDestroyView();");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    _builder.append("@Override");
    _builder.newLine();
    _builder.append("public void onDestroy() {");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("super.onDestroy();");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    _builder.append("@Override");
    _builder.newLine();
    _builder.append("public void onDetach() {");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("super.onDetach();");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
}
