package hu.bme.mit.mobilegen.datamodel.ui.file;

import hu.bme.mit.mobilegen.datamodel.ui.builder.ConfigurationFileParameters;
import hu.bme.mit.mobilegen.datamodel.ui.builder.FileExtensions;

import java.io.ByteArrayInputStream;
import java.io.InputStream;

import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.dialogs.WizardNewFileCreationPage;

public class CreateDatamodelConfigFileHelper extends WizardNewFileCreationPage {

    public CreateDatamodelConfigFileHelper(IStructuredSelection selection) {
        super("New Datamodel Config File", selection);
        setTitle("Datamodel Config File");
        setDescription("Creates a new Datamodel Config File");
        setFileExtension(FileExtensions.CONFIGURATION_FILE_EXTENSION);
    }

    @Override
    protected InputStream getInitialContents() {
    	return getConfigFileInputStream();
    }
    
    private InputStream getConfigFileInputStream(){
    	return new ByteArrayInputStream(
    			(ConfigurationFileParameters.PROJECT_NAME + "\n" +
    			ConfigurationFileParameters.PACKAGE_NAME + "\n" +
    			ConfigurationFileParameters.DEVICE + "\n" +
    			ConfigurationFileParameters.ORM_TYPE + "\n" +
    			ConfigurationFileParameters.DB_NAME + "\n" +
    			ConfigurationFileParameters.DB_VERSION + "\n"
    			).getBytes());
    }
    
}