package hu.bme.mit.mobilegen.datamodel.ui.handler;

import hu.bme.mit.mobilegen.datamodel.ui.builder.DatamodelBuilder;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.IHandler;
import org.eclipse.core.resources.IFile;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.handlers.HandlerUtil;

import com.google.inject.Inject;

public class DatamodelGeneratorFromXMIHandler extends AbstractHandler implements IHandler {

	@Inject
	private DatamodelBuilder builder;

	@Override
	public Object execute(ExecutionEvent event) throws ExecutionException {

		ISelection selection = HandlerUtil.getCurrentSelection(event);

		if (selection instanceof IStructuredSelection) {

			IStructuredSelection structuredSelection = (IStructuredSelection) selection;
			Object firstElement = structuredSelection.getFirstElement();

			if (firstElement instanceof IFile) {
				IFile file = (IFile) firstElement;
				builder.generateDatamodelFromXMI(file);
			}
		}

		return null;
	}

}
