package hu.bme.mit.mobilegen.datamodel.generator

import com.google.inject.Inject
import hu.bme.mit.mobilegen.datamodel.datamodel.Enumeration
import hu.bme.mit.mobilegen.datamodel.generator.entity.EntityFactoryGenerator
import hu.bme.mit.mobilegen.datamodel.generator.entity.EntityGENGenerator
import hu.bme.mit.mobilegen.datamodel.generator.entity.EntityGenerator
import hu.bme.mit.mobilegen.datamodel.generator.entity.EnumerationGenerator
import hu.bme.mit.mobilegen.datamodel.helper.GeneratorHelper
import hu.bme.mit.mobilegen.datamodel.helper.WrappedEntity
import hu.bme.mit.mobilegen.datamodel.helper.WrappedModel
import java.util.List
import org.eclipse.xtext.generator.IFileSystemAccess

class DatamodelElementGenerator {
	
	@Inject
	EntityGENGenerator entityGENGen;
	
	@Inject
	EntityGenerator entityGen;
	
	@Inject
	EntityFactoryGenerator entityFactoryGen;
	
	@Inject
	EnumerationGenerator enumerationGenerator;
	
	def generateDataModel(WrappedModel wm, IFileSystemAccess fsa){
		generateEnumerations(wm.enumerations, fsa);
		generateEntities(wm.entities, fsa);
	}
	
	def generateEntities(List<WrappedEntity> entities, IFileSystemAccess fsa) {
		
		for(WrappedEntity we : entities){
			if(we.genHelp == GeneratorHelper.JoinClass){
				entityGENGen.generateEntityGENOnly(we, fsa);
			}
			else{
				if(GeneratorData.generateStub){
					entityGENGen.generateEntityGEN(we, fsa);
					entityGen.generateEntity(we, fsa);
				}
				else{
					entityGENGen.generateEntityGENOnly(we, fsa);
				}
				
			}
		}
		
		entityFactoryGen.generateEntityFactory(entities, fsa);
		
	}
	
	def generateEnumerations(List<Enumeration> enumerations, IFileSystemAccess fsa) {
		for(Enumeration e : enumerations){
			enumerationGenerator.generateEnumeration(e, fsa);
		}
	}
	
}
