package hu.bme.mit.mobilegen.datamodel.generator

import com.google.inject.Inject
import hu.bme.mit.mobilegen.datamodel.generator.database.DatabaseGeneratorMain
import hu.bme.mit.mobilegen.datamodel.generator.serialize.SerializeGenerator
import hu.bme.mit.mobilegen.datamodel.generator.sharedpreferences.SharedPreferencesGenerator
import hu.bme.mit.mobilegen.datamodel.helper.WrappedModel
import org.eclipse.xtext.generator.IFileSystemAccess

class DatamodelGeneratorMain implements IDatamodelGenerator{
	
	@Inject
	DatamodelElementGenerator modelGenerator;
	
	@Inject
	DatabaseGeneratorMain databaseGenerator;
	
	@Inject
	SerializeGenerator serializeGenerator;
	
	@Inject
	SharedPreferencesGenerator sharedPreferencesGenerator;
	
	override generate(WrappedModel wm, IFileSystemAccess fsa) {
		modelGenerator.generateDataModel(wm, fsa);
		
		databaseGenerator.generateDataAccessLayer(wm, fsa);
		
		serializeGenerator.generateSerializationUnit(wm, fsa);
		
		sharedPreferencesGenerator.generateSharedPreferencesUnit(wm, fsa);
	}
	
}