package hu.bme.mit.mobilegen.datamodel.generator.entity

import hu.bme.mit.mobilegen.datamodel.datamodel.Enumeration
import hu.bme.mit.mobilegen.datamodel.generator.GeneratorConstants
import hu.bme.mit.mobilegen.datamodel.generator.GeneratorData
import hu.bme.mit.mobilegen.datamodel.logger.Log
import org.eclipse.xtext.generator.IFileSystemAccess

class EnumerationGenerator {
	
	def generateEnumeration(Enumeration enumeration, IFileSystemAccess fsa){
		Log.info("Generating " + enumeration.name + ".java");
		fsa.generateFile(enumeration.name + ".java", GeneratorConstants.SRC_GEN_ENTITIES, enumeration.generateEnumeration())
	}
	
	def private generateEnumeration(Enumeration e) '''
		«e.enumHeader»
		
		«packageDeclaration»
		
		//
		«e.enumDeclaration»
		
	'''
	
	def private enumHeader(Enumeration e) '''
		//------------------------- Geneated Java Class File For Enumeration - «e.name» ---------------------------------
	'''
	
	def private packageDeclaration() '''
		package «GeneratorData.packageName».«GeneratorConstants.SRC_GEN_ENTITIES»;
	'''
	
	def private enumJavaDoc(Enumeration e) '''
		/**
		 * <!-- begin-user-doc -->
		 * This Class contains the representation of the model object '<em><b«e.name»</b></em>'.
		 * For each Entity the generator creates an EntityGEN.java file,
		 * which contains EntityGEN class with every Property and Association for the Entity.
		 * This Java file will be override, with each generation.
		 * The generator creates an Entity.java file, with the Entity class,
		 * which extends form EntityGEN. This file normally (if the Entity is not deleted)
		 * won't be overrided, so this file can be modified between the generations.
		 * 
		 * <p>
		 * This is The Entity.java file. It is created at the first generation, after that,
		 * it can be modified, it won't be overrided, until the Entity is renamed, or the
		 * Entity is deleted.
		 * </p>
		 * <!-- end-user-doc -->
		 *
		 * <p>
		 * The following features are supported:
		 * <ul>
		 *   <li>{@link hu.bme.hellga.onlab.Entity#getCache <em>Cache</em>}</li>
		 *   <li>{@link hu.bme.hellga.onlab.Entity#getPersistentType <em>Persistent Type</em>}</li>
		 *   <li>{@link hu.bme.hellga.onlab.Entity#isAbstract <em>Abstract</em>}</li>
		 *   <li>{@link hu.bme.hellga.onlab.Entity#getName <em>Name</em>}</li>
		 *   <li>{@link hu.bme.hellga.onlab.Entity#getSuperType <em>Super Type</em>}</li>
		 *   <li>{@link hu.bme.hellga.onlab.Entity#getRelationship <em>Relationship</em>}</li>
		 *   <li>{@link hu.bme.hellga.onlab.Entity#getProperty <em>Property</em>}</li>
		 * </ul>
		 * </p>
		 *
		 * @see hu.bme.hellga.onlab.OnlabPackage#getEntity()
		 * @model
		 * @generated
		 */
	'''
	
	def private enumDeclaration(Enumeration e) '''
		public enum «e.name.toFirstUpper» {
			«FOR f:e.enumeration SEPARATOR ', '»«f.toFirstUpper»«ENDFOR»;
		}
	'''
	
}