package hu.bme.mit.mobilegen.datamodel.generator.database.ormlite

import com.google.inject.Inject
import hu.bme.mit.mobilegen.datamodel.generator.GeneratorData
import hu.bme.mit.mobilegen.datamodel.helper.WrappedEntity
import java.util.List
import org.eclipse.xtext.generator.IFileSystemAccess
import hu.bme.mit.mobilegen.datamodel.generator.DeviceType

class ORMLiteGenerator {
	
	@Inject
	ORMLiteDatabaseHelperGenerator helperGen;
	
	@Inject
	ORMLiteDatabaseFactoryGenerator dbFactoryGen;
	
	@Inject
	ORMLiteDAOFactoryGenerator daoFactoryGen;
	
	@Inject
	ORMLiteDAOInterfaceGenerator daoInterfaceGen;
	
	@Inject
	ORMLiteDAOGenerator daoGen;
	
	@Inject
	ORMLiteDataCacheGenerator dataCacheGen;
	
	List<WrappedEntity> DBEntity;
	
	def generateORMLiteDataAccessLayer(List<WrappedEntity> db, IFileSystemAccess fsa){
		DBEntity = db;
		
		if(GeneratorData.device == DeviceType.Android){
			generateORMDataAccessLayer4Android(DBEntity, fsa);
		}
	}
	
	def private generateORMDataAccessLayer4Android(List<WrappedEntity> entities, IFileSystemAccess fsa){
		
		if(DBEntity.size > 0){
			helperGen.generateDatabaseHelper(entities, fsa);
			dbFactoryGen.generateDatabaseFactory(entities, fsa);
			daoFactoryGen.generateDAOFactory(entities, fsa);
			ORMLiteJarProvider.copyJarFiles(GeneratorData.project);
		}
		
		for(WrappedEntity we : entities){
			daoInterfaceGen.generateDAOInterface(we, fsa);
			daoGen.generateDAO(we, fsa);
		}
		
		if(GeneratorData.cache){
			dataCacheGen.generateDataCache(entities, fsa);
			dataCacheGen.generateGenericDAOInterface(fsa);
			dataCacheGen.generateGenericDAO(fsa);
		}
		
	}
	
}