package hu.bme.mit.mobilegen.datamodel.generator.database.ormlite;

import hu.bme.mit.mobilegen.datamodel.logger.Log;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IFolder;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.FileLocator;

public class ORMLiteJarProvider {

	public static boolean copyJarFiles(IProject project){
		
		URL url;
		URL url2;
		
		try {
			
			Log.info("Copying ORMLite Jar files to target project");
			
	        url = new URL(ORMLiteFilePaths.ORM_LITE_CORE_PATH);
	        url2 = new URL(ORMLiteFilePaths.ORM_LITE_ANDROID_PATH);
	        
	        IFolder folder = project.getFolder(ORMLiteFilePaths.ORM_LITE_JARS);
	        
	        if(!folder.exists()){
	        	Log.error(ORMLiteFilePaths.ORM_LITE_JARS + " folder dos not exists, cant copy jar files");
	        	return false;
	        }
	        
	        boolean first = true;
	        try {
				for(IResource r :folder.members()){
					if(r instanceof IFile){
						if(((IFile)r).getName().contains("ormlite")){
							if(first){
								Log.warning(ORMLiteFilePaths.ORM_LITE_JARS + " folder still contains files that seem to belong to ORMLite - check these files");
								first = false;
							}
							Log.warning(((IFile)r).getName() + " file seems to beleong to ORMLite, maybe another version");
						}
					}
				}
			} catch (CoreException e) {
				Log.error("Error occured during copying jars");
				e.printStackTrace();
				return false;
			}
	        
	        File f1 = null;
	        try {
	        	URL resolvedURL = FileLocator.resolve(url);
	        	
				f1 = new File(new URI(resolvedURL.getProtocol(), resolvedURL.getPath(), null));
			} catch (URISyntaxException e) {
				Log.error("Error occured during copying jars");
				e.printStackTrace();
				return false;
			}

		    IFile file = folder.getFile(ORMLiteFilePaths.ORM_LITE_CORE_NAME);
		    
		    try {
		    	if(file.exists()){
		    		Log.warning("Deleting " + ORMLiteFilePaths.ORM_LITE_CORE_NAME + " file from directory");
		    		
			    	file.delete(IResource.KEEP_HISTORY, null);
			    	
			    	Log.info("Delete successfull");
			    }
		    	Log.info("Copying " + ORMLiteFilePaths.ORM_LITE_CORE_NAME);
		    	
				file.create(new FileInputStream(f1), true, null);
				
				Log.info("Copy successfull");
			} catch (CoreException e) {
				Log.error("Error occured during copying jars");
				e.printStackTrace();
				return false;
			}
		    
		    File f2 = null;
	        try {
	        	URL resolvedURL = FileLocator.resolve(url2);
	        	
				f2 = new File(new URI(resolvedURL.getProtocol(), resolvedURL.getPath(), null));
			} catch (URISyntaxException e1) {
				Log.error("Error occured during copying jars");
				e1.printStackTrace();
				return false;
			}
	        
		    IFile file2 = folder.getFile(ORMLiteFilePaths.ORM_LITE_ANDROID_NAME);
		    try {
		    	if(file2.exists()){
		    		Log.warning("Deleting " + ORMLiteFilePaths.ORM_LITE_ANDROID_NAME + " file from directory");
		    		
			    	file2.delete(IResource.KEEP_HISTORY, null);
			    	
			    	Log.info("Delete successfull");
			    }
		    	Log.info("Copying " + ORMLiteFilePaths.ORM_LITE_ANDROID_NAME);
		    	
				file2.create(new FileInputStream(f2), true, null);
				
				Log.info("Copy successfull");
			} catch (CoreException e) {
				Log.error("Error occured during copying jars");
				e.printStackTrace();
				return false;
			}
		    
		    Log.info("Copying jars was successfull");
		    
		    return true;
	 
		} catch (IOException e) {
			Log.error("Error occured during copying jars");
		    e.printStackTrace();
		    return false;
		}
	}
	
}
