package hu.bme.mit.mobilegen.datamodel.helper;

import hu.bme.mit.mobilegen.datamodel.datamodel.Association;
import hu.bme.mit.mobilegen.datamodel.datamodel.Entity;
import hu.bme.mit.mobilegen.datamodel.datamodel.Enumeration;
import hu.bme.mit.mobilegen.datamodel.datamodel.Property;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

public class EntityCloner {

	public static void cloneEntityWithoutReferences(Entity from, Entity to, Map<String, Enumeration> enums){
		
		to.setOnlyInContainment(from.isOnlyInContainment());
		to.setCache(from.isCache());
		to.setPersistentType(from.getPersistentType());
		to.setAbstract(from.isAbstract());
		to.setName(from.getName());
		
		Iterator<Property> propertyIterator = from.getProperty().iterator();
		List<Property> properties = new ArrayList<Property>();
		
		while(propertyIterator.hasNext()){
			Property p = EntityFactory.getFactory().createProperty();
			cloneProperty(propertyIterator.next(), p, enums);
			properties.add(p);
		}
		
		to.getProperty().addAll(properties);
	}
	
	private static void cloneProperty(Property from, Property to, Map<String, Enumeration> enums){
		to.setCantBeNull(from.isCantBeNull());
		to.setConnectionType(from.getConnectionType());
		to.setIndexed(from.isIndexed());
		to.setName(from.getName());
		to.setTransient(from.isTransient());
		to.setType(from.getType());
		to.setUnique(from.isUnique());
		to.setStatic(from.isStatic());
		if(from.getEnumeration() != null){
			to.setEnumeration(enums.get(from.getEnumeration().getName()));
		}
	}
	
	public static void cloneAssociationWithoutReferences(Association from, Association to){
		to.setCantBeNull(from.isCantBeNull());
		to.setConnectionDir(from.getConnectionDir());
		to.setConnectionType(from.getConnectionType());
		to.setContainment(from.isContainment());
		to.setDirectionSet(from.isDirectionSet());
		to.setName(from.getName());
		to.setTransient(from.isTransient());
		to.setInverseName(from.getInverseName());
		to.setInverseNameSet(from.isInverseNameSet());
		to.setStatic(from.isStatic());
	}
	
	public static void cloneEnumeration(Enumeration from, Enumeration to){
		to.setName(from.getName());
		for(String s : from.getEnumeration()){
			to.getEnumeration().add(s);
		}
	}
	
}
