package hu.bme.mit.mobilegen.datamodel.helper;

import hu.bme.mit.mobilegen.datamodel.datamodel.Association;
import hu.bme.mit.mobilegen.datamodel.datamodel.Entity;
import hu.bme.mit.mobilegen.datamodel.datamodel.PersistentType;
import hu.bme.mit.mobilegen.datamodel.datamodel.Property;

import java.util.ArrayList;
import java.util.List;

public class WrappedEntity {
	
	private String resourceURI;
	private Entity entity = null;
	private PersistentType persistType;
	
	private List<Association> dbManyToOneForeignKeys = null;
	private List<Entity> dbOneToOneForeignKeys = null;
	private List<Association> dbManyToOneForeignKeysCont = null;
	private List<Entity> dbOneToOneForeignKeysCont = null;
	private List<WrappedAssociation> dbManyToOneForeignKeysRev = null;
	private List<Entity> dbOneToOneForeignKeysRev = null;
	private List<Entity> dbManyToOneForeignKeysContRev = null;
	private List<Entity> dbOneToOneForeignKeysContRev = null;
	private List<Association> dbOneToOneForeignKeysInv = null;
	private List<Association> dbOneToOneForeignKeysContInv = null;
	private List<WrappedAssociation> dbOneToOneForeignKeysRevInv = null;
	private List<Entity> dbOneToOneForeignKeysContRevInv = null;
	private List<Entity> dbManyToManyJoinTable = null;
	
	private List<WrappedEntity> subClasses = null;
	private WrappedEntity superClass = null;
	private boolean hasSuperClass = false;
	private boolean hasSubClass = false;
	
	private boolean hasContainment = false;

	private List<Property> requiredProperties = null;
	
	private GeneratorHelper genHelp;
	
	private boolean hasJoinTable = false;
	
	public WrappedEntity(Entity e){
		entity = e;
		
		dbManyToOneForeignKeys = new ArrayList<Association>();
		dbOneToOneForeignKeys = new ArrayList<Entity>();
		dbManyToOneForeignKeysCont = new ArrayList<Association>();
		dbOneToOneForeignKeysCont = new ArrayList<Entity>();
		dbManyToOneForeignKeysRev = new ArrayList<WrappedAssociation>();
		dbOneToOneForeignKeysRev = new ArrayList<Entity>();
		dbManyToOneForeignKeysContRev = new ArrayList<Entity>();
		dbOneToOneForeignKeysContRev = new ArrayList<Entity>();
		dbOneToOneForeignKeysInv = new ArrayList<Association>();
		dbOneToOneForeignKeysContInv = new ArrayList<Association>();
		dbOneToOneForeignKeysRevInv = new ArrayList<WrappedAssociation>();
		dbOneToOneForeignKeysContRevInv = new ArrayList<Entity>();
		
		subClasses = new ArrayList<WrappedEntity>();
		requiredProperties = new ArrayList<Property>();
		dbManyToManyJoinTable = new ArrayList<Entity>();
	}

	public String getResourceURI() {
		return resourceURI;
	}

	public void setResourceURI(String resourceURI) {
		this.resourceURI = resourceURI;
	}

	public Entity getEntity() {
		return entity;
	}

	public void setEntity(Entity entity) {
		this.entity = entity;
	}

	public PersistentType getPersistType() {
		return persistType;
	}

	public void setPersistType(PersistentType persistType) {
		this.persistType = persistType;
	}

	public List<Association> getDbManyToOneForeignKeys() {
		return dbManyToOneForeignKeys;
	}

	public void setDbManyToOneForeignKeys(List<Association> dbManyToOneForeignKeys) {
		this.dbManyToOneForeignKeys = dbManyToOneForeignKeys;
	}

	public List<Entity> getDbOneToOneForeignKeys() {
		return dbOneToOneForeignKeys;
	}

	public void setDbOneToOneForeignKeys(List<Entity> dbOneToOneForeignKeys) {
		this.dbOneToOneForeignKeys = dbOneToOneForeignKeys;
	}

	public List<Association> getDbManyToOneForeignKeysCont() {
		return dbManyToOneForeignKeysCont;
	}

	public void setDbManyToOneForeignKeysCont(
			List<Association> dbManyToOneForeignKeysCont) {
		this.dbManyToOneForeignKeysCont = dbManyToOneForeignKeysCont;
	}

	public List<Entity> getDbOneToOneForeignKeysCont() {
		return dbOneToOneForeignKeysCont;
	}

	public void setDbOneToOneForeignKeysCont(List<Entity> dbOneToOneForeignKeysCont) {
		this.dbOneToOneForeignKeysCont = dbOneToOneForeignKeysCont;
	}

	public List<WrappedAssociation> getDbManyToOneForeignKeysRev() {
		return dbManyToOneForeignKeysRev;
	}

	public void setDbManyToOneForeignKeysRev(
			List<WrappedAssociation> dbManyToOneForeignKeysRev) {
		this.dbManyToOneForeignKeysRev = dbManyToOneForeignKeysRev;
	}

	public List<Entity> getDbOneToOneForeignKeysRev() {
		return dbOneToOneForeignKeysRev;
	}

	public void setDbOneToOneForeignKeysRev(List<Entity> dbOneToOneForeignKeysRev) {
		this.dbOneToOneForeignKeysRev = dbOneToOneForeignKeysRev;
	}

	public List<Entity> getDbManyToOneForeignKeysContRev() {
		return dbManyToOneForeignKeysContRev;
	}

	public void setDbManyToOneForeignKeysContRev(
			List<Entity> dbManyToOneForeignKeysContRev) {
		this.dbManyToOneForeignKeysContRev = dbManyToOneForeignKeysContRev;
	}

	public List<Entity> getDbOneToOneForeignKeysContRev() {
		return dbOneToOneForeignKeysContRev;
	}

	public void setDbOneToOneForeignKeysContRev(
			List<Entity> dbOneToOneForeignKeysContRev) {
		this.dbOneToOneForeignKeysContRev = dbOneToOneForeignKeysContRev;
	}

	public List<Association> getDbOneToOneForeignKeysInv() {
		return dbOneToOneForeignKeysInv;
	}

	public void setDbOneToOneForeignKeysInv(
			List<Association> dbOneToOneForeignKeysInv) {
		this.dbOneToOneForeignKeysInv = dbOneToOneForeignKeysInv;
	}

	public List<Association> getDbOneToOneForeignKeysContInv() {
		return dbOneToOneForeignKeysContInv;
	}

	public void setDbOneToOneForeignKeysContInv(
			List<Association> dbOneToOneForeignKeysContInv) {
		this.dbOneToOneForeignKeysContInv = dbOneToOneForeignKeysContInv;
	}

	public List<WrappedAssociation> getDbOneToOneForeignKeysRevInv() {
		return dbOneToOneForeignKeysRevInv;
	}

	public void setDbOneToOneForeignKeysRevInv(
			List<WrappedAssociation> dbOneToOneForeignKeysRevInv) {
		this.dbOneToOneForeignKeysRevInv = dbOneToOneForeignKeysRevInv;
	}

	public List<Entity> getDbOneToOneForeignKeysContRevInv() {
		return dbOneToOneForeignKeysContRevInv;
	}

	public void setDbOneToOneForeignKeysContRevInv(
			List<Entity> dbOneToOneForeignKeysContRevInv) {
		this.dbOneToOneForeignKeysContRevInv = dbOneToOneForeignKeysContRevInv;
	}

	public List<Entity> getDbManyToManyJoinTable() {
		return dbManyToManyJoinTable;
	}

	public void setDbManyToManyJoinTable(List<Entity> dbManyToManyJoinTable) {
		this.dbManyToManyJoinTable = dbManyToManyJoinTable;
	}

	public List<WrappedEntity> getSubClasses() {
		return subClasses;
	}

	public void setSubClasses(List<WrappedEntity> subClasses) {
		this.subClasses = subClasses;
	}

	public WrappedEntity getSuperClass() {
		return superClass;
	}

	public void setSuperClass(WrappedEntity superClass) {
		this.superClass = superClass;
	}

	public boolean isHasSuperClass() {
		return hasSuperClass;
	}

	public void setHasSuperClass(boolean hasSuperClass) {
		this.hasSuperClass = hasSuperClass;
	}

	public boolean isHasSubClass() {
		return hasSubClass;
	}

	public void setHasSubClass(boolean hasSubClass) {
		this.hasSubClass = hasSubClass;
	}

	public boolean isHasContainment() {
		return hasContainment;
	}

	public void setHasContainment(boolean hasContainment) {
		this.hasContainment = hasContainment;
	}

	public List<Property> getRequiredProperties() {
		return requiredProperties;
	}

	public void setRequiredProperties(List<Property> requiredProperties) {
		this.requiredProperties = requiredProperties;
	}

	public GeneratorHelper getGenHelp() {
		return genHelp;
	}

	public void setGenHelp(GeneratorHelper genHelp) {
		this.genHelp = genHelp;
	}

	public boolean isHasJoinTable() {
		return hasJoinTable;
	}

	public void setHasJoinTable(boolean hasJoinTable) {
		this.hasJoinTable = hasJoinTable;
	}
	
}
