package hu.bme.mit.mobilegen.datamodel.preprocessor;


import hu.bme.mit.mobilegen.datamodel.datamodel.Enumeration;
import hu.bme.mit.mobilegen.datamodel.helper.GeneratorHelper;
import hu.bme.mit.mobilegen.datamodel.helper.WrappedEntity;
import hu.bme.mit.mobilegen.datamodel.logger.Log;

import java.util.List;



public class ModelSorter {
	
	/**
	 * 
	 * Sort model
	 * @param: Processed elements
	 * 
	 */
	public static void sortModel(List<WrappedEntity> all, List<Enumeration> enums, List<WrappedEntity> db, List<WrappedEntity> ser, List<WrappedEntity> pref, List<WrappedEntity> none){
		for(WrappedEntity we : all){
			we.setGenHelp(GeneratorHelper.GEN);
			switch(we.getPersistType()){
				case DB: db.add(we);
					break;
				case SERIALIZE: ser.add(we);
					break;
				case PREFERENCES: pref.add(we);
					break;
				case NONE: none.add(we);
					break;
			}
		}
		
		if(pref.size() > 0){
			Log.info("Found Shared Preferences annotation - SharedPreferences Utility will be created");
		}
		
		Log.info("Model Sorted - NONE: " + none.size() + " SERIALIZE: " + ser.size() + " SHARED PREFERENCES: " + pref.size() + " DB: " + db.size() + " Enumeration: " + enums.size());
	}
	
}
