package hu.bme.mit.mobilegen.datamodel.preprocessor;

import hu.bme.mit.mobilegen.datamodel.datamodel.Enumeration;
import hu.bme.mit.mobilegen.datamodel.helper.WrappedEntity;
import hu.bme.mit.mobilegen.datamodel.helper.WrappedModel;
import hu.bme.mit.mobilegen.datamodel.logger.Log;
import hu.bme.mit.mobilegen.datamodel.preprocessor.database.DBProcessor;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.emf.ecore.resource.ResourceSet;

public class PreProcessor {
	
	private static List<WrappedEntity> wrappedEntities = null;
	private static List<Enumeration> enumerations = null;
	
	private static List<WrappedEntity> DBPersisted = null;
	private static List<WrappedEntity> Serialized = null;
	private static List<WrappedEntity> SharedPreferences = null;
	private static List<WrappedEntity> None = null;
	
	/**
	 * 
	 * Initialize elements
	 * 
	 */
	public static void initialize(){
		wrappedEntities = new ArrayList<WrappedEntity>();
		enumerations = new ArrayList<Enumeration>();
		
		DBPersisted = new ArrayList<WrappedEntity>();
		Serialized = new ArrayList<WrappedEntity>();
		SharedPreferences = new ArrayList<WrappedEntity>();
		None = new ArrayList<WrappedEntity>();
	}
	
	/**
	 * 
	 * PreProcessing model
	 * @param: ResultSet with whole model
	 * 
	 */
	public static WrappedModel preProcessModel(ResourceSet rs){
		initialize();
		
		Log.header("STARTING PRE-PROECESS");
		
		Log.header("STARTING MODEL-WARAPPING");
		
		ModelWrapper.processModel(rs, wrappedEntities, enumerations);
		
		Log.separator();
		Log.header("STARTING ANNOTATION PROCESSING");
		
		AnnotationProcessor.processAnnotations(wrappedEntities);
		
		Log.separator();
		Log.header("STARTING MODEL SORTING");
		
		ModelSorter.sortModel(wrappedEntities, enumerations, DBPersisted, Serialized, SharedPreferences, None);
		
		Log.separator();
		Log.header("STARTING DB PROCESSING");
		
		DBProcessor.processDBEntities(wrappedEntities, DBPersisted);
		
		return new WrappedModel(wrappedEntities, enumerations, DBPersisted, Serialized, SharedPreferences, None);
	}
	
}