package hu.bme.mit.mobilegen.datamodel.validation;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class ReservedStrings {
	
	private static final String[] forbidden = {
		"join"
	};
	
	private static final String[] endings = {
		"dao",
		"factory",
		"gen",
		"interface",
		"helper",
		"unit",
		"inverse"
	};
	
	private static final String[] reserved = {
		"bool",
		"boolean",
		"char",
		"byte",
		"date",
		"string",
		"int",
		"integer",
		"float",
		"double",
		"long",
		"class",
		"id",
		"abstract",
		"continue",
		"for",
		"new",
		"switch",
		"assert",
		"default",
		"goto",
		"package",
		"synchronized",
		"do",
		"if",
		"private",
		"this",
		"break",
		"implements",
		"protected",
		"throw",
		"else",
		"import",
		"public",
		"throws",
		"case",
		"enum",
		"instanceof",
		"return",
		"transient",
		"catch",
		"extends",
		"short",
		"try",
		"final",
		"interface",
		"static",
		"void",
		"class",
		"finally",
		"strictfp",
		"volatile",
		"const",
		"native",
		"super",
		"while",
		"context",
		"ctx",
		"activity",
		"application"
	};
	
	private static List<String> reservedList = null;
	private static List<String> endingList = null;
	private static List<String> forbiddenList = null;
	
	public static List<String> getReservedStrings(){
		if(reservedList == null){
			reservedList = new ArrayList<String>(Arrays.asList(reserved));
		}
		return reservedList;
	}
	
	public static List<String> getReservedEndings(){
		if(endingList == null){
			endingList = new ArrayList<String>(Arrays.asList(endings));
		}
		return endingList;
	}
	
	public static List<String> getForbiddenStrings(){		
		if(forbiddenList == null){
			forbiddenList = new ArrayList<String>(Arrays.asList(forbidden));
		}
		return forbiddenList;
	}
	
}