package hu.bme.mit.mobilegen.datamodel.generator;

import com.google.common.base.Objects;
import com.google.inject.Inject;
import hu.bme.mit.mobilegen.datamodel.datamodel.Enumeration;
import hu.bme.mit.mobilegen.datamodel.generator.GeneratorData;
import hu.bme.mit.mobilegen.datamodel.generator.entity.EntityFactoryGenerator;
import hu.bme.mit.mobilegen.datamodel.generator.entity.EntityGENGenerator;
import hu.bme.mit.mobilegen.datamodel.generator.entity.EntityGenerator;
import hu.bme.mit.mobilegen.datamodel.generator.entity.EnumerationGenerator;
import hu.bme.mit.mobilegen.datamodel.helper.GeneratorHelper;
import hu.bme.mit.mobilegen.datamodel.helper.WrappedEntity;
import hu.bme.mit.mobilegen.datamodel.helper.WrappedModel;
import java.util.List;
import org.eclipse.xtext.generator.IFileSystemAccess;

@SuppressWarnings("all")
public class DatamodelElementGenerator {
  @Inject
  private EntityGENGenerator entityGENGen;
  
  @Inject
  private EntityGenerator entityGen;
  
  @Inject
  private EntityFactoryGenerator entityFactoryGen;
  
  @Inject
  private EnumerationGenerator enumerationGenerator;
  
  public void generateDataModel(final WrappedModel wm, final IFileSystemAccess fsa) {
    List<Enumeration> _enumerations = wm.getEnumerations();
    this.generateEnumerations(_enumerations, fsa);
    List<WrappedEntity> _entities = wm.getEntities();
    this.generateEntities(_entities, fsa);
  }
  
  public void generateEntities(final List<WrappedEntity> entities, final IFileSystemAccess fsa) {
    for (final WrappedEntity we : entities) {
      GeneratorHelper _genHelp = we.getGenHelp();
      boolean _equals = Objects.equal(_genHelp, GeneratorHelper.JoinClass);
      if (_equals) {
        this.entityGENGen.generateEntityGENOnly(we, fsa);
      } else {
        boolean _isGenerateStub = GeneratorData.isGenerateStub();
        if (_isGenerateStub) {
          this.entityGENGen.generateEntityGEN(we, fsa);
          this.entityGen.generateEntity(we, fsa);
        } else {
          this.entityGENGen.generateEntityGENOnly(we, fsa);
        }
      }
    }
    this.entityFactoryGen.generateEntityFactory(entities, fsa);
  }
  
  public void generateEnumerations(final List<Enumeration> enumerations, final IFileSystemAccess fsa) {
    for (final Enumeration e : enumerations) {
      this.enumerationGenerator.generateEnumeration(e, fsa);
    }
  }
}
