package hu.bme.mit.mobilegen.datamodel.generator;

import com.google.inject.Inject;
import hu.bme.mit.mobilegen.datamodel.generator.DatamodelElementGenerator;
import hu.bme.mit.mobilegen.datamodel.generator.IDatamodelGenerator;
import hu.bme.mit.mobilegen.datamodel.generator.database.DatabaseGeneratorMain;
import hu.bme.mit.mobilegen.datamodel.generator.serialize.SerializeGenerator;
import hu.bme.mit.mobilegen.datamodel.generator.sharedpreferences.SharedPreferencesGenerator;
import hu.bme.mit.mobilegen.datamodel.helper.WrappedModel;
import org.eclipse.xtext.generator.IFileSystemAccess;

@SuppressWarnings("all")
public class DatamodelGeneratorMain implements IDatamodelGenerator {
  @Inject
  private DatamodelElementGenerator modelGenerator;
  
  @Inject
  private DatabaseGeneratorMain databaseGenerator;
  
  @Inject
  private SerializeGenerator serializeGenerator;
  
  @Inject
  private SharedPreferencesGenerator sharedPreferencesGenerator;
  
  public void generate(final WrappedModel wm, final IFileSystemAccess fsa) {
    this.modelGenerator.generateDataModel(wm, fsa);
    this.databaseGenerator.generateDataAccessLayer(wm, fsa);
    this.serializeGenerator.generateSerializationUnit(wm, fsa);
    this.sharedPreferencesGenerator.generateSharedPreferencesUnit(wm, fsa);
  }
}
