package hu.bme.mit.mobilegen.datamodel.generator.database.ormlite;

import com.google.common.base.Objects;
import hu.bme.mit.mobilegen.datamodel.datamodel.Association;
import hu.bme.mit.mobilegen.datamodel.datamodel.Entity;
import hu.bme.mit.mobilegen.datamodel.generator.GeneratorConstants;
import hu.bme.mit.mobilegen.datamodel.generator.GeneratorData;
import hu.bme.mit.mobilegen.datamodel.helper.GeneratorHelper;
import hu.bme.mit.mobilegen.datamodel.helper.WrappedAssociation;
import hu.bme.mit.mobilegen.datamodel.helper.WrappedEntity;
import hu.bme.mit.mobilegen.datamodel.logger.Log;
import java.util.ArrayList;
import java.util.List;
import org.eclipse.emf.common.util.EList;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.generator.IFileSystemAccess;
import org.eclipse.xtext.xbase.lib.StringExtensions;

@SuppressWarnings("all")
public class ORMLiteDAOGenerator {
  private WrappedEntity wrappedEntity;
  
  private Entity entity;
  
  private List<String> imports;
  
  public void generateDAO(final WrappedEntity we, final IFileSystemAccess fsa) {
    this.wrappedEntity = we;
    Entity _entity = we.getEntity();
    this.entity = _entity;
    this.collectImports();
    String _name = this.entity.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    String _plus = ("Generating " + _firstUpper);
    String _plus_1 = (_plus + "DAO.java");
    Log.info(_plus_1);
    String _name_1 = this.entity.getName();
    String _firstUpper_1 = StringExtensions.toFirstUpper(_name_1);
    String _plus_2 = (_firstUpper_1 + "DAO.java");
    CharSequence _generateDAO = this.generateDAO(this.entity);
    fsa.generateFile(_plus_2, GeneratorConstants.SRC_GEN_DB, _generateDAO);
  }
  
  private boolean collectImports() {
    boolean _xblockexpression = false;
    {
      ArrayList<String> _arrayList = new ArrayList<String>();
      this.imports = _arrayList;
      String _packageName = GeneratorData.getPackageName();
      String _plus = (_packageName + ".entities.");
      Entity _entity = this.wrappedEntity.getEntity();
      String _name = _entity.getName();
      String _firstUpper = StringExtensions.toFirstUpper(_name);
      String _plus_1 = (_plus + _firstUpper);
      this.imports.add(_plus_1);
      List<Association> _dbManyToOneForeignKeysCont = this.wrappedEntity.getDbManyToOneForeignKeysCont();
      for (final Association a : _dbManyToOneForeignKeysCont) {
        String _packageName_1 = GeneratorData.getPackageName();
        String _plus_2 = (_packageName_1 + ".entities.");
        Entity _connectTo = a.getConnectTo();
        String _name_1 = _connectTo.getName();
        String _firstUpper_1 = StringExtensions.toFirstUpper(_name_1);
        String _plus_3 = (_plus_2 + _firstUpper_1);
        this.imports.add(_plus_3);
      }
      List<Association> _dbOneToOneForeignKeysContInv = this.wrappedEntity.getDbOneToOneForeignKeysContInv();
      for (final Association a_1 : _dbOneToOneForeignKeysContInv) {
        String _packageName_2 = GeneratorData.getPackageName();
        String _plus_4 = (_packageName_2 + ".entities.");
        Entity _connectTo_1 = a_1.getConnectTo();
        String _name_2 = _connectTo_1.getName();
        String _firstUpper_2 = StringExtensions.toFirstUpper(_name_2);
        String _plus_5 = (_plus_4 + _firstUpper_2);
        this.imports.add(_plus_5);
      }
      List<Association> _dbManyToOneForeignKeys = this.wrappedEntity.getDbManyToOneForeignKeys();
      for (final Association a_2 : _dbManyToOneForeignKeys) {
        String _packageName_3 = GeneratorData.getPackageName();
        String _plus_6 = (_packageName_3 + ".entities.");
        Entity _connectTo_2 = a_2.getConnectTo();
        String _name_3 = _connectTo_2.getName();
        String _firstUpper_3 = StringExtensions.toFirstUpper(_name_3);
        String _plus_7 = (_plus_6 + _firstUpper_3);
        this.imports.add(_plus_7);
      }
      List<Association> _dbOneToOneForeignKeysInv = this.wrappedEntity.getDbOneToOneForeignKeysInv();
      for (final Association a_3 : _dbOneToOneForeignKeysInv) {
        String _packageName_4 = GeneratorData.getPackageName();
        String _plus_8 = (_packageName_4 + ".entities.");
        Entity _connectTo_3 = a_3.getConnectTo();
        String _name_4 = _connectTo_3.getName();
        String _firstUpper_4 = StringExtensions.toFirstUpper(_name_4);
        String _plus_9 = (_plus_8 + _firstUpper_4);
        this.imports.add(_plus_9);
      }
      List<Entity> _dbManyToOneForeignKeysContRev = this.wrappedEntity.getDbManyToOneForeignKeysContRev();
      for (final Entity e : _dbManyToOneForeignKeysContRev) {
        String _packageName_5 = GeneratorData.getPackageName();
        String _plus_10 = (_packageName_5 + ".entities.");
        String _name_5 = e.getName();
        String _firstUpper_5 = StringExtensions.toFirstUpper(_name_5);
        String _plus_11 = (_plus_10 + _firstUpper_5);
        this.imports.add(_plus_11);
      }
      List<Entity> _dbOneToOneForeignKeysContRevInv = this.wrappedEntity.getDbOneToOneForeignKeysContRevInv();
      for (final Entity e_1 : _dbOneToOneForeignKeysContRevInv) {
        String _packageName_6 = GeneratorData.getPackageName();
        String _plus_12 = (_packageName_6 + ".entities.");
        String _name_6 = e_1.getName();
        String _firstUpper_6 = StringExtensions.toFirstUpper(_name_6);
        String _plus_13 = (_plus_12 + _firstUpper_6);
        this.imports.add(_plus_13);
      }
      List<WrappedAssociation> _dbManyToOneForeignKeysRev = this.wrappedEntity.getDbManyToOneForeignKeysRev();
      for (final WrappedAssociation wa : _dbManyToOneForeignKeysRev) {
        String _packageName_7 = GeneratorData.getPackageName();
        String _plus_14 = (_packageName_7 + ".entities.");
        Entity _container = wa.getContainer();
        String _name_7 = _container.getName();
        String _firstUpper_7 = StringExtensions.toFirstUpper(_name_7);
        String _plus_15 = (_plus_14 + _firstUpper_7);
        this.imports.add(_plus_15);
      }
      List<WrappedAssociation> _dbOneToOneForeignKeysRevInv = this.wrappedEntity.getDbOneToOneForeignKeysRevInv();
      for (final WrappedAssociation wa_1 : _dbOneToOneForeignKeysRevInv) {
        String _packageName_8 = GeneratorData.getPackageName();
        String _plus_16 = (_packageName_8 + ".entities.");
        Entity _container_1 = wa_1.getContainer();
        String _name_8 = _container_1.getName();
        String _firstUpper_8 = StringExtensions.toFirstUpper(_name_8);
        String _plus_17 = (_plus_16 + _firstUpper_8);
        this.imports.add(_plus_17);
      }
      List<Entity> _dbManyToManyJoinTable = this.wrappedEntity.getDbManyToManyJoinTable();
      for (final Entity e_2 : _dbManyToManyJoinTable) {
        EList<Association> _association = e_2.getAssociation();
        for (final Association a_4 : _association) {
          Entity _connectTo_4 = a_4.getConnectTo();
          String _name_9 = _connectTo_4.getName();
          String _name_10 = this.entity.getName();
          boolean _equals = _name_9.equals(_name_10);
          boolean _not = (!_equals);
          if (_not) {
            String _packageName_9 = GeneratorData.getPackageName();
            String _plus_18 = (_packageName_9 + ".entities.");
            Entity _connectTo_5 = a_4.getConnectTo();
            String _name_11 = _connectTo_5.getName();
            String _firstUpper_9 = StringExtensions.toFirstUpper(_name_11);
            String _plus_19 = (_plus_18 + _firstUpper_9);
            this.imports.add(_plus_19);
          }
        }
      }
      this.imports.add("java.util.List");
      this.imports.add("com.j256.ormlite.dao.Dao");
      this.imports.add("java.sql.SQLException");
      boolean _xifexpression = false;
      boolean _isHasJoinTable = this.wrappedEntity.isHasJoinTable();
      if (_isHasJoinTable) {
        _xifexpression = this.imports.add("java.util.ArrayList");
      }
      _xblockexpression = _xifexpression;
    }
    return _xblockexpression;
  }
  
  private CharSequence generateDAO(final Entity e) {
    StringConcatenation _builder = new StringConcatenation();
    CharSequence _classHeader = this.classHeader(e);
    _builder.append(_classHeader, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _packageDeclaration = this.packageDeclaration();
    _builder.append(_packageDeclaration, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _classImports = this.classImports(e);
    _builder.append(_classImports, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("//");
    _builder.newLine();
    CharSequence _classDeclaration = this.classDeclaration(e);
    _builder.append(_classDeclaration, "");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence classHeader(final Entity e) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//------------------------- Geneated Java Class File For ");
    String _name = e.getName();
    _builder.append(_name, "");
    _builder.append("DAO Class ---------------------------------");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence packageDeclaration() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("package ");
    String _packageName = GeneratorData.getPackageName();
    _builder.append(_packageName, "");
    _builder.append(".");
    _builder.append(GeneratorConstants.SRC_GEN_DB, "");
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence classImports(final Entity e) {
    StringConcatenation _builder = new StringConcatenation();
    {
      for(final String f : this.imports) {
        _builder.append("import ");
        _builder.append(f, "");
        _builder.append(";");
        _builder.newLineIfNotEmpty();
      }
    }
    return _builder;
  }
  
  private CharSequence classJavaDoc(final Entity e) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("/**");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <!-- begin-user-doc -->");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* This Class contains the representation of the model object \'<em><b></b></em>\'.");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* For each Entity the generator creates an EntityGEN.java file,");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* which contains EntityGEN class with every Property and Association for the Entity.");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* This Java file will be override, with each generation.");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* The generator creates an Entity.java file, with the Entity class,");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* which extends form EntityGEN. This file normally (if the Entity is not deleted)");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* won\'t be overrided, so this file can be modified between the generations.");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* ");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* This is The EntityGEN.java file. It must contain only the generated code.");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* Do not edit it, or it will be overrided with each generation!");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* </p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <!-- end-user-doc -->");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* The following features are supported:");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <ul>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getCache <em>Cache</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getPersistentType <em>Persistent Type</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#isAbstract <em>Abstract</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getName <em>Name</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getSuperType <em>Super Type</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getRelationship <em>Relationship</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getProperty <em>Property</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* </ul>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* </p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* @see hu.bme.hellga.onlab.OnlabPackage#getEntity()");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* @model");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* @generated");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*/");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence classDeclaration(final Entity e) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("public class ");
    String _name = e.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    _builder.append(_firstUpper, "");
    _builder.append("DAO implements ");
    String _name_1 = e.getName();
    String _firstUpper_1 = StringExtensions.toFirstUpper(_name_1);
    _builder.append(_firstUpper_1, "");
    _builder.append("DAOInterface {");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    CharSequence _classBody = this.classBody(e);
    _builder.append(_classBody, "\t");
    _builder.newLineIfNotEmpty();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence classBody(final Entity e) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("// Property declarations");
    _builder.newLine();
    _builder.newLine();
    CharSequence _properties = this.properties(e);
    _builder.append(_properties, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("// Constructor");
    _builder.newLine();
    _builder.newLine();
    CharSequence _constructor = this.constructor(e);
    _builder.append(_constructor, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _body = this.body(e);
    _builder.append(_body, "");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence properties(final Entity e) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//");
    _builder.newLine();
    _builder.append("private static Dao<");
    String _name = e.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    _builder.append(_firstUpper, "");
    _builder.append(", Integer> ");
    String _name_1 = e.getName();
    String _firstLower = StringExtensions.toFirstLower(_name_1);
    _builder.append(_firstLower, "");
    _builder.append("DAO = null;");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence constructor(final Entity e) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("public ");
    String _name = e.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    _builder.append(_firstUpper, "");
    _builder.append("DAO(){");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("try {");
    _builder.newLine();
    _builder.append("\t\t");
    String _name_1 = e.getName();
    String _firstLower = StringExtensions.toFirstLower(_name_1);
    _builder.append(_firstLower, "\t\t");
    _builder.append("DAO = DatabaseFactory.get");
    String _name_2 = e.getName();
    String _firstUpper_1 = StringExtensions.toFirstUpper(_name_2);
    _builder.append(_firstUpper_1, "\t\t");
    _builder.append("DAO();");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("} catch (SQLException e) {");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("e.printStackTrace();");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence body(final Entity e) {
    StringConcatenation _builder = new StringConcatenation();
    CharSequence _create = this.create(e);
    _builder.append(_create, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _update = this.update(e);
    _builder.append(_update, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _deleteOne = this.deleteOne(e);
    _builder.append(_deleteOne, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _deleteMore = this.deleteMore(e);
    _builder.append(_deleteMore, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _refresh = this.refresh(e);
    _builder.append(_refresh, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _all = this.getAll(e);
    _builder.append(_all, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _byContainment = this.getByContainment(e);
    _builder.append(_byContainment, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _byReference = this.getByReference(e);
    _builder.append(_byReference, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _byID = this.getByID(e);
    _builder.append(_byID, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _dao = this.dao(e);
    _builder.append(_dao, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _others = this.others(this.wrappedEntity);
    _builder.append(_others, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence create(final Entity e) {
    StringConcatenation _builder = new StringConcatenation();
    {
      List<Association> _dbManyToOneForeignKeysCont = this.wrappedEntity.getDbManyToOneForeignKeysCont();
      for(final Association f : _dbManyToOneForeignKeysCont) {
        _builder.append("@Override");
        _builder.newLine();
        _builder.append("public boolean create");
        String _name = e.getName();
        String _firstUpper = StringExtensions.toFirstUpper(_name);
        _builder.append(_firstUpper, "");
        _builder.append("(");
        Entity _connectTo = f.getConnectTo();
        String _name_1 = _connectTo.getName();
        String _firstUpper_1 = StringExtensions.toFirstUpper(_name_1);
        _builder.append(_firstUpper_1, "");
        _builder.append(" ");
        Entity _connectTo_1 = f.getConnectTo();
        String _name_2 = _connectTo_1.getName();
        String _firstLower = StringExtensions.toFirstLower(_name_2);
        _builder.append(_firstLower, "");
        _builder.append(", ");
        String _name_3 = e.getName();
        String _firstUpper_2 = StringExtensions.toFirstUpper(_name_3);
        _builder.append(_firstUpper_2, "");
        _builder.append(" ");
        String _name_4 = e.getName();
        String _firstLower_1 = StringExtensions.toFirstLower(_name_4);
        _builder.append(_firstLower_1, "");
        _builder.append(") {");
        _builder.newLineIfNotEmpty();
        _builder.append("\t");
        _builder.append("try {");
        _builder.newLine();
        _builder.append("\t\t");
        String _name_5 = e.getName();
        String _firstLower_2 = StringExtensions.toFirstLower(_name_5);
        _builder.append(_firstLower_2, "\t\t");
        _builder.append(".set");
        String _name_6 = f.getName();
        String _firstUpper_3 = StringExtensions.toFirstUpper(_name_6);
        _builder.append(_firstUpper_3, "\t\t");
        _builder.append("(");
        Entity _connectTo_2 = f.getConnectTo();
        String _name_7 = _connectTo_2.getName();
        String _firstLower_3 = StringExtensions.toFirstLower(_name_7);
        _builder.append(_firstLower_3, "\t\t");
        _builder.append(");");
        _builder.newLineIfNotEmpty();
        _builder.append("\t\t");
        String _name_8 = e.getName();
        String _firstLower_4 = StringExtensions.toFirstLower(_name_8);
        _builder.append(_firstLower_4, "\t\t");
        _builder.append("DAO.create(");
        String _name_9 = e.getName();
        String _firstLower_5 = StringExtensions.toFirstLower(_name_9);
        _builder.append(_firstLower_5, "\t\t");
        _builder.append(");");
        _builder.newLineIfNotEmpty();
        _builder.append("\t");
        _builder.append("} catch (SQLException e) {");
        _builder.newLine();
        _builder.append("\t\t");
        _builder.append("e.printStackTrace();");
        _builder.newLine();
        _builder.append("\t\t");
        _builder.append("return false;");
        _builder.newLine();
        _builder.append("\t");
        _builder.append("}");
        _builder.newLine();
        _builder.append("\t");
        _builder.append("return true;");
        _builder.newLine();
        _builder.append("}");
        _builder.newLine();
      }
    }
    {
      List<Association> _dbOneToOneForeignKeysContInv = this.wrappedEntity.getDbOneToOneForeignKeysContInv();
      for(final Association f_1 : _dbOneToOneForeignKeysContInv) {
        _builder.append("@Override");
        _builder.newLine();
        _builder.append("public boolean create");
        String _name_10 = e.getName();
        String _firstUpper_4 = StringExtensions.toFirstUpper(_name_10);
        _builder.append(_firstUpper_4, "");
        _builder.append("(");
        Entity _connectTo_3 = f_1.getConnectTo();
        String _name_11 = _connectTo_3.getName();
        String _firstUpper_5 = StringExtensions.toFirstUpper(_name_11);
        _builder.append(_firstUpper_5, "");
        _builder.append(" ");
        Entity _connectTo_4 = f_1.getConnectTo();
        String _name_12 = _connectTo_4.getName();
        String _firstLower_6 = StringExtensions.toFirstLower(_name_12);
        _builder.append(_firstLower_6, "");
        _builder.append(", ");
        String _name_13 = e.getName();
        String _firstUpper_6 = StringExtensions.toFirstUpper(_name_13);
        _builder.append(_firstUpper_6, "");
        _builder.append(" ");
        String _name_14 = e.getName();
        String _firstLower_7 = StringExtensions.toFirstLower(_name_14);
        _builder.append(_firstLower_7, "");
        _builder.append(") {");
        _builder.newLineIfNotEmpty();
        _builder.append("\t");
        _builder.append("try {");
        _builder.newLine();
        _builder.append("\t\t");
        String _name_15 = e.getName();
        String _firstLower_8 = StringExtensions.toFirstLower(_name_15);
        _builder.append(_firstLower_8, "\t\t");
        _builder.append(".set");
        String _name_16 = f_1.getName();
        String _firstUpper_7 = StringExtensions.toFirstUpper(_name_16);
        _builder.append(_firstUpper_7, "\t\t");
        _builder.append("(");
        Entity _connectTo_5 = f_1.getConnectTo();
        String _name_17 = _connectTo_5.getName();
        String _firstLower_9 = StringExtensions.toFirstLower(_name_17);
        _builder.append(_firstLower_9, "\t\t");
        _builder.append(");");
        _builder.newLineIfNotEmpty();
        _builder.append("\t\t");
        String _name_18 = e.getName();
        String _firstLower_10 = StringExtensions.toFirstLower(_name_18);
        _builder.append(_firstLower_10, "\t\t");
        _builder.append("DAO.create(");
        String _name_19 = e.getName();
        String _firstLower_11 = StringExtensions.toFirstLower(_name_19);
        _builder.append(_firstLower_11, "\t\t");
        _builder.append(");");
        _builder.newLineIfNotEmpty();
        _builder.append("\t");
        _builder.append("} catch (SQLException e) {");
        _builder.newLine();
        _builder.append("\t\t");
        _builder.append("e.printStackTrace();");
        _builder.newLine();
        _builder.append("\t\t");
        _builder.append("return false;");
        _builder.newLine();
        _builder.append("\t");
        _builder.append("}");
        _builder.newLine();
        _builder.append("\t");
        _builder.append("return true;");
        _builder.newLine();
        _builder.append("}");
        _builder.newLine();
      }
    }
    {
      boolean _isOnlyInContainment = e.isOnlyInContainment();
      boolean _not = (!_isOnlyInContainment);
      if (_not) {
        _builder.append("@Override");
        _builder.newLine();
        _builder.append("\t");
        _builder.append("public boolean create");
        String _name_20 = e.getName();
        String _firstUpper_8 = StringExtensions.toFirstUpper(_name_20);
        _builder.append(_firstUpper_8, "\t");
        _builder.append("(");
        String _name_21 = e.getName();
        String _firstUpper_9 = StringExtensions.toFirstUpper(_name_21);
        _builder.append(_firstUpper_9, "\t");
        _builder.append(" ");
        String _name_22 = e.getName();
        String _firstLower_12 = StringExtensions.toFirstLower(_name_22);
        _builder.append(_firstLower_12, "\t");
        _builder.append("){");
        _builder.newLineIfNotEmpty();
        _builder.append("\t\t");
        _builder.append("try {");
        _builder.newLine();
        _builder.append("\t\t\t");
        String _name_23 = e.getName();
        String _firstLower_13 = StringExtensions.toFirstLower(_name_23);
        _builder.append(_firstLower_13, "\t\t\t");
        _builder.append("DAO.create(");
        String _name_24 = e.getName();
        String _firstLower_14 = StringExtensions.toFirstLower(_name_24);
        _builder.append(_firstLower_14, "\t\t\t");
        _builder.append(");");
        _builder.newLineIfNotEmpty();
        _builder.append("\t\t");
        _builder.append("} catch (SQLException e) {");
        _builder.newLine();
        _builder.append("\t\t\t");
        _builder.append("e.printStackTrace();");
        _builder.newLine();
        _builder.append("\t\t\t");
        _builder.append("return false;");
        _builder.newLine();
        _builder.append("\t\t");
        _builder.append("}");
        _builder.newLine();
        _builder.append("\t\t");
        _builder.append("return true;");
        _builder.newLine();
        _builder.append("\t");
        _builder.append("}");
        _builder.newLine();
      }
    }
    return _builder;
  }
  
  private CharSequence update(final Entity e) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("@Override");
    _builder.newLine();
    _builder.append("public boolean update");
    String _name = e.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    _builder.append(_firstUpper, "");
    _builder.append("(");
    String _name_1 = e.getName();
    String _firstUpper_1 = StringExtensions.toFirstUpper(_name_1);
    _builder.append(_firstUpper_1, "");
    _builder.append(" ");
    String _name_2 = e.getName();
    String _firstLower = StringExtensions.toFirstLower(_name_2);
    _builder.append(_firstLower, "");
    _builder.append(") {");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("try {");
    _builder.newLine();
    _builder.append("\t\t");
    String _name_3 = e.getName();
    String _firstLower_1 = StringExtensions.toFirstLower(_name_3);
    _builder.append(_firstLower_1, "\t\t");
    _builder.append("DAO.update(");
    String _name_4 = e.getName();
    String _firstLower_2 = StringExtensions.toFirstLower(_name_4);
    _builder.append(_firstLower_2, "\t\t");
    _builder.append(");");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("} catch (SQLException e) {");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("e.printStackTrace();");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("return false;");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("return true;");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence deleteOne(final Entity e) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("public boolean delete");
    String _name = e.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    _builder.append(_firstUpper, "");
    _builder.append("(");
    String _name_1 = e.getName();
    String _firstUpper_1 = StringExtensions.toFirstUpper(_name_1);
    _builder.append(_firstUpper_1, "");
    _builder.append(" ");
    String _name_2 = e.getName();
    String _firstLower = StringExtensions.toFirstLower(_name_2);
    _builder.append(_firstLower, "");
    _builder.append(") {");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("try {");
    _builder.newLine();
    {
      List<Entity> _dbManyToOneForeignKeysContRev = this.wrappedEntity.getDbManyToOneForeignKeysContRev();
      for(final Entity f : _dbManyToOneForeignKeysContRev) {
        _builder.append("\t\t");
        _builder.append("List<");
        String _name_3 = f.getName();
        String _firstUpper_2 = StringExtensions.toFirstUpper(_name_3);
        _builder.append(_firstUpper_2, "\t\t");
        _builder.append("> ");
        String _name_4 = f.getName();
        String _firstLower_1 = StringExtensions.toFirstLower(_name_4);
        _builder.append(_firstLower_1, "\t\t");
        _builder.append("list = DAOFactory.get");
        String _name_5 = f.getName();
        String _firstUpper_3 = StringExtensions.toFirstUpper(_name_5);
        _builder.append(_firstUpper_3, "\t\t");
        _builder.append("DAO().get");
        String _name_6 = f.getName();
        String _firstUpper_4 = StringExtensions.toFirstUpper(_name_6);
        _builder.append(_firstUpper_4, "\t\t");
        _builder.append("sBy");
        String _name_7 = e.getName();
        String _firstUpper_5 = StringExtensions.toFirstUpper(_name_7);
        _builder.append(_firstUpper_5, "\t\t");
        _builder.append("Containment(");
        String _name_8 = e.getName();
        String _firstLower_2 = StringExtensions.toFirstLower(_name_8);
        _builder.append(_firstLower_2, "\t\t");
        _builder.append(");");
        _builder.newLineIfNotEmpty();
        _builder.append("\t\t");
        _builder.append("DAOFactory.get");
        String _name_9 = f.getName();
        String _firstUpper_6 = StringExtensions.toFirstUpper(_name_9);
        _builder.append(_firstUpper_6, "\t\t");
        _builder.append("DAO().delete");
        String _name_10 = f.getName();
        String _firstUpper_7 = StringExtensions.toFirstUpper(_name_10);
        _builder.append(_firstUpper_7, "\t\t");
        _builder.append("s(");
        String _name_11 = f.getName();
        String _firstLower_3 = StringExtensions.toFirstLower(_name_11);
        _builder.append(_firstLower_3, "\t\t");
        _builder.append("list);");
        _builder.newLineIfNotEmpty();
        _builder.append("\t\t");
        _builder.newLine();
      }
    }
    {
      List<Entity> _dbOneToOneForeignKeysContRevInv = this.wrappedEntity.getDbOneToOneForeignKeysContRevInv();
      for(final Entity f_1 : _dbOneToOneForeignKeysContRevInv) {
        _builder.append("\t\t");
        String _name_12 = f_1.getName();
        String _firstUpper_8 = StringExtensions.toFirstUpper(_name_12);
        _builder.append(_firstUpper_8, "\t\t");
        _builder.append(" ");
        String _name_13 = f_1.getName();
        String _firstLower_4 = StringExtensions.toFirstLower(_name_13);
        _builder.append(_firstLower_4, "\t\t");
        _builder.append(" = DAOFactory.get");
        String _name_14 = f_1.getName();
        String _firstUpper_9 = StringExtensions.toFirstUpper(_name_14);
        _builder.append(_firstUpper_9, "\t\t");
        _builder.append("DAO().get");
        String _name_15 = f_1.getName();
        String _firstUpper_10 = StringExtensions.toFirstUpper(_name_15);
        _builder.append(_firstUpper_10, "\t\t");
        _builder.append("By");
        String _name_16 = e.getName();
        String _firstUpper_11 = StringExtensions.toFirstUpper(_name_16);
        _builder.append(_firstUpper_11, "\t\t");
        _builder.append("Containment(");
        String _name_17 = e.getName();
        String _firstLower_5 = StringExtensions.toFirstLower(_name_17);
        _builder.append(_firstLower_5, "\t\t");
        _builder.append(");");
        _builder.newLineIfNotEmpty();
        _builder.append("\t\t");
        _builder.append("DAOFactory.get");
        String _name_18 = f_1.getName();
        String _firstUpper_12 = StringExtensions.toFirstUpper(_name_18);
        _builder.append(_firstUpper_12, "\t\t");
        _builder.append("DAO().delete");
        String _name_19 = f_1.getName();
        String _firstUpper_13 = StringExtensions.toFirstUpper(_name_19);
        _builder.append(_firstUpper_13, "\t\t");
        _builder.append("(");
        String _name_20 = f_1.getName();
        String _firstLower_6 = StringExtensions.toFirstLower(_name_20);
        _builder.append(_firstLower_6, "\t\t");
        _builder.append(");");
        _builder.newLineIfNotEmpty();
        _builder.append("\t\t");
        _builder.newLine();
      }
    }
    {
      List<WrappedAssociation> _dbManyToOneForeignKeysRev = this.wrappedEntity.getDbManyToOneForeignKeysRev();
      for(final WrappedAssociation f_2 : _dbManyToOneForeignKeysRev) {
        _builder.append("\t\t");
        _builder.append("List<");
        Entity _container = f_2.getContainer();
        String _name_21 = _container.getName();
        String _firstUpper_14 = StringExtensions.toFirstUpper(_name_21);
        _builder.append(_firstUpper_14, "\t\t");
        _builder.append("> ");
        Entity _container_1 = f_2.getContainer();
        String _name_22 = _container_1.getName();
        String _firstLower_7 = StringExtensions.toFirstLower(_name_22);
        _builder.append(_firstLower_7, "\t\t");
        _builder.append("list = DAOFactory.get");
        Entity _container_2 = f_2.getContainer();
        String _name_23 = _container_2.getName();
        String _firstUpper_15 = StringExtensions.toFirstUpper(_name_23);
        _builder.append(_firstUpper_15, "\t\t");
        _builder.append("DAO().get");
        Entity _container_3 = f_2.getContainer();
        String _name_24 = _container_3.getName();
        String _firstUpper_16 = StringExtensions.toFirstUpper(_name_24);
        _builder.append(_firstUpper_16, "\t\t");
        _builder.append("sBy");
        String _name_25 = e.getName();
        String _firstUpper_17 = StringExtensions.toFirstUpper(_name_25);
        _builder.append(_firstUpper_17, "\t\t");
        _builder.append("Reference(");
        String _name_26 = e.getName();
        String _firstLower_8 = StringExtensions.toFirstLower(_name_26);
        _builder.append(_firstLower_8, "\t\t");
        _builder.append(");");
        _builder.newLineIfNotEmpty();
        _builder.append("\t\t");
        _builder.newLine();
        _builder.append("\t\t");
        _builder.append("for(");
        Entity _container_4 = f_2.getContainer();
        String _name_27 = _container_4.getName();
        String _firstUpper_18 = StringExtensions.toFirstUpper(_name_27);
        _builder.append(_firstUpper_18, "\t\t");
        _builder.append(" ");
        Entity _container_5 = f_2.getContainer();
        String _name_28 = _container_5.getName();
        String _substring = _name_28.substring(0, 1);
        String _firstLower_9 = StringExtensions.toFirstLower(_substring);
        _builder.append(_firstLower_9, "\t\t");
        _builder.append(" : ");
        Entity _container_6 = f_2.getContainer();
        String _name_29 = _container_6.getName();
        String _firstLower_10 = StringExtensions.toFirstLower(_name_29);
        _builder.append(_firstLower_10, "\t\t");
        _builder.append("list){");
        _builder.newLineIfNotEmpty();
        _builder.append("\t\t");
        _builder.append("\t");
        Entity _container_7 = f_2.getContainer();
        String _name_30 = _container_7.getName();
        String _substring_1 = _name_30.substring(0, 1);
        String _firstLower_11 = StringExtensions.toFirstLower(_substring_1);
        _builder.append(_firstLower_11, "\t\t\t");
        _builder.append(".set");
        Association _association = f_2.getAssociation();
        String _name_31 = _association.getName();
        String _firstUpper_19 = StringExtensions.toFirstUpper(_name_31);
        _builder.append(_firstUpper_19, "\t\t\t");
        _builder.append("(null);");
        _builder.newLineIfNotEmpty();
        _builder.append("\t\t");
        _builder.append("}");
        _builder.newLine();
        _builder.append("\t\t");
        _builder.newLine();
      }
    }
    {
      List<WrappedAssociation> _dbOneToOneForeignKeysRevInv = this.wrappedEntity.getDbOneToOneForeignKeysRevInv();
      for(final WrappedAssociation f_3 : _dbOneToOneForeignKeysRevInv) {
        _builder.append("\t\t");
        Entity _container_8 = f_3.getContainer();
        String _name_32 = _container_8.getName();
        String _firstUpper_20 = StringExtensions.toFirstUpper(_name_32);
        _builder.append(_firstUpper_20, "\t\t");
        _builder.append(" ");
        Entity _container_9 = f_3.getContainer();
        String _name_33 = _container_9.getName();
        String _firstLower_12 = StringExtensions.toFirstLower(_name_33);
        _builder.append(_firstLower_12, "\t\t");
        _builder.append(" = DAOFactory.get");
        Entity _container_10 = f_3.getContainer();
        String _name_34 = _container_10.getName();
        String _firstUpper_21 = StringExtensions.toFirstUpper(_name_34);
        _builder.append(_firstUpper_21, "\t\t");
        _builder.append("DAO().get");
        Entity _container_11 = f_3.getContainer();
        String _name_35 = _container_11.getName();
        String _firstUpper_22 = StringExtensions.toFirstUpper(_name_35);
        _builder.append(_firstUpper_22, "\t\t");
        _builder.append("By");
        String _name_36 = e.getName();
        String _firstUpper_23 = StringExtensions.toFirstUpper(_name_36);
        _builder.append(_firstUpper_23, "\t\t");
        _builder.append("Reference(");
        String _name_37 = e.getName();
        String _firstLower_13 = StringExtensions.toFirstLower(_name_37);
        _builder.append(_firstLower_13, "\t\t");
        _builder.append(");");
        _builder.newLineIfNotEmpty();
        _builder.append("\t\t");
        Entity _container_12 = f_3.getContainer();
        String _name_38 = _container_12.getName();
        String _firstLower_14 = StringExtensions.toFirstLower(_name_38);
        _builder.append(_firstLower_14, "\t\t");
        _builder.append(".set");
        Association _association_1 = f_3.getAssociation();
        String _name_39 = _association_1.getName();
        String _firstUpper_24 = StringExtensions.toFirstUpper(_name_39);
        _builder.append(_firstUpper_24, "\t\t");
        _builder.append("(null);");
        _builder.newLineIfNotEmpty();
        _builder.append("\t\t");
        _builder.newLine();
      }
    }
    _builder.append("\t\t");
    String _name_40 = e.getName();
    String _firstLower_15 = StringExtensions.toFirstLower(_name_40);
    _builder.append(_firstLower_15, "\t\t");
    _builder.append("DAO.delete(");
    String _name_41 = e.getName();
    String _firstLower_16 = StringExtensions.toFirstLower(_name_41);
    _builder.append(_firstLower_16, "\t\t");
    _builder.append(");");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("} catch (SQLException e) {");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("e.printStackTrace();");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("return false;");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("return true;");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence deleteMore(final Entity e) {
    StringConcatenation _builder = new StringConcatenation();
    {
      boolean _isHasContainment = this.wrappedEntity.isHasContainment();
      if (_isHasContainment) {
        _builder.append("public boolean delete");
        String _name = e.getName();
        String _firstUpper = StringExtensions.toFirstUpper(_name);
        _builder.append(_firstUpper, "");
        _builder.append("s(List<");
        String _name_1 = e.getName();
        String _firstUpper_1 = StringExtensions.toFirstUpper(_name_1);
        _builder.append(_firstUpper_1, "");
        _builder.append("> ");
        String _name_2 = e.getName();
        String _firstLower = StringExtensions.toFirstLower(_name_2);
        _builder.append(_firstLower, "");
        _builder.append("s) {");
        _builder.newLineIfNotEmpty();
        _builder.append("\t");
        _builder.append("try {");
        _builder.newLine();
        _builder.append("\t\t");
        _builder.append("for(");
        String _name_3 = e.getName();
        String _firstUpper_2 = StringExtensions.toFirstUpper(_name_3);
        _builder.append(_firstUpper_2, "\t\t");
        _builder.append(" ");
        String _name_4 = e.getName();
        String _firstLower_1 = StringExtensions.toFirstLower(_name_4);
        _builder.append(_firstLower_1, "\t\t");
        _builder.append(" : ");
        String _name_5 = e.getName();
        String _firstLower_2 = StringExtensions.toFirstLower(_name_5);
        _builder.append(_firstLower_2, "\t\t");
        _builder.append("s){");
        _builder.newLineIfNotEmpty();
        {
          List<Entity> _dbManyToOneForeignKeysContRev = this.wrappedEntity.getDbManyToOneForeignKeysContRev();
          for(final Entity f : _dbManyToOneForeignKeysContRev) {
            _builder.append("\t\t\t");
            _builder.append("List<");
            String _name_6 = f.getName();
            String _firstUpper_3 = StringExtensions.toFirstUpper(_name_6);
            _builder.append(_firstUpper_3, "\t\t\t");
            _builder.append("> ");
            String _name_7 = f.getName();
            String _firstLower_3 = StringExtensions.toFirstLower(_name_7);
            _builder.append(_firstLower_3, "\t\t\t");
            _builder.append("list = DAOFactory.get");
            String _name_8 = f.getName();
            String _firstUpper_4 = StringExtensions.toFirstUpper(_name_8);
            _builder.append(_firstUpper_4, "\t\t\t");
            _builder.append("DAO().get");
            String _name_9 = f.getName();
            String _firstUpper_5 = StringExtensions.toFirstUpper(_name_9);
            _builder.append(_firstUpper_5, "\t\t\t");
            _builder.append("sBy");
            String _name_10 = e.getName();
            String _firstUpper_6 = StringExtensions.toFirstUpper(_name_10);
            _builder.append(_firstUpper_6, "\t\t\t");
            _builder.append("Containment(");
            String _name_11 = e.getName();
            String _firstLower_4 = StringExtensions.toFirstLower(_name_11);
            _builder.append(_firstLower_4, "\t\t\t");
            _builder.append(");");
            _builder.newLineIfNotEmpty();
            _builder.append("\t\t\t");
            _builder.append("DAOFactory.get");
            String _name_12 = f.getName();
            String _firstUpper_7 = StringExtensions.toFirstUpper(_name_12);
            _builder.append(_firstUpper_7, "\t\t\t");
            _builder.append("DAO().delete");
            String _name_13 = f.getName();
            String _firstUpper_8 = StringExtensions.toFirstUpper(_name_13);
            _builder.append(_firstUpper_8, "\t\t\t");
            _builder.append("s(");
            String _name_14 = f.getName();
            String _firstLower_5 = StringExtensions.toFirstLower(_name_14);
            _builder.append(_firstLower_5, "\t\t\t");
            _builder.append("list);");
            _builder.newLineIfNotEmpty();
            _builder.append("\t\t\t");
            _builder.newLine();
          }
        }
        {
          List<Entity> _dbOneToOneForeignKeysContRevInv = this.wrappedEntity.getDbOneToOneForeignKeysContRevInv();
          for(final Entity f_1 : _dbOneToOneForeignKeysContRevInv) {
            _builder.append("\t\t\t");
            String _name_15 = f_1.getName();
            String _firstUpper_9 = StringExtensions.toFirstUpper(_name_15);
            _builder.append(_firstUpper_9, "\t\t\t");
            _builder.append(" ");
            String _name_16 = f_1.getName();
            String _firstLower_6 = StringExtensions.toFirstLower(_name_16);
            _builder.append(_firstLower_6, "\t\t\t");
            _builder.append(" = DAOFactory.get");
            String _name_17 = f_1.getName();
            String _firstUpper_10 = StringExtensions.toFirstUpper(_name_17);
            _builder.append(_firstUpper_10, "\t\t\t");
            _builder.append("DAO().get");
            String _name_18 = f_1.getName();
            String _firstUpper_11 = StringExtensions.toFirstUpper(_name_18);
            _builder.append(_firstUpper_11, "\t\t\t");
            _builder.append("By");
            String _name_19 = e.getName();
            String _firstUpper_12 = StringExtensions.toFirstUpper(_name_19);
            _builder.append(_firstUpper_12, "\t\t\t");
            _builder.append("Containment(");
            String _name_20 = e.getName();
            String _firstLower_7 = StringExtensions.toFirstLower(_name_20);
            _builder.append(_firstLower_7, "\t\t\t");
            _builder.append(");");
            _builder.newLineIfNotEmpty();
            _builder.append("\t\t\t");
            _builder.append("DAOFactory.get");
            String _name_21 = f_1.getName();
            String _firstUpper_13 = StringExtensions.toFirstUpper(_name_21);
            _builder.append(_firstUpper_13, "\t\t\t");
            _builder.append("DAO().delete");
            String _name_22 = f_1.getName();
            String _firstUpper_14 = StringExtensions.toFirstUpper(_name_22);
            _builder.append(_firstUpper_14, "\t\t\t");
            _builder.append("(");
            String _name_23 = f_1.getName();
            String _firstLower_8 = StringExtensions.toFirstLower(_name_23);
            _builder.append(_firstLower_8, "\t\t\t");
            _builder.append(");");
            _builder.newLineIfNotEmpty();
            _builder.append("\t\t\t");
            _builder.newLine();
          }
        }
        {
          List<WrappedAssociation> _dbManyToOneForeignKeysRev = this.wrappedEntity.getDbManyToOneForeignKeysRev();
          for(final WrappedAssociation f_2 : _dbManyToOneForeignKeysRev) {
            _builder.append("\t\t\t");
            _builder.append("List<");
            Entity _container = f_2.getContainer();
            String _name_24 = _container.getName();
            String _firstUpper_15 = StringExtensions.toFirstUpper(_name_24);
            _builder.append(_firstUpper_15, "\t\t\t");
            _builder.append("> ");
            Entity _container_1 = f_2.getContainer();
            String _name_25 = _container_1.getName();
            String _firstLower_9 = StringExtensions.toFirstLower(_name_25);
            _builder.append(_firstLower_9, "\t\t\t");
            _builder.append("list = DAOFactory.get");
            Entity _container_2 = f_2.getContainer();
            String _name_26 = _container_2.getName();
            String _firstUpper_16 = StringExtensions.toFirstUpper(_name_26);
            _builder.append(_firstUpper_16, "\t\t\t");
            _builder.append("DAO().get");
            Entity _container_3 = f_2.getContainer();
            String _name_27 = _container_3.getName();
            String _firstUpper_17 = StringExtensions.toFirstUpper(_name_27);
            _builder.append(_firstUpper_17, "\t\t\t");
            _builder.append("sBy");
            String _name_28 = e.getName();
            String _firstUpper_18 = StringExtensions.toFirstUpper(_name_28);
            _builder.append(_firstUpper_18, "\t\t\t");
            _builder.append("Reference(");
            String _name_29 = e.getName();
            String _firstLower_10 = StringExtensions.toFirstLower(_name_29);
            _builder.append(_firstLower_10, "\t\t\t");
            _builder.append(");");
            _builder.newLineIfNotEmpty();
            _builder.append("\t\t\t");
            _builder.newLine();
            _builder.append("\t\t\t");
            _builder.append("for(");
            Entity _container_4 = f_2.getContainer();
            String _name_30 = _container_4.getName();
            String _firstUpper_19 = StringExtensions.toFirstUpper(_name_30);
            _builder.append(_firstUpper_19, "\t\t\t");
            _builder.append(" ");
            Entity _container_5 = f_2.getContainer();
            String _name_31 = _container_5.getName();
            String _substring = _name_31.substring(0, 1);
            String _firstLower_11 = StringExtensions.toFirstLower(_substring);
            _builder.append(_firstLower_11, "\t\t\t");
            _builder.append(" : ");
            Entity _container_6 = f_2.getContainer();
            String _name_32 = _container_6.getName();
            String _firstLower_12 = StringExtensions.toFirstLower(_name_32);
            _builder.append(_firstLower_12, "\t\t\t");
            _builder.append("list){");
            _builder.newLineIfNotEmpty();
            _builder.append("\t\t\t");
            _builder.append("\t");
            Entity _container_7 = f_2.getContainer();
            String _name_33 = _container_7.getName();
            String _substring_1 = _name_33.substring(0, 1);
            String _firstLower_13 = StringExtensions.toFirstLower(_substring_1);
            _builder.append(_firstLower_13, "\t\t\t\t");
            _builder.append(".set");
            Association _association = f_2.getAssociation();
            String _name_34 = _association.getName();
            String _firstUpper_20 = StringExtensions.toFirstUpper(_name_34);
            _builder.append(_firstUpper_20, "\t\t\t\t");
            _builder.append("(null);");
            _builder.newLineIfNotEmpty();
            _builder.append("\t\t\t");
            _builder.append("}");
            _builder.newLine();
            _builder.append("\t\t\t");
            _builder.newLine();
          }
        }
        {
          List<WrappedAssociation> _dbOneToOneForeignKeysRevInv = this.wrappedEntity.getDbOneToOneForeignKeysRevInv();
          for(final WrappedAssociation f_3 : _dbOneToOneForeignKeysRevInv) {
            _builder.append("\t\t\t");
            Entity _container_8 = f_3.getContainer();
            String _name_35 = _container_8.getName();
            String _firstUpper_21 = StringExtensions.toFirstUpper(_name_35);
            _builder.append(_firstUpper_21, "\t\t\t");
            _builder.append(" ");
            Entity _container_9 = f_3.getContainer();
            String _name_36 = _container_9.getName();
            String _firstLower_14 = StringExtensions.toFirstLower(_name_36);
            _builder.append(_firstLower_14, "\t\t\t");
            _builder.append(" = DAOFactory.get");
            Entity _container_10 = f_3.getContainer();
            String _name_37 = _container_10.getName();
            String _firstUpper_22 = StringExtensions.toFirstUpper(_name_37);
            _builder.append(_firstUpper_22, "\t\t\t");
            _builder.append("DAO().get");
            Entity _container_11 = f_3.getContainer();
            String _name_38 = _container_11.getName();
            String _firstUpper_23 = StringExtensions.toFirstUpper(_name_38);
            _builder.append(_firstUpper_23, "\t\t\t");
            _builder.append("By");
            String _name_39 = e.getName();
            String _firstUpper_24 = StringExtensions.toFirstUpper(_name_39);
            _builder.append(_firstUpper_24, "\t\t\t");
            _builder.append("Reference(");
            String _name_40 = e.getName();
            String _firstLower_15 = StringExtensions.toFirstLower(_name_40);
            _builder.append(_firstLower_15, "\t\t\t");
            _builder.append(");");
            _builder.newLineIfNotEmpty();
            _builder.append("\t\t\t");
            Entity _container_12 = f_3.getContainer();
            String _name_41 = _container_12.getName();
            String _firstLower_16 = StringExtensions.toFirstLower(_name_41);
            _builder.append(_firstLower_16, "\t\t\t");
            _builder.append(".set");
            Association _association_1 = f_3.getAssociation();
            String _name_42 = _association_1.getName();
            String _firstUpper_25 = StringExtensions.toFirstUpper(_name_42);
            _builder.append(_firstUpper_25, "\t\t\t");
            _builder.append("(null);");
            _builder.newLineIfNotEmpty();
            _builder.append("\t\t\t");
            _builder.newLine();
          }
        }
        _builder.append("\t\t\t");
        String _name_43 = e.getName();
        String _firstLower_17 = StringExtensions.toFirstLower(_name_43);
        _builder.append(_firstLower_17, "\t\t\t");
        _builder.append("DAO.delete(");
        String _name_44 = e.getName();
        String _firstLower_18 = StringExtensions.toFirstLower(_name_44);
        _builder.append(_firstLower_18, "\t\t\t");
        _builder.append(");");
        _builder.newLineIfNotEmpty();
        _builder.append("\t\t");
        _builder.append("}");
        _builder.newLine();
        _builder.append("\t");
        _builder.append("} catch (SQLException e) {");
        _builder.newLine();
        _builder.append("\t\t");
        _builder.append("e.printStackTrace();");
        _builder.newLine();
        _builder.append("\t\t");
        _builder.append("return false;");
        _builder.newLine();
        _builder.append("\t");
        _builder.append("}");
        _builder.newLine();
        _builder.append("\t");
        _builder.append("return true;");
        _builder.newLine();
        _builder.append("}");
        _builder.newLine();
      } else {
        _builder.append("@Override");
        _builder.newLine();
        _builder.append("public boolean delete");
        String _name_45 = e.getName();
        String _firstUpper_26 = StringExtensions.toFirstUpper(_name_45);
        _builder.append(_firstUpper_26, "");
        _builder.append("s(List<");
        String _name_46 = e.getName();
        String _firstUpper_27 = StringExtensions.toFirstUpper(_name_46);
        _builder.append(_firstUpper_27, "");
        _builder.append("> ");
        String _name_47 = e.getName();
        String _firstLower_19 = StringExtensions.toFirstLower(_name_47);
        _builder.append(_firstLower_19, "");
        _builder.append("s) {");
        _builder.newLineIfNotEmpty();
        _builder.append("\t");
        _builder.append("try {");
        _builder.newLine();
        _builder.append("\t\t");
        String _name_48 = e.getName();
        String _firstLower_20 = StringExtensions.toFirstLower(_name_48);
        _builder.append(_firstLower_20, "\t\t");
        _builder.append("DAO.delete(");
        String _name_49 = e.getName();
        String _firstLower_21 = StringExtensions.toFirstLower(_name_49);
        _builder.append(_firstLower_21, "\t\t");
        _builder.append("s);");
        _builder.newLineIfNotEmpty();
        _builder.append("\t");
        _builder.append("} catch (SQLException e) {");
        _builder.newLine();
        _builder.append("\t\t");
        _builder.append("e.printStackTrace();");
        _builder.newLine();
        _builder.append("\t\t");
        _builder.append("return false;");
        _builder.newLine();
        _builder.append("\t");
        _builder.append("}");
        _builder.newLine();
        _builder.append("\t");
        _builder.append("return true;");
        _builder.newLine();
        _builder.append("}");
        _builder.newLine();
      }
    }
    return _builder;
  }
  
  private CharSequence refresh(final Entity e) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("@Override");
    _builder.newLine();
    _builder.append("public boolean refresh");
    String _name = e.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    _builder.append(_firstUpper, "");
    _builder.append("(");
    String _name_1 = e.getName();
    String _firstUpper_1 = StringExtensions.toFirstUpper(_name_1);
    _builder.append(_firstUpper_1, "");
    _builder.append(" ");
    String _name_2 = e.getName();
    String _firstLower = StringExtensions.toFirstLower(_name_2);
    _builder.append(_firstLower, "");
    _builder.append(") {");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("try {");
    _builder.newLine();
    _builder.append("\t\t");
    String _name_3 = e.getName();
    String _firstLower_1 = StringExtensions.toFirstLower(_name_3);
    _builder.append(_firstLower_1, "\t\t");
    _builder.append("DAO.refresh(");
    String _name_4 = e.getName();
    String _firstLower_2 = StringExtensions.toFirstLower(_name_4);
    _builder.append(_firstLower_2, "\t\t");
    _builder.append(");");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("} catch (SQLException e) {");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("e.printStackTrace();");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("return false;");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("return true;");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence getAll(final Entity e) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("@Override");
    _builder.newLine();
    _builder.append("public List<");
    String _name = e.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    _builder.append(_firstUpper, "");
    _builder.append("> get");
    String _name_1 = e.getName();
    String _firstUpper_1 = StringExtensions.toFirstUpper(_name_1);
    _builder.append(_firstUpper_1, "");
    _builder.append("s() {");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("try {");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("return ");
    String _name_2 = e.getName();
    String _firstLower = StringExtensions.toFirstLower(_name_2);
    _builder.append(_firstLower, "\t\t");
    _builder.append("DAO.queryForAll();");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("} catch (SQLException e) {");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("e.printStackTrace();");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("return null;");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence getByContainment(final Entity e) {
    StringConcatenation _builder = new StringConcatenation();
    {
      List<Association> _dbManyToOneForeignKeysCont = this.wrappedEntity.getDbManyToOneForeignKeysCont();
      for(final Association f : _dbManyToOneForeignKeysCont) {
        _builder.append("@Override");
        _builder.newLine();
        _builder.append("public List<");
        String _name = e.getName();
        String _firstUpper = StringExtensions.toFirstUpper(_name);
        _builder.append(_firstUpper, "");
        _builder.append("> get");
        String _name_1 = e.getName();
        String _firstUpper_1 = StringExtensions.toFirstUpper(_name_1);
        _builder.append(_firstUpper_1, "");
        _builder.append("sBy");
        Entity _connectTo = f.getConnectTo();
        String _name_2 = _connectTo.getName();
        String _firstUpper_2 = StringExtensions.toFirstUpper(_name_2);
        _builder.append(_firstUpper_2, "");
        _builder.append("Containment(");
        Entity _connectTo_1 = f.getConnectTo();
        String _name_3 = _connectTo_1.getName();
        String _firstUpper_3 = StringExtensions.toFirstUpper(_name_3);
        _builder.append(_firstUpper_3, "");
        _builder.append(" ");
        Entity _connectTo_2 = f.getConnectTo();
        String _name_4 = _connectTo_2.getName();
        String _firstLower = StringExtensions.toFirstLower(_name_4);
        _builder.append(_firstLower, "");
        _builder.append(") {");
        _builder.newLineIfNotEmpty();
        _builder.append("\t");
        _builder.append("try {");
        _builder.newLine();
        _builder.append("\t\t");
        _builder.append("List<");
        String _name_5 = e.getName();
        String _firstUpper_4 = StringExtensions.toFirstUpper(_name_5);
        _builder.append(_firstUpper_4, "\t\t");
        _builder.append("> ");
        String _name_6 = e.getName();
        String _firstLower_1 = StringExtensions.toFirstLower(_name_6);
        _builder.append(_firstLower_1, "\t\t");
        _builder.append("List = ");
        String _name_7 = e.getName();
        String _firstLower_2 = StringExtensions.toFirstLower(_name_7);
        _builder.append(_firstLower_2, "\t\t");
        _builder.append("DAO.query(");
        String _name_8 = e.getName();
        String _firstLower_3 = StringExtensions.toFirstLower(_name_8);
        _builder.append(_firstLower_3, "\t\t");
        _builder.append("DAO.queryBuilder().where().eq(");
        String _name_9 = e.getName();
        String _firstUpper_5 = StringExtensions.toFirstUpper(_name_9);
        _builder.append(_firstUpper_5, "\t\t");
        _builder.append(".");
        String _name_10 = f.getName();
        String _upperCase = _name_10.toUpperCase();
        _builder.append(_upperCase, "\t\t");
        _builder.append("_ID_FIELD_NAME, ");
        Entity _connectTo_3 = f.getConnectTo();
        String _name_11 = _connectTo_3.getName();
        String _firstLower_4 = StringExtensions.toFirstLower(_name_11);
        _builder.append(_firstLower_4, "\t\t");
        _builder.append(".getId()).prepare());");
        _builder.newLineIfNotEmpty();
        _builder.append("\t\t");
        _builder.append("return ");
        String _name_12 = e.getName();
        String _firstLower_5 = StringExtensions.toFirstLower(_name_12);
        _builder.append(_firstLower_5, "\t\t");
        _builder.append("List;");
        _builder.newLineIfNotEmpty();
        _builder.append("\t");
        _builder.append("} catch (SQLException e) {");
        _builder.newLine();
        _builder.append("\t\t");
        _builder.append("e.printStackTrace();");
        _builder.newLine();
        _builder.append("\t\t");
        _builder.append("return null;");
        _builder.newLine();
        _builder.append("\t");
        _builder.append("}");
        _builder.newLine();
        _builder.append("}");
        _builder.newLine();
      }
    }
    {
      List<Association> _dbOneToOneForeignKeysContInv = this.wrappedEntity.getDbOneToOneForeignKeysContInv();
      for(final Association f_1 : _dbOneToOneForeignKeysContInv) {
        _builder.append("@Override");
        _builder.newLine();
        _builder.append("public ");
        String _name_13 = e.getName();
        String _firstUpper_6 = StringExtensions.toFirstUpper(_name_13);
        _builder.append(_firstUpper_6, "");
        _builder.append(" get");
        String _name_14 = e.getName();
        String _firstUpper_7 = StringExtensions.toFirstUpper(_name_14);
        _builder.append(_firstUpper_7, "");
        _builder.append("By");
        Entity _connectTo_4 = f_1.getConnectTo();
        String _name_15 = _connectTo_4.getName();
        String _firstUpper_8 = StringExtensions.toFirstUpper(_name_15);
        _builder.append(_firstUpper_8, "");
        _builder.append("Containment(");
        Entity _connectTo_5 = f_1.getConnectTo();
        String _name_16 = _connectTo_5.getName();
        String _firstUpper_9 = StringExtensions.toFirstUpper(_name_16);
        _builder.append(_firstUpper_9, "");
        _builder.append(" ");
        Entity _connectTo_6 = f_1.getConnectTo();
        String _name_17 = _connectTo_6.getName();
        String _firstLower_6 = StringExtensions.toFirstLower(_name_17);
        _builder.append(_firstLower_6, "");
        _builder.append(") {");
        _builder.newLineIfNotEmpty();
        _builder.append("\t");
        _builder.append("try {");
        _builder.newLine();
        _builder.append("\t\t");
        _builder.append("List<");
        String _name_18 = e.getName();
        String _firstUpper_10 = StringExtensions.toFirstUpper(_name_18);
        _builder.append(_firstUpper_10, "\t\t");
        _builder.append("> ");
        String _name_19 = e.getName();
        String _firstLower_7 = StringExtensions.toFirstLower(_name_19);
        _builder.append(_firstLower_7, "\t\t");
        _builder.append("List = ");
        String _name_20 = e.getName();
        String _firstLower_8 = StringExtensions.toFirstLower(_name_20);
        _builder.append(_firstLower_8, "\t\t");
        _builder.append("DAO.query(");
        String _name_21 = e.getName();
        String _firstLower_9 = StringExtensions.toFirstLower(_name_21);
        _builder.append(_firstLower_9, "\t\t");
        _builder.append("DAO.queryBuilder().where().eq(");
        String _name_22 = e.getName();
        String _firstUpper_11 = StringExtensions.toFirstUpper(_name_22);
        _builder.append(_firstUpper_11, "\t\t");
        _builder.append(".");
        String _name_23 = f_1.getName();
        String _upperCase_1 = _name_23.toUpperCase();
        _builder.append(_upperCase_1, "\t\t");
        _builder.append("_ID_FIELD_NAME, ");
        Entity _connectTo_7 = f_1.getConnectTo();
        String _name_24 = _connectTo_7.getName();
        String _firstLower_10 = StringExtensions.toFirstLower(_name_24);
        _builder.append(_firstLower_10, "\t\t");
        _builder.append(".getId()).prepare());");
        _builder.newLineIfNotEmpty();
        _builder.append("\t\t");
        _builder.append("if(");
        String _name_25 = e.getName();
        String _firstLower_11 = StringExtensions.toFirstLower(_name_25);
        _builder.append(_firstLower_11, "\t\t");
        _builder.append("List.size() > 0){");
        _builder.newLineIfNotEmpty();
        _builder.append("\t\t\t");
        _builder.append("return ");
        String _name_26 = e.getName();
        String _firstLower_12 = StringExtensions.toFirstLower(_name_26);
        _builder.append(_firstLower_12, "\t\t\t");
        _builder.append("List.get(0);");
        _builder.newLineIfNotEmpty();
        _builder.append("\t\t");
        _builder.append("}");
        _builder.newLine();
        _builder.append("\t\t");
        _builder.append("else{");
        _builder.newLine();
        _builder.append("\t\t\t");
        _builder.append("return null;");
        _builder.newLine();
        _builder.append("\t\t");
        _builder.append("}");
        _builder.newLine();
        _builder.append("\t");
        _builder.append("} catch (SQLException e) {");
        _builder.newLine();
        _builder.append("\t\t");
        _builder.append("e.printStackTrace();");
        _builder.newLine();
        _builder.append("\t\t");
        _builder.append("return null;");
        _builder.newLine();
        _builder.append("\t");
        _builder.append("}");
        _builder.newLine();
        _builder.append("}");
        _builder.newLine();
      }
    }
    return _builder;
  }
  
  private CharSequence getByReference(final Entity e) {
    StringConcatenation _builder = new StringConcatenation();
    {
      List<Association> _dbManyToOneForeignKeys = this.wrappedEntity.getDbManyToOneForeignKeys();
      for(final Association f : _dbManyToOneForeignKeys) {
        _builder.append("@Override");
        _builder.newLine();
        _builder.append("public List<");
        String _name = e.getName();
        String _firstUpper = StringExtensions.toFirstUpper(_name);
        _builder.append(_firstUpper, "");
        _builder.append("> get");
        String _name_1 = e.getName();
        String _firstUpper_1 = StringExtensions.toFirstUpper(_name_1);
        _builder.append(_firstUpper_1, "");
        _builder.append("sBy");
        Entity _connectTo = f.getConnectTo();
        String _name_2 = _connectTo.getName();
        String _firstUpper_2 = StringExtensions.toFirstUpper(_name_2);
        _builder.append(_firstUpper_2, "");
        _builder.append("Reference(");
        Entity _connectTo_1 = f.getConnectTo();
        String _name_3 = _connectTo_1.getName();
        String _firstUpper_3 = StringExtensions.toFirstUpper(_name_3);
        _builder.append(_firstUpper_3, "");
        _builder.append(" ");
        Entity _connectTo_2 = f.getConnectTo();
        String _name_4 = _connectTo_2.getName();
        String _firstLower = StringExtensions.toFirstLower(_name_4);
        _builder.append(_firstLower, "");
        _builder.append(") {");
        _builder.newLineIfNotEmpty();
        _builder.append("\t");
        _builder.append("try {");
        _builder.newLine();
        _builder.append("\t\t");
        _builder.append("List<");
        String _name_5 = e.getName();
        String _firstUpper_4 = StringExtensions.toFirstUpper(_name_5);
        _builder.append(_firstUpper_4, "\t\t");
        _builder.append("> ");
        String _name_6 = e.getName();
        String _firstLower_1 = StringExtensions.toFirstLower(_name_6);
        _builder.append(_firstLower_1, "\t\t");
        _builder.append("List = ");
        String _name_7 = e.getName();
        String _firstLower_2 = StringExtensions.toFirstLower(_name_7);
        _builder.append(_firstLower_2, "\t\t");
        _builder.append("DAO.query(");
        String _name_8 = e.getName();
        String _firstLower_3 = StringExtensions.toFirstLower(_name_8);
        _builder.append(_firstLower_3, "\t\t");
        _builder.append("DAO.queryBuilder().where().eq(");
        String _name_9 = e.getName();
        String _firstUpper_5 = StringExtensions.toFirstUpper(_name_9);
        _builder.append(_firstUpper_5, "\t\t");
        _builder.append(".");
        String _name_10 = f.getName();
        String _upperCase = _name_10.toUpperCase();
        _builder.append(_upperCase, "\t\t");
        _builder.append("_ID_FIELD_NAME, ");
        Entity _connectTo_3 = f.getConnectTo();
        String _name_11 = _connectTo_3.getName();
        String _firstLower_4 = StringExtensions.toFirstLower(_name_11);
        _builder.append(_firstLower_4, "\t\t");
        _builder.append(".getId()).prepare());");
        _builder.newLineIfNotEmpty();
        _builder.append("\t\t");
        _builder.append("return ");
        String _name_12 = e.getName();
        String _firstLower_5 = StringExtensions.toFirstLower(_name_12);
        _builder.append(_firstLower_5, "\t\t");
        _builder.append("List;");
        _builder.newLineIfNotEmpty();
        _builder.append("\t");
        _builder.append("} catch (SQLException e) {");
        _builder.newLine();
        _builder.append("\t\t");
        _builder.append("e.printStackTrace();");
        _builder.newLine();
        _builder.append("\t\t");
        _builder.append("return null;");
        _builder.newLine();
        _builder.append("\t");
        _builder.append("}");
        _builder.newLine();
        _builder.append("}");
        _builder.newLine();
      }
    }
    {
      List<Association> _dbOneToOneForeignKeysInv = this.wrappedEntity.getDbOneToOneForeignKeysInv();
      for(final Association f_1 : _dbOneToOneForeignKeysInv) {
        _builder.append("@Override");
        _builder.newLine();
        _builder.append("public ");
        String _name_13 = e.getName();
        String _firstUpper_6 = StringExtensions.toFirstUpper(_name_13);
        _builder.append(_firstUpper_6, "");
        _builder.append(" get");
        String _name_14 = e.getName();
        String _firstUpper_7 = StringExtensions.toFirstUpper(_name_14);
        _builder.append(_firstUpper_7, "");
        _builder.append("By");
        Entity _connectTo_4 = f_1.getConnectTo();
        String _name_15 = _connectTo_4.getName();
        String _firstUpper_8 = StringExtensions.toFirstUpper(_name_15);
        _builder.append(_firstUpper_8, "");
        _builder.append("Reference(");
        Entity _connectTo_5 = f_1.getConnectTo();
        String _name_16 = _connectTo_5.getName();
        String _firstUpper_9 = StringExtensions.toFirstUpper(_name_16);
        _builder.append(_firstUpper_9, "");
        _builder.append(" ");
        Entity _connectTo_6 = f_1.getConnectTo();
        String _name_17 = _connectTo_6.getName();
        String _firstLower_6 = StringExtensions.toFirstLower(_name_17);
        _builder.append(_firstLower_6, "");
        _builder.append(") {");
        _builder.newLineIfNotEmpty();
        _builder.append("\t");
        _builder.append("try {");
        _builder.newLine();
        _builder.append("\t\t");
        _builder.append("List<");
        String _name_18 = e.getName();
        String _firstUpper_10 = StringExtensions.toFirstUpper(_name_18);
        _builder.append(_firstUpper_10, "\t\t");
        _builder.append("> ");
        String _name_19 = e.getName();
        String _firstLower_7 = StringExtensions.toFirstLower(_name_19);
        _builder.append(_firstLower_7, "\t\t");
        _builder.append("List = ");
        String _name_20 = e.getName();
        String _firstLower_8 = StringExtensions.toFirstLower(_name_20);
        _builder.append(_firstLower_8, "\t\t");
        _builder.append("DAO.query(");
        String _name_21 = e.getName();
        String _firstLower_9 = StringExtensions.toFirstLower(_name_21);
        _builder.append(_firstLower_9, "\t\t");
        _builder.append("DAO.queryBuilder().where().eq(");
        String _name_22 = e.getName();
        String _firstUpper_11 = StringExtensions.toFirstUpper(_name_22);
        _builder.append(_firstUpper_11, "\t\t");
        _builder.append(".");
        String _name_23 = f_1.getName();
        String _upperCase_1 = _name_23.toUpperCase();
        _builder.append(_upperCase_1, "\t\t");
        _builder.append("_ID_FIELD_NAME, ");
        Entity _connectTo_7 = f_1.getConnectTo();
        String _name_24 = _connectTo_7.getName();
        String _firstLower_10 = StringExtensions.toFirstLower(_name_24);
        _builder.append(_firstLower_10, "\t\t");
        _builder.append(".getId()).prepare());");
        _builder.newLineIfNotEmpty();
        _builder.append("\t\t");
        _builder.append("if(");
        String _name_25 = e.getName();
        String _firstLower_11 = StringExtensions.toFirstLower(_name_25);
        _builder.append(_firstLower_11, "\t\t");
        _builder.append("List.size() > 0){");
        _builder.newLineIfNotEmpty();
        _builder.append("\t\t\t");
        _builder.append("return ");
        String _name_26 = e.getName();
        String _firstLower_12 = StringExtensions.toFirstLower(_name_26);
        _builder.append(_firstLower_12, "\t\t\t");
        _builder.append("List.get(0);");
        _builder.newLineIfNotEmpty();
        _builder.append("\t\t");
        _builder.append("}");
        _builder.newLine();
        _builder.append("\t\t");
        _builder.append("else{");
        _builder.newLine();
        _builder.append("\t\t\t");
        _builder.append("return null;");
        _builder.newLine();
        _builder.append("\t\t");
        _builder.append("}");
        _builder.newLine();
        _builder.append("\t");
        _builder.append("} catch (SQLException e) {");
        _builder.newLine();
        _builder.append("\t\t");
        _builder.append("e.printStackTrace();");
        _builder.newLine();
        _builder.append("\t\t");
        _builder.append("return null;");
        _builder.newLine();
        _builder.append("\t");
        _builder.append("}");
        _builder.newLine();
        _builder.append("}");
        _builder.newLine();
      }
    }
    return _builder;
  }
  
  private CharSequence getByID(final Entity e) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("@Override");
    _builder.newLine();
    _builder.append("public ");
    String _name = e.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    _builder.append(_firstUpper, "");
    _builder.append(" get");
    String _name_1 = e.getName();
    String _firstUpper_1 = StringExtensions.toFirstUpper(_name_1);
    _builder.append(_firstUpper_1, "");
    _builder.append("ByID(int id) {");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("try {");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("return ");
    String _name_2 = e.getName();
    String _firstLower = StringExtensions.toFirstLower(_name_2);
    _builder.append(_firstLower, "\t\t");
    _builder.append("DAO.queryForId(id);");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("} catch (SQLException e) {");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("e.printStackTrace();");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("return null;");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence dao(final Entity e) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("@Override");
    _builder.newLine();
    _builder.append("public Dao<");
    String _name = e.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    _builder.append(_firstUpper, "");
    _builder.append(", Integer> getDAO() {");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("return ");
    String _name_1 = e.getName();
    String _firstLower = StringExtensions.toFirstLower(_name_1);
    _builder.append(_firstLower, "\t");
    _builder.append("DAO;");
    _builder.newLineIfNotEmpty();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence others(final WrappedEntity we) {
    StringConcatenation _builder = new StringConcatenation();
    {
      GeneratorHelper _genHelp = this.wrappedEntity.getGenHelp();
      boolean _equals = Objects.equal(_genHelp, GeneratorHelper.JoinClass);
      if (_equals) {
        CharSequence _manyToManyJoinTable = this.manyToManyJoinTable(this.wrappedEntity);
        _builder.append(_manyToManyJoinTable, "");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.newLine();
    {
      boolean _isHasJoinTable = this.wrappedEntity.isHasJoinTable();
      if (_isHasJoinTable) {
        CharSequence _manyToManyConnection = this.manyToManyConnection(this.wrappedEntity);
        _builder.append(_manyToManyConnection, "");
        _builder.newLineIfNotEmpty();
      }
    }
    return _builder;
  }
  
  private CharSequence manyToManyConnection(final WrappedEntity we) {
    StringConcatenation _builder = new StringConcatenation();
    {
      boolean _isHasJoinTable = this.wrappedEntity.isHasJoinTable();
      if (_isHasJoinTable) {
        {
          List<Entity> _dbManyToManyJoinTable = this.wrappedEntity.getDbManyToManyJoinTable();
          for(final Entity f : _dbManyToManyJoinTable) {
            CharSequence _manyToMany = this.manyToMany(we, f);
            _builder.append(_manyToMany, "");
            _builder.newLineIfNotEmpty();
          }
        }
      }
    }
    return _builder;
  }
  
  private CharSequence manyToMany(final WrappedEntity we, final Entity join) {
    StringConcatenation _builder = new StringConcatenation();
    {
      EList<Association> _association = join.getAssociation();
      for(final Association f : _association) {
        {
          Entity _connectTo = f.getConnectTo();
          String _name = _connectTo.getName();
          Entity _entity = we.getEntity();
          String _name_1 = _entity.getName();
          boolean _equals = _name.equals(_name_1);
          boolean _not = (!_equals);
          if (_not) {
            CharSequence _setManyToMany = this.setManyToMany(we, join, f);
            _builder.append(_setManyToMany, "");
            _builder.newLineIfNotEmpty();
            CharSequence _manyToMany = this.getManyToMany(we, join, f);
            _builder.append(_manyToMany, "");
            _builder.newLineIfNotEmpty();
            CharSequence _removeManyToMany = this.removeManyToMany(we, join, f);
            _builder.append(_removeManyToMany, "");
            _builder.newLineIfNotEmpty();
          }
        }
      }
    }
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence setManyToMany(final WrappedEntity we, final Entity join, final Association f) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("@Override");
    _builder.newLine();
    _builder.append("public void set");
    Entity _connectTo = f.getConnectTo();
    String _name = _connectTo.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    _builder.append(_firstUpper, "");
    _builder.append("To");
    Entity _entity = we.getEntity();
    String _name_1 = _entity.getName();
    String _firstUpper_1 = StringExtensions.toFirstUpper(_name_1);
    _builder.append(_firstUpper_1, "");
    _builder.append("(");
    Entity _connectTo_1 = f.getConnectTo();
    String _name_2 = _connectTo_1.getName();
    String _firstUpper_2 = StringExtensions.toFirstUpper(_name_2);
    _builder.append(_firstUpper_2, "");
    _builder.append(" ");
    Entity _connectTo_2 = f.getConnectTo();
    String _name_3 = _connectTo_2.getName();
    String _firstLower = StringExtensions.toFirstLower(_name_3);
    _builder.append(_firstLower, "");
    _builder.append(", ");
    Entity _entity_1 = we.getEntity();
    String _name_4 = _entity_1.getName();
    String _firstUpper_3 = StringExtensions.toFirstUpper(_name_4);
    _builder.append(_firstUpper_3, "");
    _builder.append(" ");
    Entity _entity_2 = we.getEntity();
    String _name_5 = _entity_2.getName();
    String _firstLower_1 = StringExtensions.toFirstLower(_name_5);
    _builder.append(_firstLower_1, "");
    _builder.append("){");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("DAOFactory.get");
    String _name_6 = join.getName();
    String _firstUpper_4 = StringExtensions.toFirstUpper(_name_6);
    _builder.append(_firstUpper_4, "\t");
    _builder.append("DAO().create");
    String _name_7 = join.getName();
    String _firstUpper_5 = StringExtensions.toFirstUpper(_name_7);
    _builder.append(_firstUpper_5, "\t");
    _builder.append("(");
    Entity _connectTo_3 = f.getConnectTo();
    String _name_8 = _connectTo_3.getName();
    String _firstLower_2 = StringExtensions.toFirstLower(_name_8);
    _builder.append(_firstLower_2, "\t");
    _builder.append(", ");
    Entity _entity_3 = we.getEntity();
    String _name_9 = _entity_3.getName();
    String _firstLower_3 = StringExtensions.toFirstLower(_name_9);
    _builder.append(_firstLower_3, "\t");
    _builder.append(");");
    _builder.newLineIfNotEmpty();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence getManyToMany(final WrappedEntity we, final Entity join, final Association f) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("@Override");
    _builder.newLine();
    _builder.append("public List<");
    Entity _connectTo = f.getConnectTo();
    String _name = _connectTo.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    _builder.append(_firstUpper, "");
    _builder.append("> get");
    Entity _connectTo_1 = f.getConnectTo();
    String _name_1 = _connectTo_1.getName();
    String _firstUpper_1 = StringExtensions.toFirstUpper(_name_1);
    _builder.append(_firstUpper_1, "");
    _builder.append("sBy");
    Entity _entity = we.getEntity();
    String _name_2 = _entity.getName();
    String _firstUpper_2 = StringExtensions.toFirstUpper(_name_2);
    _builder.append(_firstUpper_2, "");
    _builder.append("(");
    Entity _entity_1 = we.getEntity();
    String _name_3 = _entity_1.getName();
    String _firstUpper_3 = StringExtensions.toFirstUpper(_name_3);
    _builder.append(_firstUpper_3, "");
    _builder.append(" ");
    Entity _entity_2 = we.getEntity();
    String _name_4 = _entity_2.getName();
    String _firstLower = StringExtensions.toFirstLower(_name_4);
    _builder.append(_firstLower, "");
    _builder.append("){");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("List<");
    Entity _connectTo_2 = f.getConnectTo();
    String _name_5 = _connectTo_2.getName();
    String _firstUpper_4 = StringExtensions.toFirstUpper(_name_5);
    _builder.append(_firstUpper_4, "\t");
    _builder.append("> ");
    Entity _connectTo_3 = f.getConnectTo();
    String _name_6 = _connectTo_3.getName();
    String _firstLower_1 = StringExtensions.toFirstLower(_name_6);
    _builder.append(_firstLower_1, "\t");
    _builder.append("List = new ArrayList<");
    Entity _connectTo_4 = f.getConnectTo();
    String _name_7 = _connectTo_4.getName();
    String _firstUpper_5 = StringExtensions.toFirstUpper(_name_7);
    _builder.append(_firstUpper_5, "\t");
    _builder.append(">();");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("List<");
    String _name_8 = join.getName();
    String _firstUpper_6 = StringExtensions.toFirstUpper(_name_8);
    _builder.append(_firstUpper_6, "\t");
    _builder.append("> ");
    String _name_9 = join.getName();
    String _firstLower_2 = StringExtensions.toFirstLower(_name_9);
    _builder.append(_firstLower_2, "\t");
    _builder.append("List = DAOFactory.get");
    String _name_10 = join.getName();
    String _firstUpper_7 = StringExtensions.toFirstUpper(_name_10);
    _builder.append(_firstUpper_7, "\t");
    _builder.append("DAO().get");
    String _name_11 = join.getName();
    String _firstUpper_8 = StringExtensions.toFirstUpper(_name_11);
    _builder.append(_firstUpper_8, "\t");
    _builder.append("sBy");
    Entity _entity_3 = we.getEntity();
    String _name_12 = _entity_3.getName();
    String _firstUpper_9 = StringExtensions.toFirstUpper(_name_12);
    _builder.append(_firstUpper_9, "\t");
    _builder.append("Containment(");
    Entity _entity_4 = we.getEntity();
    String _name_13 = _entity_4.getName();
    String _firstLower_3 = StringExtensions.toFirstLower(_name_13);
    _builder.append(_firstLower_3, "\t");
    _builder.append(");");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("for(");
    String _name_14 = join.getName();
    String _firstUpper_10 = StringExtensions.toFirstUpper(_name_14);
    _builder.append(_firstUpper_10, "\t");
    _builder.append(" ");
    String _name_15 = join.getName();
    String _firstLower_4 = StringExtensions.toFirstLower(_name_15);
    _builder.append(_firstLower_4, "\t");
    _builder.append(" : ");
    String _name_16 = join.getName();
    String _firstLower_5 = StringExtensions.toFirstLower(_name_16);
    _builder.append(_firstLower_5, "\t");
    _builder.append("List){");
    _builder.newLineIfNotEmpty();
    _builder.append("\t\t");
    Entity _connectTo_5 = f.getConnectTo();
    String _name_17 = _connectTo_5.getName();
    String _firstLower_6 = StringExtensions.toFirstLower(_name_17);
    _builder.append(_firstLower_6, "\t\t");
    _builder.append("List.add(DAOFactory.get");
    Entity _connectTo_6 = f.getConnectTo();
    String _name_18 = _connectTo_6.getName();
    String _firstUpper_11 = StringExtensions.toFirstUpper(_name_18);
    _builder.append(_firstUpper_11, "\t\t");
    _builder.append("DAO().get");
    Entity _connectTo_7 = f.getConnectTo();
    String _name_19 = _connectTo_7.getName();
    String _firstUpper_12 = StringExtensions.toFirstUpper(_name_19);
    _builder.append(_firstUpper_12, "\t\t");
    _builder.append("ByID(");
    String _name_20 = join.getName();
    String _firstLower_7 = StringExtensions.toFirstLower(_name_20);
    _builder.append(_firstLower_7, "\t\t");
    _builder.append(".get");
    {
      EList<Association> _association = join.getAssociation();
      for(final Association a : _association) {
        {
          Entity _connectTo_8 = a.getConnectTo();
          String _name_21 = _connectTo_8.getName();
          Entity _entity_5 = we.getEntity();
          String _name_22 = _entity_5.getName();
          boolean _equals = _name_21.equals(_name_22);
          boolean _not = (!_equals);
          if (_not) {
            String _name_23 = a.getName();
            String _firstUpper_13 = StringExtensions.toFirstUpper(_name_23);
            _builder.append(_firstUpper_13, "\t\t");
          }
        }
      }
    }
    _builder.append("().getId()));");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("return ");
    Entity _connectTo_9 = f.getConnectTo();
    String _name_24 = _connectTo_9.getName();
    String _firstLower_8 = StringExtensions.toFirstLower(_name_24);
    _builder.append(_firstLower_8, "\t");
    _builder.append("List;");
    _builder.newLineIfNotEmpty();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence removeManyToMany(final WrappedEntity we, final Entity join, final Association f) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("@Override");
    _builder.newLine();
    _builder.append("public boolean remove");
    Entity _connectTo = f.getConnectTo();
    String _name = _connectTo.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    _builder.append(_firstUpper, "");
    _builder.append("By");
    Entity _entity = we.getEntity();
    String _name_1 = _entity.getName();
    String _firstUpper_1 = StringExtensions.toFirstUpper(_name_1);
    _builder.append(_firstUpper_1, "");
    _builder.append("(");
    Entity _connectTo_1 = f.getConnectTo();
    String _name_2 = _connectTo_1.getName();
    String _firstUpper_2 = StringExtensions.toFirstUpper(_name_2);
    _builder.append(_firstUpper_2, "");
    _builder.append(" ");
    Entity _connectTo_2 = f.getConnectTo();
    String _name_3 = _connectTo_2.getName();
    String _firstLower = StringExtensions.toFirstLower(_name_3);
    _builder.append(_firstLower, "");
    _builder.append(", ");
    Entity _entity_1 = we.getEntity();
    String _name_4 = _entity_1.getName();
    String _firstUpper_3 = StringExtensions.toFirstUpper(_name_4);
    _builder.append(_firstUpper_3, "");
    _builder.append(" ");
    Entity _entity_2 = we.getEntity();
    String _name_5 = _entity_2.getName();
    String _firstLower_1 = StringExtensions.toFirstLower(_name_5);
    _builder.append(_firstLower_1, "");
    _builder.append("){");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("List<");
    String _name_6 = join.getName();
    String _firstUpper_4 = StringExtensions.toFirstUpper(_name_6);
    _builder.append(_firstUpper_4, "\t");
    _builder.append("> ");
    String _name_7 = join.getName();
    String _firstLower_2 = StringExtensions.toFirstLower(_name_7);
    _builder.append(_firstLower_2, "\t");
    _builder.append("DelList = new ArrayList<");
    String _name_8 = join.getName();
    String _firstUpper_5 = StringExtensions.toFirstUpper(_name_8);
    _builder.append(_firstUpper_5, "\t");
    _builder.append(">();");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("List<");
    String _name_9 = join.getName();
    String _firstUpper_6 = StringExtensions.toFirstUpper(_name_9);
    _builder.append(_firstUpper_6, "\t");
    _builder.append("> ");
    String _name_10 = join.getName();
    String _firstUpper_7 = StringExtensions.toFirstUpper(_name_10);
    _builder.append(_firstUpper_7, "\t");
    _builder.append("List = DAOFactory.get");
    String _name_11 = join.getName();
    String _firstUpper_8 = StringExtensions.toFirstUpper(_name_11);
    _builder.append(_firstUpper_8, "\t");
    _builder.append("DAO().get");
    String _name_12 = join.getName();
    String _firstUpper_9 = StringExtensions.toFirstUpper(_name_12);
    _builder.append(_firstUpper_9, "\t");
    _builder.append("sBy");
    Entity _entity_3 = we.getEntity();
    String _name_13 = _entity_3.getName();
    String _firstUpper_10 = StringExtensions.toFirstUpper(_name_13);
    _builder.append(_firstUpper_10, "\t");
    _builder.append("Containment(");
    Entity _entity_4 = we.getEntity();
    String _name_14 = _entity_4.getName();
    String _firstLower_3 = StringExtensions.toFirstLower(_name_14);
    _builder.append(_firstLower_3, "\t");
    _builder.append(");");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("for(");
    String _name_15 = join.getName();
    String _firstUpper_11 = StringExtensions.toFirstUpper(_name_15);
    _builder.append(_firstUpper_11, "\t");
    _builder.append(" ");
    String _name_16 = join.getName();
    String _firstLower_4 = StringExtensions.toFirstLower(_name_16);
    _builder.append(_firstLower_4, "\t");
    _builder.append(" : ");
    String _name_17 = join.getName();
    String _firstUpper_12 = StringExtensions.toFirstUpper(_name_17);
    _builder.append(_firstUpper_12, "\t");
    _builder.append("List){");
    _builder.newLineIfNotEmpty();
    _builder.append("\t\t");
    _builder.append("if(");
    String _name_18 = join.getName();
    String _firstLower_5 = StringExtensions.toFirstLower(_name_18);
    _builder.append(_firstLower_5, "\t\t");
    _builder.append(".get");
    {
      EList<Association> _association = join.getAssociation();
      for(final Association a : _association) {
        {
          Entity _connectTo_3 = a.getConnectTo();
          String _name_19 = _connectTo_3.getName();
          Entity _entity_5 = we.getEntity();
          String _name_20 = _entity_5.getName();
          boolean _equals = _name_19.equals(_name_20);
          boolean _not = (!_equals);
          if (_not) {
            String _name_21 = a.getName();
            String _firstUpper_13 = StringExtensions.toFirstUpper(_name_21);
            _builder.append(_firstUpper_13, "\t\t");
          }
        }
      }
    }
    _builder.append("().getId() == ");
    Entity _connectTo_4 = f.getConnectTo();
    String _name_22 = _connectTo_4.getName();
    String _firstLower_6 = StringExtensions.toFirstLower(_name_22);
    _builder.append(_firstLower_6, "\t\t");
    _builder.append(".getId()){");
    _builder.newLineIfNotEmpty();
    _builder.append("\t\t\t");
    String _name_23 = join.getName();
    String _firstLower_7 = StringExtensions.toFirstLower(_name_23);
    _builder.append(_firstLower_7, "\t\t\t");
    _builder.append("DelList.add(");
    String _name_24 = join.getName();
    String _firstLower_8 = StringExtensions.toFirstLower(_name_24);
    _builder.append(_firstLower_8, "\t\t\t");
    _builder.append(");");
    _builder.newLineIfNotEmpty();
    _builder.append("\t\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("DAOFactory.get");
    String _name_25 = join.getName();
    String _firstUpper_14 = StringExtensions.toFirstUpper(_name_25);
    _builder.append(_firstUpper_14, "\t");
    _builder.append("DAO().delete");
    String _name_26 = join.getName();
    String _firstUpper_15 = StringExtensions.toFirstUpper(_name_26);
    _builder.append(_firstUpper_15, "\t");
    _builder.append("s(");
    String _name_27 = join.getName();
    String _firstLower_9 = StringExtensions.toFirstLower(_name_27);
    _builder.append(_firstLower_9, "\t");
    _builder.append("DelList);");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("return true;");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence manyToManyJoinTable(final WrappedEntity we) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("@Override");
    _builder.newLine();
    _builder.append("public boolean create");
    Entity _entity = we.getEntity();
    String _name = _entity.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    _builder.append(_firstUpper, "");
    _builder.append("(");
    List<Association> _dbManyToOneForeignKeysCont = we.getDbManyToOneForeignKeysCont();
    Association _get = _dbManyToOneForeignKeysCont.get(0);
    Entity _connectTo = _get.getConnectTo();
    String _name_1 = _connectTo.getName();
    String _firstUpper_1 = StringExtensions.toFirstUpper(_name_1);
    _builder.append(_firstUpper_1, "");
    _builder.append(" ");
    List<Association> _dbManyToOneForeignKeysCont_1 = we.getDbManyToOneForeignKeysCont();
    Association _get_1 = _dbManyToOneForeignKeysCont_1.get(0);
    Entity _connectTo_1 = _get_1.getConnectTo();
    String _name_2 = _connectTo_1.getName();
    String _firstLower = StringExtensions.toFirstLower(_name_2);
    _builder.append(_firstLower, "");
    _builder.append(", ");
    List<Association> _dbManyToOneForeignKeysCont_2 = we.getDbManyToOneForeignKeysCont();
    Association _get_2 = _dbManyToOneForeignKeysCont_2.get(1);
    Entity _connectTo_2 = _get_2.getConnectTo();
    String _name_3 = _connectTo_2.getName();
    String _firstUpper_2 = StringExtensions.toFirstUpper(_name_3);
    _builder.append(_firstUpper_2, "");
    _builder.append(" ");
    List<Association> _dbManyToOneForeignKeysCont_3 = we.getDbManyToOneForeignKeysCont();
    Association _get_3 = _dbManyToOneForeignKeysCont_3.get(1);
    Entity _connectTo_3 = _get_3.getConnectTo();
    String _name_4 = _connectTo_3.getName();
    String _firstLower_1 = StringExtensions.toFirstLower(_name_4);
    _builder.append(_firstLower_1, "");
    _builder.append("){");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("try {");
    _builder.newLine();
    _builder.append("\t\t");
    Entity _entity_1 = we.getEntity();
    String _name_5 = _entity_1.getName();
    String _firstUpper_3 = StringExtensions.toFirstUpper(_name_5);
    _builder.append(_firstUpper_3, "\t\t");
    _builder.append(" ");
    Entity _entity_2 = we.getEntity();
    String _name_6 = _entity_2.getName();
    String _firstLower_2 = StringExtensions.toFirstLower(_name_6);
    _builder.append(_firstLower_2, "\t\t");
    _builder.append(" = new ");
    Entity _entity_3 = we.getEntity();
    String _name_7 = _entity_3.getName();
    String _firstUpper_4 = StringExtensions.toFirstUpper(_name_7);
    _builder.append(_firstUpper_4, "\t\t");
    _builder.append("();");
    _builder.newLineIfNotEmpty();
    {
      List<Association> _dbManyToOneForeignKeysCont_4 = we.getDbManyToOneForeignKeysCont();
      for(final Association f : _dbManyToOneForeignKeysCont_4) {
        _builder.append("\t\t");
        Entity _entity_4 = we.getEntity();
        String _name_8 = _entity_4.getName();
        String _firstLower_3 = StringExtensions.toFirstLower(_name_8);
        _builder.append(_firstLower_3, "\t\t");
        _builder.append(".set");
        String _name_9 = f.getName();
        String _firstUpper_5 = StringExtensions.toFirstUpper(_name_9);
        _builder.append(_firstUpper_5, "\t\t");
        _builder.append("(");
        Entity _connectTo_4 = f.getConnectTo();
        String _name_10 = _connectTo_4.getName();
        String _firstLower_4 = StringExtensions.toFirstLower(_name_10);
        _builder.append(_firstLower_4, "\t\t");
        _builder.append(");");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("\t\t");
    Entity _entity_5 = we.getEntity();
    String _name_11 = _entity_5.getName();
    String _firstLower_5 = StringExtensions.toFirstLower(_name_11);
    _builder.append(_firstLower_5, "\t\t");
    _builder.append("DAO.create(");
    Entity _entity_6 = we.getEntity();
    String _name_12 = _entity_6.getName();
    String _firstLower_6 = StringExtensions.toFirstLower(_name_12);
    _builder.append(_firstLower_6, "\t\t");
    _builder.append(");");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("} catch (SQLException e) {");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("e.printStackTrace();");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("return false;");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("return true;");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    _builder.append("@Override");
    _builder.newLine();
    _builder.append("public boolean create");
    Entity _entity_7 = we.getEntity();
    String _name_13 = _entity_7.getName();
    String _firstUpper_6 = StringExtensions.toFirstUpper(_name_13);
    _builder.append(_firstUpper_6, "");
    _builder.append("(");
    List<Association> _dbManyToOneForeignKeysCont_5 = we.getDbManyToOneForeignKeysCont();
    Association _get_4 = _dbManyToOneForeignKeysCont_5.get(1);
    Entity _connectTo_5 = _get_4.getConnectTo();
    String _name_14 = _connectTo_5.getName();
    String _firstUpper_7 = StringExtensions.toFirstUpper(_name_14);
    _builder.append(_firstUpper_7, "");
    _builder.append(" ");
    List<Association> _dbManyToOneForeignKeysCont_6 = we.getDbManyToOneForeignKeysCont();
    Association _get_5 = _dbManyToOneForeignKeysCont_6.get(1);
    Entity _connectTo_6 = _get_5.getConnectTo();
    String _name_15 = _connectTo_6.getName();
    String _firstLower_7 = StringExtensions.toFirstLower(_name_15);
    _builder.append(_firstLower_7, "");
    _builder.append(", ");
    List<Association> _dbManyToOneForeignKeysCont_7 = we.getDbManyToOneForeignKeysCont();
    Association _get_6 = _dbManyToOneForeignKeysCont_7.get(0);
    Entity _connectTo_7 = _get_6.getConnectTo();
    String _name_16 = _connectTo_7.getName();
    String _firstUpper_8 = StringExtensions.toFirstUpper(_name_16);
    _builder.append(_firstUpper_8, "");
    _builder.append(" ");
    List<Association> _dbManyToOneForeignKeysCont_8 = we.getDbManyToOneForeignKeysCont();
    Association _get_7 = _dbManyToOneForeignKeysCont_8.get(0);
    Entity _connectTo_8 = _get_7.getConnectTo();
    String _name_17 = _connectTo_8.getName();
    String _firstLower_8 = StringExtensions.toFirstLower(_name_17);
    _builder.append(_firstLower_8, "");
    _builder.append("){");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("try {");
    _builder.newLine();
    _builder.append("\t\t");
    Entity _entity_8 = we.getEntity();
    String _name_18 = _entity_8.getName();
    String _firstUpper_9 = StringExtensions.toFirstUpper(_name_18);
    _builder.append(_firstUpper_9, "\t\t");
    _builder.append(" ");
    Entity _entity_9 = we.getEntity();
    String _name_19 = _entity_9.getName();
    String _firstLower_9 = StringExtensions.toFirstLower(_name_19);
    _builder.append(_firstLower_9, "\t\t");
    _builder.append(" = new ");
    Entity _entity_10 = we.getEntity();
    String _name_20 = _entity_10.getName();
    String _firstUpper_10 = StringExtensions.toFirstUpper(_name_20);
    _builder.append(_firstUpper_10, "\t\t");
    _builder.append("();");
    _builder.newLineIfNotEmpty();
    {
      List<Association> _dbManyToOneForeignKeysCont_9 = we.getDbManyToOneForeignKeysCont();
      for(final Association f_1 : _dbManyToOneForeignKeysCont_9) {
        _builder.append("\t\t");
        Entity _entity_11 = we.getEntity();
        String _name_21 = _entity_11.getName();
        String _firstLower_10 = StringExtensions.toFirstLower(_name_21);
        _builder.append(_firstLower_10, "\t\t");
        _builder.append(".set");
        String _name_22 = f_1.getName();
        String _firstUpper_11 = StringExtensions.toFirstUpper(_name_22);
        _builder.append(_firstUpper_11, "\t\t");
        _builder.append("(");
        Entity _connectTo_9 = f_1.getConnectTo();
        String _name_23 = _connectTo_9.getName();
        String _firstLower_11 = StringExtensions.toFirstLower(_name_23);
        _builder.append(_firstLower_11, "\t\t");
        _builder.append(");");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("\t\t");
    Entity _entity_12 = we.getEntity();
    String _name_24 = _entity_12.getName();
    String _firstLower_12 = StringExtensions.toFirstLower(_name_24);
    _builder.append(_firstLower_12, "\t\t");
    _builder.append("DAO.create(");
    Entity _entity_13 = we.getEntity();
    String _name_25 = _entity_13.getName();
    String _firstLower_13 = StringExtensions.toFirstLower(_name_25);
    _builder.append(_firstLower_13, "\t\t");
    _builder.append(");");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("} catch (SQLException e) {");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("e.printStackTrace();");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("return false;");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("return true;");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    return _builder;
  }
}
