package hu.bme.mit.mobilegen.datamodel.generator.database.ormlite;

import com.google.common.base.Objects;
import hu.bme.mit.mobilegen.datamodel.datamodel.Association;
import hu.bme.mit.mobilegen.datamodel.datamodel.Entity;
import hu.bme.mit.mobilegen.datamodel.generator.GeneratorConstants;
import hu.bme.mit.mobilegen.datamodel.generator.GeneratorData;
import hu.bme.mit.mobilegen.datamodel.helper.GeneratorHelper;
import hu.bme.mit.mobilegen.datamodel.helper.WrappedEntity;
import hu.bme.mit.mobilegen.datamodel.logger.Log;
import java.util.ArrayList;
import java.util.List;
import org.eclipse.emf.common.util.EList;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.generator.IFileSystemAccess;
import org.eclipse.xtext.xbase.lib.StringExtensions;

@SuppressWarnings("all")
public class ORMLiteDAOInterfaceGenerator {
  private WrappedEntity wrappedEntity;
  
  private Entity entity;
  
  private List<String> imports;
  
  public void generateDAOInterface(final WrappedEntity we, final IFileSystemAccess fsa) {
    this.wrappedEntity = we;
    Entity _entity = we.getEntity();
    this.entity = _entity;
    this.collectImports();
    String _name = this.entity.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    String _plus = ("Generating " + _firstUpper);
    String _plus_1 = (_plus + "DAOInterface.java");
    Log.info(_plus_1);
    String _name_1 = this.entity.getName();
    String _firstUpper_1 = StringExtensions.toFirstUpper(_name_1);
    String _plus_2 = (_firstUpper_1 + "DAOInterface.java");
    CharSequence _generateDAOInterface = this.generateDAOInterface(this.entity);
    fsa.generateFile(_plus_2, GeneratorConstants.SRC_GEN_DB, _generateDAOInterface);
  }
  
  private boolean collectImports() {
    boolean _xblockexpression = false;
    {
      ArrayList<String> _arrayList = new ArrayList<String>();
      this.imports = _arrayList;
      String _packageName = GeneratorData.getPackageName();
      String _plus = (_packageName + ".entities.");
      Entity _entity = this.wrappedEntity.getEntity();
      String _name = _entity.getName();
      String _firstUpper = StringExtensions.toFirstUpper(_name);
      String _plus_1 = (_plus + _firstUpper);
      this.imports.add(_plus_1);
      List<Association> _dbManyToOneForeignKeysCont = this.wrappedEntity.getDbManyToOneForeignKeysCont();
      for (final Association a : _dbManyToOneForeignKeysCont) {
        String _packageName_1 = GeneratorData.getPackageName();
        String _plus_2 = (_packageName_1 + ".entities.");
        Entity _connectTo = a.getConnectTo();
        String _name_1 = _connectTo.getName();
        String _firstUpper_1 = StringExtensions.toFirstUpper(_name_1);
        String _plus_3 = (_plus_2 + _firstUpper_1);
        this.imports.add(_plus_3);
      }
      List<Association> _dbOneToOneForeignKeysContInv = this.wrappedEntity.getDbOneToOneForeignKeysContInv();
      for (final Association a_1 : _dbOneToOneForeignKeysContInv) {
        String _packageName_2 = GeneratorData.getPackageName();
        String _plus_4 = (_packageName_2 + ".entities.");
        Entity _connectTo_1 = a_1.getConnectTo();
        String _name_2 = _connectTo_1.getName();
        String _firstUpper_2 = StringExtensions.toFirstUpper(_name_2);
        String _plus_5 = (_plus_4 + _firstUpper_2);
        this.imports.add(_plus_5);
      }
      List<Association> _dbManyToOneForeignKeys = this.wrappedEntity.getDbManyToOneForeignKeys();
      for (final Association a_2 : _dbManyToOneForeignKeys) {
        String _packageName_3 = GeneratorData.getPackageName();
        String _plus_6 = (_packageName_3 + ".entities.");
        Entity _connectTo_2 = a_2.getConnectTo();
        String _name_3 = _connectTo_2.getName();
        String _firstUpper_3 = StringExtensions.toFirstUpper(_name_3);
        String _plus_7 = (_plus_6 + _firstUpper_3);
        this.imports.add(_plus_7);
      }
      List<Association> _dbOneToOneForeignKeysInv = this.wrappedEntity.getDbOneToOneForeignKeysInv();
      for (final Association a_3 : _dbOneToOneForeignKeysInv) {
        String _packageName_4 = GeneratorData.getPackageName();
        String _plus_8 = (_packageName_4 + ".entities.");
        Entity _connectTo_3 = a_3.getConnectTo();
        String _name_4 = _connectTo_3.getName();
        String _firstUpper_4 = StringExtensions.toFirstUpper(_name_4);
        String _plus_9 = (_plus_8 + _firstUpper_4);
        this.imports.add(_plus_9);
      }
      List<Entity> _dbManyToManyJoinTable = this.wrappedEntity.getDbManyToManyJoinTable();
      for (final Entity e : _dbManyToManyJoinTable) {
        EList<Association> _association = e.getAssociation();
        for (final Association a_4 : _association) {
          Entity _connectTo_4 = a_4.getConnectTo();
          String _name_5 = _connectTo_4.getName();
          String _name_6 = this.entity.getName();
          boolean _equals = _name_5.equals(_name_6);
          boolean _not = (!_equals);
          if (_not) {
            String _packageName_5 = GeneratorData.getPackageName();
            String _plus_10 = (_packageName_5 + ".entities.");
            Entity _connectTo_5 = a_4.getConnectTo();
            String _name_7 = _connectTo_5.getName();
            String _firstUpper_5 = StringExtensions.toFirstUpper(_name_7);
            String _plus_11 = (_plus_10 + _firstUpper_5);
            this.imports.add(_plus_11);
          }
        }
      }
      this.imports.add("java.util.List");
      _xblockexpression = this.imports.add("com.j256.ormlite.dao.Dao");
    }
    return _xblockexpression;
  }
  
  private CharSequence generateDAOInterface(final Entity e) {
    StringConcatenation _builder = new StringConcatenation();
    CharSequence _classHeader = this.classHeader(e);
    _builder.append(_classHeader, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _packageDeclaration = this.packageDeclaration();
    _builder.append(_packageDeclaration, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _classImports = this.classImports(e);
    _builder.append(_classImports, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("//");
    _builder.newLine();
    CharSequence _classDeclaration = this.classDeclaration(e);
    _builder.append(_classDeclaration, "");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence classHeader(final Entity e) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//------------------------- Geneated Java Class File For ");
    String _name = e.getName();
    _builder.append(_name, "");
    _builder.append("DAOInterface Class ---------------------------------");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence packageDeclaration() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("package ");
    String _packageName = GeneratorData.getPackageName();
    _builder.append(_packageName, "");
    _builder.append(".");
    _builder.append(GeneratorConstants.SRC_GEN_DB, "");
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence classImports(final Entity e) {
    StringConcatenation _builder = new StringConcatenation();
    {
      for(final String f : this.imports) {
        _builder.append("import ");
        _builder.append(f, "");
        _builder.append(";");
        _builder.newLineIfNotEmpty();
      }
    }
    return _builder;
  }
  
  private CharSequence classJavaDoc(final Entity e) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("/**");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <!-- begin-user-doc -->");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* This Class contains the representation of the model object \'<em><b></b></em>\'.");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* For each Entity the generator creates an EntityGEN.java file,");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* which contains EntityGEN class with every Property and Association for the Entity.");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* This Java file will be override, with each generation.");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* The generator creates an Entity.java file, with the Entity class,");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* which extends form EntityGEN. This file normally (if the Entity is not deleted)");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* won\'t be overrided, so this file can be modified between the generations.");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* ");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* This is The EntityGEN.java file. It must contain only the generated code.");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* Do not edit it, or it will be overrided with each generation!");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* </p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <!-- end-user-doc -->");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* The following features are supported:");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <ul>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getCache <em>Cache</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getPersistentType <em>Persistent Type</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#isAbstract <em>Abstract</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getName <em>Name</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getSuperType <em>Super Type</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getRelationship <em>Relationship</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getProperty <em>Property</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* </ul>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* </p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* @see hu.bme.hellga.onlab.OnlabPackage#getEntity()");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* @model");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* @generated");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*/");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence classDeclaration(final Entity e) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("public interface ");
    String _name = e.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    _builder.append(_firstUpper, "");
    _builder.append("DAOInterface {");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    CharSequence _classBody = this.classBody(e);
    _builder.append(_classBody, "\t");
    _builder.newLineIfNotEmpty();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence classBody(final Entity e) {
    StringConcatenation _builder = new StringConcatenation();
    CharSequence _create = this.create(e);
    _builder.append(_create, "");
    _builder.newLineIfNotEmpty();
    _builder.append("public boolean update");
    String _name = e.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    _builder.append(_firstUpper, "");
    _builder.append("(");
    String _name_1 = e.getName();
    String _firstUpper_1 = StringExtensions.toFirstUpper(_name_1);
    _builder.append(_firstUpper_1, "");
    _builder.append(" ");
    String _name_2 = e.getName();
    String _firstLower = StringExtensions.toFirstLower(_name_2);
    _builder.append(_firstLower, "");
    _builder.append(");");
    _builder.newLineIfNotEmpty();
    _builder.append("public boolean delete");
    String _name_3 = e.getName();
    String _firstUpper_2 = StringExtensions.toFirstUpper(_name_3);
    _builder.append(_firstUpper_2, "");
    _builder.append("(");
    String _name_4 = e.getName();
    String _firstUpper_3 = StringExtensions.toFirstUpper(_name_4);
    _builder.append(_firstUpper_3, "");
    _builder.append(" ");
    String _name_5 = e.getName();
    String _firstLower_1 = StringExtensions.toFirstLower(_name_5);
    _builder.append(_firstLower_1, "");
    _builder.append(");");
    _builder.newLineIfNotEmpty();
    _builder.append("public boolean delete");
    String _name_6 = e.getName();
    String _firstUpper_4 = StringExtensions.toFirstUpper(_name_6);
    _builder.append(_firstUpper_4, "");
    _builder.append("s(List<");
    String _name_7 = e.getName();
    String _firstUpper_5 = StringExtensions.toFirstUpper(_name_7);
    _builder.append(_firstUpper_5, "");
    _builder.append("> ");
    String _name_8 = e.getName();
    String _firstLower_2 = StringExtensions.toFirstLower(_name_8);
    _builder.append(_firstLower_2, "");
    _builder.append(");");
    _builder.newLineIfNotEmpty();
    _builder.append("public boolean refresh");
    String _name_9 = e.getName();
    String _firstUpper_6 = StringExtensions.toFirstUpper(_name_9);
    _builder.append(_firstUpper_6, "");
    _builder.append("(");
    String _name_10 = e.getName();
    String _firstUpper_7 = StringExtensions.toFirstUpper(_name_10);
    _builder.append(_firstUpper_7, "");
    _builder.append(" ");
    String _name_11 = e.getName();
    String _firstLower_3 = StringExtensions.toFirstLower(_name_11);
    _builder.append(_firstLower_3, "");
    _builder.append(");");
    _builder.newLineIfNotEmpty();
    _builder.append("public List<");
    String _name_12 = e.getName();
    String _firstUpper_8 = StringExtensions.toFirstUpper(_name_12);
    _builder.append(_firstUpper_8, "");
    _builder.append("> get");
    String _name_13 = e.getName();
    String _firstUpper_9 = StringExtensions.toFirstUpper(_name_13);
    _builder.append(_firstUpper_9, "");
    _builder.append("s();");
    _builder.newLineIfNotEmpty();
    CharSequence _byContainment = this.getByContainment(e);
    _builder.append(_byContainment, "");
    _builder.newLineIfNotEmpty();
    CharSequence _byReference = this.getByReference(e);
    _builder.append(_byReference, "");
    _builder.newLineIfNotEmpty();
    _builder.append("public ");
    String _name_14 = e.getName();
    String _firstUpper_10 = StringExtensions.toFirstUpper(_name_14);
    _builder.append(_firstUpper_10, "");
    _builder.append(" get");
    String _name_15 = e.getName();
    String _firstUpper_11 = StringExtensions.toFirstUpper(_name_15);
    _builder.append(_firstUpper_11, "");
    _builder.append("ByID(int id);");
    _builder.newLineIfNotEmpty();
    _builder.append("public Dao<");
    String _name_16 = e.getName();
    String _firstUpper_12 = StringExtensions.toFirstUpper(_name_16);
    _builder.append(_firstUpper_12, "");
    _builder.append(", Integer> getDAO();");
    _builder.newLineIfNotEmpty();
    CharSequence _others = this.others(this.wrappedEntity);
    _builder.append(_others, "");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence create(final Entity e) {
    StringConcatenation _builder = new StringConcatenation();
    {
      List<Association> _dbManyToOneForeignKeysCont = this.wrappedEntity.getDbManyToOneForeignKeysCont();
      for(final Association f : _dbManyToOneForeignKeysCont) {
        _builder.append("public boolean create");
        String _name = e.getName();
        String _firstUpper = StringExtensions.toFirstUpper(_name);
        _builder.append(_firstUpper, "");
        _builder.append("(");
        Entity _connectTo = f.getConnectTo();
        String _name_1 = _connectTo.getName();
        String _firstUpper_1 = StringExtensions.toFirstUpper(_name_1);
        _builder.append(_firstUpper_1, "");
        _builder.append(" ");
        Entity _connectTo_1 = f.getConnectTo();
        String _name_2 = _connectTo_1.getName();
        String _firstLower = StringExtensions.toFirstLower(_name_2);
        _builder.append(_firstLower, "");
        _builder.append(", ");
        String _name_3 = e.getName();
        String _firstUpper_2 = StringExtensions.toFirstUpper(_name_3);
        _builder.append(_firstUpper_2, "");
        _builder.append(" ");
        String _name_4 = e.getName();
        String _firstLower_1 = StringExtensions.toFirstLower(_name_4);
        _builder.append(_firstLower_1, "");
        _builder.append(");");
        _builder.newLineIfNotEmpty();
      }
    }
    {
      List<Association> _dbOneToOneForeignKeysContInv = this.wrappedEntity.getDbOneToOneForeignKeysContInv();
      for(final Association f_1 : _dbOneToOneForeignKeysContInv) {
        _builder.append("public boolean create");
        String _name_5 = e.getName();
        String _firstUpper_3 = StringExtensions.toFirstUpper(_name_5);
        _builder.append(_firstUpper_3, "");
        _builder.append("(");
        Entity _connectTo_2 = f_1.getConnectTo();
        String _name_6 = _connectTo_2.getName();
        String _firstUpper_4 = StringExtensions.toFirstUpper(_name_6);
        _builder.append(_firstUpper_4, "");
        _builder.append(" ");
        Entity _connectTo_3 = f_1.getConnectTo();
        String _name_7 = _connectTo_3.getName();
        String _firstLower_2 = StringExtensions.toFirstLower(_name_7);
        _builder.append(_firstLower_2, "");
        _builder.append(", ");
        String _name_8 = e.getName();
        String _firstUpper_5 = StringExtensions.toFirstUpper(_name_8);
        _builder.append(_firstUpper_5, "");
        _builder.append(" ");
        String _name_9 = e.getName();
        String _firstLower_3 = StringExtensions.toFirstLower(_name_9);
        _builder.append(_firstLower_3, "");
        _builder.append(");");
        _builder.newLineIfNotEmpty();
      }
    }
    {
      boolean _isOnlyInContainment = e.isOnlyInContainment();
      boolean _not = (!_isOnlyInContainment);
      if (_not) {
        _builder.append("public boolean create");
        String _name_10 = e.getName();
        String _firstUpper_6 = StringExtensions.toFirstUpper(_name_10);
        _builder.append(_firstUpper_6, "");
        _builder.append("(");
        String _name_11 = e.getName();
        String _firstUpper_7 = StringExtensions.toFirstUpper(_name_11);
        _builder.append(_firstUpper_7, "");
        _builder.append(" ");
        String _name_12 = e.getName();
        String _firstLower_4 = StringExtensions.toFirstLower(_name_12);
        _builder.append(_firstLower_4, "");
        _builder.append(");");
        _builder.newLineIfNotEmpty();
      }
    }
    return _builder;
  }
  
  private CharSequence getByContainment(final Entity e) {
    StringConcatenation _builder = new StringConcatenation();
    {
      List<Association> _dbManyToOneForeignKeysCont = this.wrappedEntity.getDbManyToOneForeignKeysCont();
      for(final Association f : _dbManyToOneForeignKeysCont) {
        _builder.append("public List<");
        String _name = e.getName();
        String _firstUpper = StringExtensions.toFirstUpper(_name);
        _builder.append(_firstUpper, "");
        _builder.append("> get");
        String _name_1 = e.getName();
        String _firstUpper_1 = StringExtensions.toFirstUpper(_name_1);
        _builder.append(_firstUpper_1, "");
        _builder.append("sBy");
        Entity _connectTo = f.getConnectTo();
        String _name_2 = _connectTo.getName();
        String _firstUpper_2 = StringExtensions.toFirstUpper(_name_2);
        _builder.append(_firstUpper_2, "");
        _builder.append("Containment(");
        Entity _connectTo_1 = f.getConnectTo();
        String _name_3 = _connectTo_1.getName();
        String _firstUpper_3 = StringExtensions.toFirstUpper(_name_3);
        _builder.append(_firstUpper_3, "");
        _builder.append(" ");
        Entity _connectTo_2 = f.getConnectTo();
        String _name_4 = _connectTo_2.getName();
        String _firstLower = StringExtensions.toFirstLower(_name_4);
        _builder.append(_firstLower, "");
        _builder.append(");");
        _builder.newLineIfNotEmpty();
      }
    }
    {
      List<Association> _dbOneToOneForeignKeysContInv = this.wrappedEntity.getDbOneToOneForeignKeysContInv();
      for(final Association f_1 : _dbOneToOneForeignKeysContInv) {
        _builder.append("public ");
        String _name_5 = e.getName();
        String _firstUpper_4 = StringExtensions.toFirstUpper(_name_5);
        _builder.append(_firstUpper_4, "");
        _builder.append(" get");
        String _name_6 = e.getName();
        String _firstUpper_5 = StringExtensions.toFirstUpper(_name_6);
        _builder.append(_firstUpper_5, "");
        _builder.append("By");
        Entity _connectTo_3 = f_1.getConnectTo();
        String _name_7 = _connectTo_3.getName();
        String _firstUpper_6 = StringExtensions.toFirstUpper(_name_7);
        _builder.append(_firstUpper_6, "");
        _builder.append("Containment(");
        Entity _connectTo_4 = f_1.getConnectTo();
        String _name_8 = _connectTo_4.getName();
        String _firstUpper_7 = StringExtensions.toFirstUpper(_name_8);
        _builder.append(_firstUpper_7, "");
        _builder.append(" ");
        Entity _connectTo_5 = f_1.getConnectTo();
        String _name_9 = _connectTo_5.getName();
        String _firstLower_1 = StringExtensions.toFirstLower(_name_9);
        _builder.append(_firstLower_1, "");
        _builder.append(");");
        _builder.newLineIfNotEmpty();
      }
    }
    return _builder;
  }
  
  private CharSequence getByReference(final Entity e) {
    StringConcatenation _builder = new StringConcatenation();
    {
      List<Association> _dbManyToOneForeignKeys = this.wrappedEntity.getDbManyToOneForeignKeys();
      for(final Association f : _dbManyToOneForeignKeys) {
        _builder.append("public List<");
        String _name = e.getName();
        String _firstUpper = StringExtensions.toFirstUpper(_name);
        _builder.append(_firstUpper, "");
        _builder.append("> get");
        String _name_1 = e.getName();
        String _firstUpper_1 = StringExtensions.toFirstUpper(_name_1);
        _builder.append(_firstUpper_1, "");
        _builder.append("sBy");
        Entity _connectTo = f.getConnectTo();
        String _name_2 = _connectTo.getName();
        String _firstUpper_2 = StringExtensions.toFirstUpper(_name_2);
        _builder.append(_firstUpper_2, "");
        _builder.append("Reference(");
        Entity _connectTo_1 = f.getConnectTo();
        String _name_3 = _connectTo_1.getName();
        String _firstUpper_3 = StringExtensions.toFirstUpper(_name_3);
        _builder.append(_firstUpper_3, "");
        _builder.append(" ");
        Entity _connectTo_2 = f.getConnectTo();
        String _name_4 = _connectTo_2.getName();
        String _firstLower = StringExtensions.toFirstLower(_name_4);
        _builder.append(_firstLower, "");
        _builder.append(");");
        _builder.newLineIfNotEmpty();
      }
    }
    {
      List<Association> _dbOneToOneForeignKeysInv = this.wrappedEntity.getDbOneToOneForeignKeysInv();
      for(final Association f_1 : _dbOneToOneForeignKeysInv) {
        _builder.append("public ");
        String _name_5 = e.getName();
        String _firstUpper_4 = StringExtensions.toFirstUpper(_name_5);
        _builder.append(_firstUpper_4, "");
        _builder.append(" get");
        String _name_6 = e.getName();
        String _firstUpper_5 = StringExtensions.toFirstUpper(_name_6);
        _builder.append(_firstUpper_5, "");
        _builder.append("By");
        Entity _connectTo_3 = f_1.getConnectTo();
        String _name_7 = _connectTo_3.getName();
        String _firstUpper_6 = StringExtensions.toFirstUpper(_name_7);
        _builder.append(_firstUpper_6, "");
        _builder.append("Reference(");
        Entity _connectTo_4 = f_1.getConnectTo();
        String _name_8 = _connectTo_4.getName();
        String _firstUpper_7 = StringExtensions.toFirstUpper(_name_8);
        _builder.append(_firstUpper_7, "");
        _builder.append(" ");
        Entity _connectTo_5 = f_1.getConnectTo();
        String _name_9 = _connectTo_5.getName();
        String _firstLower_1 = StringExtensions.toFirstLower(_name_9);
        _builder.append(_firstLower_1, "");
        _builder.append(");");
        _builder.newLineIfNotEmpty();
      }
    }
    return _builder;
  }
  
  private CharSequence others(final WrappedEntity we) {
    StringConcatenation _builder = new StringConcatenation();
    {
      GeneratorHelper _genHelp = this.wrappedEntity.getGenHelp();
      boolean _equals = Objects.equal(_genHelp, GeneratorHelper.JoinClass);
      if (_equals) {
        CharSequence _manyToManyJoinTable = this.manyToManyJoinTable(this.wrappedEntity);
        _builder.append(_manyToManyJoinTable, "");
        _builder.newLineIfNotEmpty();
      }
    }
    {
      boolean _isHasJoinTable = this.wrappedEntity.isHasJoinTable();
      if (_isHasJoinTable) {
        CharSequence _manyToManyConnection = this.manyToManyConnection(this.wrappedEntity);
        _builder.append(_manyToManyConnection, "");
        _builder.newLineIfNotEmpty();
      }
    }
    return _builder;
  }
  
  private CharSequence manyToManyConnection(final WrappedEntity we) {
    StringConcatenation _builder = new StringConcatenation();
    {
      boolean _isHasJoinTable = this.wrappedEntity.isHasJoinTable();
      if (_isHasJoinTable) {
        {
          List<Entity> _dbManyToManyJoinTable = this.wrappedEntity.getDbManyToManyJoinTable();
          for(final Entity f : _dbManyToManyJoinTable) {
            CharSequence _manyToMany = this.manyToMany(we, f);
            _builder.append(_manyToMany, "");
            _builder.newLineIfNotEmpty();
          }
        }
      }
    }
    return _builder;
  }
  
  private CharSequence manyToMany(final WrappedEntity we, final Entity join) {
    StringConcatenation _builder = new StringConcatenation();
    {
      EList<Association> _association = join.getAssociation();
      for(final Association f : _association) {
        {
          Entity _connectTo = f.getConnectTo();
          String _name = _connectTo.getName();
          Entity _entity = we.getEntity();
          String _name_1 = _entity.getName();
          boolean _equals = _name.equals(_name_1);
          boolean _not = (!_equals);
          if (_not) {
            _builder.append("public void set");
            Entity _connectTo_1 = f.getConnectTo();
            String _name_2 = _connectTo_1.getName();
            String _firstUpper = StringExtensions.toFirstUpper(_name_2);
            _builder.append(_firstUpper, "");
            _builder.append("To");
            Entity _entity_1 = we.getEntity();
            String _name_3 = _entity_1.getName();
            String _firstUpper_1 = StringExtensions.toFirstUpper(_name_3);
            _builder.append(_firstUpper_1, "");
            _builder.append("(");
            Entity _connectTo_2 = f.getConnectTo();
            String _name_4 = _connectTo_2.getName();
            String _firstUpper_2 = StringExtensions.toFirstUpper(_name_4);
            _builder.append(_firstUpper_2, "");
            _builder.append(" ");
            Entity _connectTo_3 = f.getConnectTo();
            String _name_5 = _connectTo_3.getName();
            String _firstLower = StringExtensions.toFirstLower(_name_5);
            _builder.append(_firstLower, "");
            _builder.append(", ");
            Entity _entity_2 = we.getEntity();
            String _name_6 = _entity_2.getName();
            String _firstUpper_3 = StringExtensions.toFirstUpper(_name_6);
            _builder.append(_firstUpper_3, "");
            _builder.append(" ");
            Entity _entity_3 = we.getEntity();
            String _name_7 = _entity_3.getName();
            String _firstLower_1 = StringExtensions.toFirstLower(_name_7);
            _builder.append(_firstLower_1, "");
            _builder.append(");");
            _builder.newLineIfNotEmpty();
            _builder.append("public List<");
            Entity _connectTo_4 = f.getConnectTo();
            String _name_8 = _connectTo_4.getName();
            String _firstUpper_4 = StringExtensions.toFirstUpper(_name_8);
            _builder.append(_firstUpper_4, "");
            _builder.append("> get");
            Entity _connectTo_5 = f.getConnectTo();
            String _name_9 = _connectTo_5.getName();
            String _firstUpper_5 = StringExtensions.toFirstUpper(_name_9);
            _builder.append(_firstUpper_5, "");
            _builder.append("sBy");
            Entity _entity_4 = we.getEntity();
            String _name_10 = _entity_4.getName();
            String _firstUpper_6 = StringExtensions.toFirstUpper(_name_10);
            _builder.append(_firstUpper_6, "");
            _builder.append("(");
            Entity _entity_5 = we.getEntity();
            String _name_11 = _entity_5.getName();
            String _firstUpper_7 = StringExtensions.toFirstUpper(_name_11);
            _builder.append(_firstUpper_7, "");
            _builder.append(" ");
            Entity _entity_6 = we.getEntity();
            String _name_12 = _entity_6.getName();
            String _firstUpper_8 = StringExtensions.toFirstUpper(_name_12);
            _builder.append(_firstUpper_8, "");
            _builder.append(");");
            _builder.newLineIfNotEmpty();
            _builder.append("public boolean remove");
            Entity _connectTo_6 = f.getConnectTo();
            String _name_13 = _connectTo_6.getName();
            String _firstUpper_9 = StringExtensions.toFirstUpper(_name_13);
            _builder.append(_firstUpper_9, "");
            _builder.append("By");
            Entity _entity_7 = we.getEntity();
            String _name_14 = _entity_7.getName();
            String _firstUpper_10 = StringExtensions.toFirstUpper(_name_14);
            _builder.append(_firstUpper_10, "");
            _builder.append("(");
            Entity _connectTo_7 = f.getConnectTo();
            String _name_15 = _connectTo_7.getName();
            String _firstUpper_11 = StringExtensions.toFirstUpper(_name_15);
            _builder.append(_firstUpper_11, "");
            _builder.append(" ");
            Entity _connectTo_8 = f.getConnectTo();
            String _name_16 = _connectTo_8.getName();
            String _firstLower_2 = StringExtensions.toFirstLower(_name_16);
            _builder.append(_firstLower_2, "");
            _builder.append(", ");
            Entity _entity_8 = we.getEntity();
            String _name_17 = _entity_8.getName();
            String _firstUpper_12 = StringExtensions.toFirstUpper(_name_17);
            _builder.append(_firstUpper_12, "");
            _builder.append(" ");
            Entity _entity_9 = we.getEntity();
            String _name_18 = _entity_9.getName();
            String _firstLower_3 = StringExtensions.toFirstLower(_name_18);
            _builder.append(_firstLower_3, "");
            _builder.append(");");
            _builder.newLineIfNotEmpty();
          }
        }
      }
    }
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence manyToManyJoinTable(final WrappedEntity we) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("public boolean create");
    Entity _entity = we.getEntity();
    String _name = _entity.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    _builder.append(_firstUpper, "");
    _builder.append("(");
    List<Association> _dbManyToOneForeignKeysCont = we.getDbManyToOneForeignKeysCont();
    Association _get = _dbManyToOneForeignKeysCont.get(0);
    Entity _connectTo = _get.getConnectTo();
    String _name_1 = _connectTo.getName();
    String _firstUpper_1 = StringExtensions.toFirstUpper(_name_1);
    _builder.append(_firstUpper_1, "");
    _builder.append(" ");
    List<Association> _dbManyToOneForeignKeysCont_1 = we.getDbManyToOneForeignKeysCont();
    Association _get_1 = _dbManyToOneForeignKeysCont_1.get(0);
    Entity _connectTo_1 = _get_1.getConnectTo();
    String _name_2 = _connectTo_1.getName();
    String _firstLower = StringExtensions.toFirstLower(_name_2);
    _builder.append(_firstLower, "");
    _builder.append(", ");
    List<Association> _dbManyToOneForeignKeysCont_2 = we.getDbManyToOneForeignKeysCont();
    Association _get_2 = _dbManyToOneForeignKeysCont_2.get(1);
    Entity _connectTo_2 = _get_2.getConnectTo();
    String _name_3 = _connectTo_2.getName();
    String _firstUpper_2 = StringExtensions.toFirstUpper(_name_3);
    _builder.append(_firstUpper_2, "");
    _builder.append(" ");
    List<Association> _dbManyToOneForeignKeysCont_3 = we.getDbManyToOneForeignKeysCont();
    Association _get_3 = _dbManyToOneForeignKeysCont_3.get(1);
    Entity _connectTo_3 = _get_3.getConnectTo();
    String _name_4 = _connectTo_3.getName();
    String _firstLower_1 = StringExtensions.toFirstLower(_name_4);
    _builder.append(_firstLower_1, "");
    _builder.append(");");
    _builder.newLineIfNotEmpty();
    _builder.append("public boolean create");
    Entity _entity_1 = we.getEntity();
    String _name_5 = _entity_1.getName();
    String _firstUpper_3 = StringExtensions.toFirstUpper(_name_5);
    _builder.append(_firstUpper_3, "");
    _builder.append("(");
    List<Association> _dbManyToOneForeignKeysCont_4 = we.getDbManyToOneForeignKeysCont();
    Association _get_4 = _dbManyToOneForeignKeysCont_4.get(1);
    Entity _connectTo_4 = _get_4.getConnectTo();
    String _name_6 = _connectTo_4.getName();
    String _firstUpper_4 = StringExtensions.toFirstUpper(_name_6);
    _builder.append(_firstUpper_4, "");
    _builder.append(" ");
    List<Association> _dbManyToOneForeignKeysCont_5 = we.getDbManyToOneForeignKeysCont();
    Association _get_5 = _dbManyToOneForeignKeysCont_5.get(1);
    Entity _connectTo_5 = _get_5.getConnectTo();
    String _name_7 = _connectTo_5.getName();
    String _firstLower_2 = StringExtensions.toFirstLower(_name_7);
    _builder.append(_firstLower_2, "");
    _builder.append(", ");
    List<Association> _dbManyToOneForeignKeysCont_6 = we.getDbManyToOneForeignKeysCont();
    Association _get_6 = _dbManyToOneForeignKeysCont_6.get(0);
    Entity _connectTo_6 = _get_6.getConnectTo();
    String _name_8 = _connectTo_6.getName();
    String _firstUpper_5 = StringExtensions.toFirstUpper(_name_8);
    _builder.append(_firstUpper_5, "");
    _builder.append(" ");
    List<Association> _dbManyToOneForeignKeysCont_7 = we.getDbManyToOneForeignKeysCont();
    Association _get_7 = _dbManyToOneForeignKeysCont_7.get(0);
    Entity _connectTo_7 = _get_7.getConnectTo();
    String _name_9 = _connectTo_7.getName();
    String _firstLower_3 = StringExtensions.toFirstLower(_name_9);
    _builder.append(_firstLower_3, "");
    _builder.append(");");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
}
