package hu.bme.mit.mobilegen.datamodel.generator.database.ormlite;

import hu.bme.mit.mobilegen.datamodel.datamodel.Entity;
import hu.bme.mit.mobilegen.datamodel.generator.GeneratorConstants;
import hu.bme.mit.mobilegen.datamodel.generator.GeneratorData;
import hu.bme.mit.mobilegen.datamodel.helper.WrappedEntity;
import hu.bme.mit.mobilegen.datamodel.logger.Log;
import java.util.ArrayList;
import java.util.List;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.generator.IFileSystemAccess;
import org.eclipse.xtext.xbase.lib.StringExtensions;

@SuppressWarnings("all")
public class ORMLiteDataCacheGenerator {
  private List<WrappedEntity> wes;
  
  private List<String> imports;
  
  public void generateDataCache(final List<WrappedEntity> entities, final IFileSystemAccess fsa) {
    ArrayList<WrappedEntity> _arrayList = new ArrayList<WrappedEntity>();
    this.wes = _arrayList;
    for (final WrappedEntity we : entities) {
      Entity _entity = we.getEntity();
      boolean _isCache = _entity.isCache();
      if (_isCache) {
        this.wes.add(we);
      }
    }
    this.collectImports();
    Log.info("Generating DataCache.java");
    CharSequence _generateDataCache = this.generateDataCache();
    fsa.generateFile("DataCache.java", GeneratorConstants.SRC_GEN_DB, _generateDataCache);
  }
  
  public void generateGenericDAOInterface(final IFileSystemAccess fsa) {
    Log.info("GenericDAOInterface.java");
    CharSequence _generateGenericDAOInterface = this.generateGenericDAOInterface();
    fsa.generateFile("GenericDAOInterface.java", GeneratorConstants.SRC_GEN_DB, _generateGenericDAOInterface);
  }
  
  public void generateGenericDAO(final IFileSystemAccess fsa) {
    Log.info("GenericDAO.java");
    CharSequence _generateGenericDAO = this.generateGenericDAO();
    fsa.generateFile("GenericDAO.java", GeneratorConstants.SRC_GEN_DB, _generateGenericDAO);
  }
  
  private boolean collectImports() {
    boolean _xblockexpression = false;
    {
      ArrayList<String> _arrayList = new ArrayList<String>();
      this.imports = _arrayList;
      for (final WrappedEntity we : this.wes) {
        String _packageName = GeneratorData.getPackageName();
        String _plus = (_packageName + ".entities.");
        Entity _entity = we.getEntity();
        String _name = _entity.getName();
        String _firstUpper = StringExtensions.toFirstUpper(_name);
        String _plus_1 = (_plus + _firstUpper);
        this.imports.add(_plus_1);
      }
      this.imports.add("java.sql.SQLException");
      this.imports.add("java.util.ArrayList");
      _xblockexpression = this.imports.add("java.util.List");
    }
    return _xblockexpression;
  }
  
  private CharSequence generateDataCache() {
    StringConcatenation _builder = new StringConcatenation();
    CharSequence _classHeader = this.classHeader();
    _builder.append(_classHeader, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _packageDeclaration = this.packageDeclaration();
    _builder.append(_packageDeclaration, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _classImports = this.classImports();
    _builder.append(_classImports, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("//");
    _builder.newLine();
    CharSequence _classDeclaration = this.classDeclaration();
    _builder.append(_classDeclaration, "");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence classHeader() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//------------------------- Geneated Java Class File For DataCache Class ---------------------------------");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence packageDeclaration() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("package ");
    String _packageName = GeneratorData.getPackageName();
    _builder.append(_packageName, "");
    _builder.append(".dbutility;");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence classImports() {
    StringConcatenation _builder = new StringConcatenation();
    {
      for(final String f : this.imports) {
        _builder.append("import ");
        _builder.append(f, "");
        _builder.append(";");
        _builder.newLineIfNotEmpty();
      }
    }
    return _builder;
  }
  
  private CharSequence classJavaDoc() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("/**");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <!-- begin-user-doc -->");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* This Class contains the representation of the model object \'<em><b></b></em>\'.");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* For each Entity the generator creates an EntityGEN.java file,");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* which contains EntityGEN class with every Property and Association for the Entity.");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* This Java file will be override, with each generation.");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* The generator creates an Entity.java file, with the Entity class,");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* which extends form EntityGEN. This file normally (if the Entity is not deleted)");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* won\'t be overrided, so this file can be modified between the generations.");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* ");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* This is The EntityGEN.java file. It must contain only the generated code.");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* Do not edit it, or it will be overrided with each generation!");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* </p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <!-- end-user-doc -->");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* The following features are supported:");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <ul>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getCache <em>Cache</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getPersistentType <em>Persistent Type</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#isAbstract <em>Abstract</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getName <em>Name</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getSuperType <em>Super Type</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getRelationship <em>Relationship</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getProperty <em>Property</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* </ul>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* </p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* @see hu.bme.hellga.onlab.OnlabPackage#getEntity()");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* @model");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* @generated");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*/");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence classDeclaration() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("public class DataCache {");
    _builder.newLine();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    CharSequence _classBody = this.classBody();
    _builder.append(_classBody, "\t");
    _builder.newLineIfNotEmpty();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence classBody() {
    StringConcatenation _builder = new StringConcatenation();
    CharSequence _properties = this.properties();
    _builder.append(_properties, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _initCache = this.initCache();
    _builder.append(_initCache, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _loadCache = this.loadCache();
    _builder.append(_loadCache, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _entities = this.getEntities();
    _builder.append(_entities, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _loadEntities = this.loadEntities();
    _builder.append(_loadEntities, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence properties() {
    StringConcatenation _builder = new StringConcatenation();
    {
      for(final WrappedEntity f : this.wes) {
        _builder.append("//");
        _builder.newLine();
        _builder.append("private static List<");
        Entity _entity = f.getEntity();
        String _name = _entity.getName();
        String _firstUpper = StringExtensions.toFirstUpper(_name);
        _builder.append(_firstUpper, "");
        _builder.append("> ");
        Entity _entity_1 = f.getEntity();
        String _name_1 = _entity_1.getName();
        String _firstLower = StringExtensions.toFirstLower(_name_1);
        _builder.append(_firstLower, "");
        _builder.append("s = new ArrayList<");
        Entity _entity_2 = f.getEntity();
        String _name_2 = _entity_2.getName();
        String _firstUpper_1 = StringExtensions.toFirstUpper(_name_2);
        _builder.append(_firstUpper_1, "");
        _builder.append(">();");
        _builder.newLineIfNotEmpty();
      }
    }
    return _builder;
  }
  
  private CharSequence initCache() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//");
    _builder.newLine();
    _builder.append("public static void initCache(){");
    _builder.newLine();
    {
      for(final WrappedEntity f : this.wes) {
        _builder.append("\t");
        _builder.append("loadCache(");
        Entity _entity = f.getEntity();
        String _name = _entity.getName();
        String _firstUpper = StringExtensions.toFirstUpper(_name);
        _builder.append(_firstUpper, "\t");
        _builder.append(".class, ");
        Entity _entity_1 = f.getEntity();
        String _name_1 = _entity_1.getName();
        String _firstLower = StringExtensions.toFirstLower(_name_1);
        _builder.append(_firstLower, "\t");
        _builder.append("s);");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence loadCache() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("@SuppressWarnings(\"unchecked\")");
    _builder.newLine();
    _builder.append("private static <T> void loadCache(Class<T> entity, List<T> cache){");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("try {");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("List<T> list = DAOFactory.getGenericDAO(entity).queryForAll();");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("for(Object o : list){");
    _builder.newLine();
    _builder.append("\t\t\t");
    _builder.append("cache.add((T)o);");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("} catch (SQLException e) {");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("e.printStackTrace();");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence getEntities() {
    StringConcatenation _builder = new StringConcatenation();
    {
      for(final WrappedEntity f : this.wes) {
        _builder.append("//");
        _builder.newLine();
        _builder.append("public static List<");
        Entity _entity = f.getEntity();
        String _name = _entity.getName();
        String _firstUpper = StringExtensions.toFirstUpper(_name);
        _builder.append(_firstUpper, "");
        _builder.append("> get");
        Entity _entity_1 = f.getEntity();
        String _name_1 = _entity_1.getName();
        String _firstUpper_1 = StringExtensions.toFirstUpper(_name_1);
        _builder.append(_firstUpper_1, "");
        _builder.append("s(){");
        _builder.newLineIfNotEmpty();
        _builder.append("\t");
        _builder.append("return ");
        Entity _entity_2 = f.getEntity();
        String _name_2 = _entity_2.getName();
        String _firstLower = StringExtensions.toFirstLower(_name_2);
        _builder.append(_firstLower, "\t");
        _builder.append("s;");
        _builder.newLineIfNotEmpty();
        _builder.append("}");
        _builder.newLine();
        _builder.newLine();
      }
    }
    return _builder;
  }
  
  private CharSequence loadEntities() {
    StringConcatenation _builder = new StringConcatenation();
    {
      for(final WrappedEntity f : this.wes) {
        _builder.append("//");
        _builder.newLine();
        _builder.append("public static void load");
        Entity _entity = f.getEntity();
        String _name = _entity.getName();
        String _firstUpper = StringExtensions.toFirstUpper(_name);
        _builder.append(_firstUpper, "");
        _builder.append("s(){");
        _builder.newLineIfNotEmpty();
        _builder.append("\t");
        Entity _entity_1 = f.getEntity();
        String _name_1 = _entity_1.getName();
        String _firstLower = StringExtensions.toFirstLower(_name_1);
        _builder.append(_firstLower, "\t");
        _builder.append("s.clear();");
        _builder.newLineIfNotEmpty();
        _builder.append("\t");
        _builder.append("loadCache(");
        Entity _entity_2 = f.getEntity();
        String _name_2 = _entity_2.getName();
        String _firstUpper_1 = StringExtensions.toFirstUpper(_name_2);
        _builder.append(_firstUpper_1, "\t");
        _builder.append(".class, ");
        Entity _entity_3 = f.getEntity();
        String _name_3 = _entity_3.getName();
        String _firstLower_1 = StringExtensions.toFirstLower(_name_3);
        _builder.append(_firstLower_1, "\t");
        _builder.append("s);");
        _builder.newLineIfNotEmpty();
        _builder.append("}");
        _builder.newLine();
        _builder.newLine();
      }
    }
    return _builder;
  }
  
  private CharSequence generateGenericDAOInterface() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("package ");
    String _packageName = GeneratorData.getPackageName();
    _builder.append(_packageName, "");
    _builder.append(".dbutility;");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("import com.j256.ormlite.dao.Dao;");
    _builder.newLine();
    _builder.newLine();
    _builder.append("public interface GenericDAOInterface {");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("public <T> Dao<T, Integer> getGenericDAO(Class<T> t);");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence generateGenericDAO() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("package ");
    String _packageName = GeneratorData.getPackageName();
    _builder.append(_packageName, "");
    _builder.append(".dbutility;");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("import java.sql.SQLException;");
    _builder.newLine();
    _builder.newLine();
    _builder.append("import com.j256.ormlite.dao.Dao;");
    _builder.newLine();
    _builder.newLine();
    _builder.append("public class GenericDAO implements GenericDAOInterface{");
    _builder.newLine();
    _builder.newLine();
    _builder.append("\t");
    _builder.append("@Override");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("public <T> Dao<T, Integer> getGenericDAO(Class<T> t) {");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("try {");
    _builder.newLine();
    _builder.append("\t\t\t");
    _builder.append("return DatabaseFactory.getGenericDAO(t);");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("} catch (SQLException e) {");
    _builder.newLine();
    _builder.append("\t\t\t");
    _builder.append("e.printStackTrace();");
    _builder.newLine();
    _builder.append("\t\t\t");
    _builder.append("return null;");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
}
