package hu.bme.mit.mobilegen.datamodel.generator.database.ormlite;

import hu.bme.mit.mobilegen.datamodel.datamodel.Entity;
import hu.bme.mit.mobilegen.datamodel.generator.GeneratorConstants;
import hu.bme.mit.mobilegen.datamodel.generator.GeneratorData;
import hu.bme.mit.mobilegen.datamodel.helper.WrappedEntity;
import hu.bme.mit.mobilegen.datamodel.logger.Log;
import java.util.ArrayList;
import java.util.List;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.generator.IFileSystemAccess;
import org.eclipse.xtext.xbase.lib.StringExtensions;

@SuppressWarnings("all")
public class ORMLiteDatabaseFactoryGenerator {
  private List<WrappedEntity> wes;
  
  private List<String> imports;
  
  public void generateDatabaseFactory(final List<WrappedEntity> entities, final IFileSystemAccess fsa) {
    this.wes = entities;
    this.collectImports();
    Log.info("Generating DatabaseFactory.java");
    CharSequence _generateDatabaseFactory = this.generateDatabaseFactory();
    fsa.generateFile("DatabaseFactory.java", GeneratorConstants.SRC_GEN_DB, _generateDatabaseFactory);
  }
  
  private boolean collectImports() {
    boolean _xblockexpression = false;
    {
      ArrayList<String> _arrayList = new ArrayList<String>();
      this.imports = _arrayList;
      for (final WrappedEntity we : this.wes) {
        String _packageName = GeneratorData.getPackageName();
        String _plus = (_packageName + ".entities.");
        Entity _entity = we.getEntity();
        String _name = _entity.getName();
        String _firstUpper = StringExtensions.toFirstUpper(_name);
        String _plus_1 = (_plus + _firstUpper);
        this.imports.add(_plus_1);
      }
      this.imports.add("java.sql.SQLException");
      this.imports.add("android.content.Context");
      this.imports.add("com.j256.ormlite.android.apptools.OpenHelperManager");
      _xblockexpression = this.imports.add("com.j256.ormlite.dao.Dao");
    }
    return _xblockexpression;
  }
  
  private CharSequence generateDatabaseFactory() {
    StringConcatenation _builder = new StringConcatenation();
    CharSequence _classHeader = this.classHeader();
    _builder.append(_classHeader, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _packageDeclaration = this.packageDeclaration();
    _builder.append(_packageDeclaration, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _classImports = this.classImports();
    _builder.append(_classImports, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("//");
    _builder.newLine();
    CharSequence _classDeclaration = this.classDeclaration();
    _builder.append(_classDeclaration, "");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence classHeader() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//------------------------- Geneated Java Class File For DatabaseFactory Class ---------------------------------");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence packageDeclaration() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("package ");
    String _packageName = GeneratorData.getPackageName();
    _builder.append(_packageName, "");
    _builder.append(".");
    _builder.append(GeneratorConstants.SRC_GEN_DB, "");
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence classImports() {
    StringConcatenation _builder = new StringConcatenation();
    {
      for(final String f : this.imports) {
        _builder.append("import ");
        _builder.append(f, "");
        _builder.append(";");
        _builder.newLineIfNotEmpty();
      }
    }
    return _builder;
  }
  
  private CharSequence classJavaDoc() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("/**");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <!-- begin-user-doc -->");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* This Class contains the representation of the model object \'<em><b></b></em>\'.");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* For each Entity the generator creates an EntityGEN.java file,");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* which contains EntityGEN class with every Property and Association for the Entity.");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* This Java file will be override, with each generation.");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* The generator creates an Entity.java file, with the Entity class,");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* which extends form EntityGEN. This file normally (if the Entity is not deleted)");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* won\'t be overrided, so this file can be modified between the generations.");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* ");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* This is The EntityGEN.java file. It must contain only the generated code.");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* Do not edit it, or it will be overrided with each generation!");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* </p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <!-- end-user-doc -->");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* The following features are supported:");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <ul>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getCache <em>Cache</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getPersistentType <em>Persistent Type</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#isAbstract <em>Abstract</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getName <em>Name</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getSuperType <em>Super Type</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getRelationship <em>Relationship</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getProperty <em>Property</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* </ul>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* </p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* @see hu.bme.hellga.onlab.OnlabPackage#getEntity()");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* @model");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* @generated");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*/");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence classDeclaration() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("class DatabaseFactory {");
    _builder.newLine();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    CharSequence _classBody = this.classBody();
    _builder.append(_classBody, "\t");
    _builder.newLineIfNotEmpty();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence classBody() {
    StringConcatenation _builder = new StringConcatenation();
    CharSequence _properties = this.properties();
    _builder.append(_properties, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _initDB = this.initDB();
    _builder.append(_initDB, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _closeDB = this.closeDB();
    _builder.append(_closeDB, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _dbName = this.dbName();
    _builder.append(_dbName, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _dbVersion = this.dbVersion();
    _builder.append(_dbVersion, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _daoGetters = this.daoGetters();
    _builder.append(_daoGetters, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _genericDAO = this.genericDAO();
    _builder.append(_genericDAO, "");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence properties() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//");
    _builder.newLine();
    _builder.append("private static DatabaseHelper dbHelper = null;");
    _builder.newLine();
    _builder.newLine();
    {
      for(final WrappedEntity f : this.wes) {
        CharSequence _daos = this.daos(f);
        _builder.append(_daos, "");
        _builder.newLineIfNotEmpty();
      }
    }
    return _builder;
  }
  
  private CharSequence daos(final WrappedEntity we) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//");
    _builder.newLine();
    CharSequence _daoDeclaration = this.daoDeclaration(we);
    _builder.append(_daoDeclaration, "");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence daoJavaDoc(final WrappedEntity we) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("/**");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* JavaDoc");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* </p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <!-- end-user-doc -->");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* The following features are supported:");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* @see hu.bme.hellga.onlab.OnlabPackage#getEntity()");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* @model");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* @generated");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*/");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence daoDeclaration(final WrappedEntity we) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("private static Dao<");
    Entity _entity = we.getEntity();
    String _name = _entity.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    _builder.append(_firstUpper, "");
    _builder.append(", Integer> ");
    Entity _entity_1 = we.getEntity();
    String _name_1 = _entity_1.getName();
    String _firstLower = StringExtensions.toFirstLower(_name_1);
    _builder.append(_firstLower, "");
    _builder.append("DAO = null;");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence initDB() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//");
    _builder.newLine();
    _builder.append("static void initDatabase(Context c){");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("if(dbHelper == null){");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("dbHelper = OpenHelperManager.getHelper(c, DatabaseHelper.class);");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("};");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence closeDB() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//");
    _builder.newLine();
    _builder.append("static void colseDatabase(){");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("if(dbHelper != null){");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("OpenHelperManager.releaseHelper();");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("dbHelper = null;");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence dbName() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//");
    _builder.newLine();
    _builder.append("static String getDBName(){");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("return DatabaseHelper.DATABASE_NAME;");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence dbVersion() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//");
    _builder.newLine();
    _builder.append("static int getDBVersion(){");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("return DatabaseHelper.DATABASE_VERSION;");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence daoGetters() {
    StringConcatenation _builder = new StringConcatenation();
    {
      for(final WrappedEntity f : this.wes) {
        _builder.append("//");
        _builder.newLine();
        CharSequence _daoGetter = this.daoGetter(f);
        _builder.append(_daoGetter, "");
        _builder.newLineIfNotEmpty();
        _builder.newLine();
      }
    }
    return _builder;
  }
  
  private CharSequence daoGetterJavaDoc(final WrappedEntity we) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("/**");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* JavaDoc");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* </p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <!-- end-user-doc -->");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* The following features are supported:");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* @see hu.bme.hellga.onlab.OnlabPackage#getEntity()");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* @model");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* @generated");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*/");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence daoGetter(final WrappedEntity we) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("static Dao<");
    Entity _entity = we.getEntity();
    String _name = _entity.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    _builder.append(_firstUpper, "");
    _builder.append(", Integer> get");
    Entity _entity_1 = we.getEntity();
    String _name_1 = _entity_1.getName();
    String _firstUpper_1 = StringExtensions.toFirstUpper(_name_1);
    _builder.append(_firstUpper_1, "");
    _builder.append("DAO() throws SQLException{");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("if(");
    Entity _entity_2 = we.getEntity();
    String _name_2 = _entity_2.getName();
    String _firstLower = StringExtensions.toFirstLower(_name_2);
    _builder.append(_firstLower, "\t");
    _builder.append("DAO == null){");
    _builder.newLineIfNotEmpty();
    _builder.append("\t\t");
    Entity _entity_3 = we.getEntity();
    String _name_3 = _entity_3.getName();
    String _firstLower_1 = StringExtensions.toFirstLower(_name_3);
    _builder.append(_firstLower_1, "\t\t");
    _builder.append("DAO = dbHelper.getDao(");
    Entity _entity_4 = we.getEntity();
    String _name_4 = _entity_4.getName();
    String _firstUpper_2 = StringExtensions.toFirstUpper(_name_4);
    _builder.append(_firstUpper_2, "\t\t");
    _builder.append(".class);");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("return ");
    Entity _entity_5 = we.getEntity();
    String _name_5 = _entity_5.getName();
    String _firstLower_2 = StringExtensions.toFirstLower(_name_5);
    _builder.append(_firstLower_2, "\t");
    _builder.append("DAO;");
    _builder.newLineIfNotEmpty();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence genericDAO() {
    StringConcatenation _builder = new StringConcatenation();
    {
      boolean _isCache = GeneratorData.isCache();
      if (_isCache) {
        _builder.append("//");
        _builder.newLine();
        _builder.append("static <T> Dao<T, Integer> getGenericDAO(Class<T> t) throws SQLException{");
        _builder.newLine();
        _builder.append("\t");
        _builder.append("return dbHelper.getDao(t);");
        _builder.newLine();
        _builder.append("}");
        _builder.newLine();
      }
    }
    return _builder;
  }
}
