package hu.bme.mit.mobilegen.datamodel.generator.database.ormlite;

import hu.bme.mit.mobilegen.datamodel.datamodel.Entity;
import hu.bme.mit.mobilegen.datamodel.generator.GeneratorConstants;
import hu.bme.mit.mobilegen.datamodel.generator.GeneratorData;
import hu.bme.mit.mobilegen.datamodel.helper.WrappedEntity;
import hu.bme.mit.mobilegen.datamodel.logger.Log;
import java.util.ArrayList;
import java.util.List;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.generator.IFileSystemAccess;
import org.eclipse.xtext.xbase.lib.StringExtensions;

@SuppressWarnings("all")
public class ORMLiteDatabaseHelperGenerator {
  private List<WrappedEntity> wes;
  
  private List<String> imports;
  
  public void generateDatabaseHelper(final List<WrappedEntity> entities, final IFileSystemAccess fsa) {
    this.wes = entities;
    this.collectImports();
    Log.info("Generating DatabaseHelper.java");
    CharSequence _generateDatabaseHelper = this.generateDatabaseHelper();
    fsa.generateFile("DatabaseHelper.java", GeneratorConstants.SRC_GEN_DB, _generateDatabaseHelper);
  }
  
  private boolean collectImports() {
    boolean _xblockexpression = false;
    {
      ArrayList<String> _arrayList = new ArrayList<String>();
      this.imports = _arrayList;
      for (final WrappedEntity we : this.wes) {
        String _packageName = GeneratorData.getPackageName();
        String _plus = (_packageName + ".entities.");
        Entity _entity = we.getEntity();
        String _name = _entity.getName();
        String _firstUpper = StringExtensions.toFirstUpper(_name);
        String _plus_1 = (_plus + _firstUpper);
        this.imports.add(_plus_1);
      }
      this.imports.add("java.sql.SQLException");
      this.imports.add("android.content.Context");
      this.imports.add("android.database.sqlite.SQLiteDatabase");
      this.imports.add("com.j256.ormlite.android.apptools.OrmLiteSqliteOpenHelper");
      this.imports.add("com.j256.ormlite.support.ConnectionSource");
      _xblockexpression = this.imports.add("com.j256.ormlite.table.TableUtils");
    }
    return _xblockexpression;
  }
  
  private CharSequence generateDatabaseHelper() {
    StringConcatenation _builder = new StringConcatenation();
    CharSequence _classHeader = this.classHeader();
    _builder.append(_classHeader, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _packageDeclaration = this.packageDeclaration();
    _builder.append(_packageDeclaration, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _classImports = this.classImports();
    _builder.append(_classImports, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("//");
    _builder.newLine();
    CharSequence _classDeclaration = this.classDeclaration();
    _builder.append(_classDeclaration, "");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence classHeader() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//------------------------- Geneated Java Class File For DatabaseHelper Class ---------------------------------");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence packageDeclaration() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("package ");
    String _packageName = GeneratorData.getPackageName();
    _builder.append(_packageName, "");
    _builder.append(".");
    _builder.append(GeneratorConstants.SRC_GEN_DB, "");
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence classImports() {
    StringConcatenation _builder = new StringConcatenation();
    {
      for(final String f : this.imports) {
        _builder.append("import ");
        _builder.append(f, "");
        _builder.append(";");
        _builder.newLineIfNotEmpty();
      }
    }
    return _builder;
  }
  
  private CharSequence classJavaDoc() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("/**");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <!-- begin-user-doc -->");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* This Class contains the representation of the model object \'<em><b></b></em>\'.");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* For each Entity the generator creates an EntityGEN.java file,");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* which contains EntityGEN class with every Property and Association for the Entity.");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* This Java file will be override, with each generation.");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* The generator creates an Entity.java file, with the Entity class,");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* which extends form EntityGEN. This file normally (if the Entity is not deleted)");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* won\'t be overrided, so this file can be modified between the generations.");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* ");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* This is The EntityGEN.java file. It must contain only the generated code.");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* Do not edit it, or it will be overrided with each generation!");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* </p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <!-- end-user-doc -->");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* The following features are supported:");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <ul>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getCache <em>Cache</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getPersistentType <em>Persistent Type</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#isAbstract <em>Abstract</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getName <em>Name</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getSuperType <em>Super Type</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getRelationship <em>Relationship</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getProperty <em>Property</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* </ul>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* </p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* @see hu.bme.hellga.onlab.OnlabPackage#getEntity()");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* @model");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* @generated");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*/");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence classDeclaration() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("class DatabaseHelper extends OrmLiteSqliteOpenHelper {");
    _builder.newLine();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    CharSequence _classBody = this.classBody();
    _builder.append(_classBody, "\t");
    _builder.newLineIfNotEmpty();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence classBody() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("// Property declarations");
    _builder.newLine();
    _builder.newLine();
    CharSequence _properties = this.properties();
    _builder.append(_properties, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("// Constructor");
    _builder.newLine();
    _builder.newLine();
    CharSequence _constructor = this.constructor();
    _builder.append(_constructor, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _onCreate = this.onCreate();
    _builder.append(_onCreate, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _onUpgrade = this.onUpgrade();
    _builder.append(_onUpgrade, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _close = this.close();
    _builder.append(_close, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence properties() {
    StringConcatenation _builder = new StringConcatenation();
    CharSequence _databaseName = this.databaseName();
    _builder.append(_databaseName, "");
    _builder.newLineIfNotEmpty();
    CharSequence _databaseVersion = this.databaseVersion();
    _builder.append(_databaseVersion, "");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence databaseName() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//");
    _builder.newLine();
    _builder.append("public static final String DATABASE_NAME = \"");
    String _dBName = GeneratorData.getDBName();
    _builder.append(_dBName, "");
    _builder.append("\";");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence databaseVersion() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//");
    _builder.newLine();
    _builder.append("public static final int DATABASE_VERSION = ");
    int _dBVersion = GeneratorData.getDBVersion();
    _builder.append(_dBVersion, "");
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence constructor() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//");
    _builder.newLine();
    CharSequence _constructorDeclaration = this.constructorDeclaration();
    _builder.append(_constructorDeclaration, "");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence constructorJavaDoc() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("/**");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* JavaDoc");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* </p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <!-- end-user-doc -->");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* The following features are supported:");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* @see hu.bme.hellga.onlab.OnlabPackage#getEntity()");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* @model");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* @generated");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*/");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence constructorDeclaration() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("public DatabaseHelper(Context context) {");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("super(context, DATABASE_NAME, null, DATABASE_VERSION);");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence onCreate() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//");
    _builder.newLine();
    _builder.append("@Override");
    _builder.newLine();
    _builder.append("public void onCreate(SQLiteDatabase db, ConnectionSource connectionSource) {");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("try {");
    _builder.newLine();
    {
      for(final WrappedEntity f : this.wes) {
        _builder.append("\t\t");
        CharSequence _createTable = this.createTable(f);
        _builder.append(_createTable, "\t\t");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("\t");
    _builder.append("} catch (SQLException e) {");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("e.printStackTrace();");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence createTable(final WrappedEntity we) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("TableUtils.createTable(connectionSource, ");
    Entity _entity = we.getEntity();
    String _name = _entity.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    _builder.append(_firstUpper, "");
    _builder.append(".class);");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence onUpgrade() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//");
    _builder.newLine();
    _builder.append("@Override");
    _builder.newLine();
    _builder.append("public void onUpgrade(SQLiteDatabase db, ConnectionSource connectionSource, int oldVersion, int newVersion) {");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("try {");
    _builder.newLine();
    {
      for(final WrappedEntity f : this.wes) {
        _builder.append("\t\t");
        CharSequence _dropTable = this.dropTable(f);
        _builder.append(_dropTable, "\t\t");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("\t\t");
    _builder.append("onCreate(db, connectionSource);");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("} catch (SQLException e) {");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("e.printStackTrace();");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence dropTable(final WrappedEntity we) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("TableUtils.dropTable(connectionSource, ");
    Entity _entity = we.getEntity();
    String _name = _entity.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    _builder.append(_firstUpper, "");
    _builder.append(".class, true);");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence close() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//");
    _builder.newLine();
    _builder.append("@Override");
    _builder.newLine();
    _builder.append("public void close() {");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("super.close();");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
}
