package hu.bme.mit.mobilegen.datamodel.generator.database.ormlite;

import com.google.common.base.Objects;
import com.google.inject.Inject;
import hu.bme.mit.mobilegen.datamodel.generator.DeviceType;
import hu.bme.mit.mobilegen.datamodel.generator.GeneratorData;
import hu.bme.mit.mobilegen.datamodel.generator.database.ormlite.ORMLiteDAOFactoryGenerator;
import hu.bme.mit.mobilegen.datamodel.generator.database.ormlite.ORMLiteDAOGenerator;
import hu.bme.mit.mobilegen.datamodel.generator.database.ormlite.ORMLiteDAOInterfaceGenerator;
import hu.bme.mit.mobilegen.datamodel.generator.database.ormlite.ORMLiteDataCacheGenerator;
import hu.bme.mit.mobilegen.datamodel.generator.database.ormlite.ORMLiteDatabaseFactoryGenerator;
import hu.bme.mit.mobilegen.datamodel.generator.database.ormlite.ORMLiteDatabaseHelperGenerator;
import hu.bme.mit.mobilegen.datamodel.generator.database.ormlite.ORMLiteJarProvider;
import hu.bme.mit.mobilegen.datamodel.helper.WrappedEntity;
import java.util.List;
import org.eclipse.core.resources.IProject;
import org.eclipse.xtext.generator.IFileSystemAccess;

@SuppressWarnings("all")
public class ORMLiteGenerator {
  @Inject
  private ORMLiteDatabaseHelperGenerator helperGen;
  
  @Inject
  private ORMLiteDatabaseFactoryGenerator dbFactoryGen;
  
  @Inject
  private ORMLiteDAOFactoryGenerator daoFactoryGen;
  
  @Inject
  private ORMLiteDAOInterfaceGenerator daoInterfaceGen;
  
  @Inject
  private ORMLiteDAOGenerator daoGen;
  
  @Inject
  private ORMLiteDataCacheGenerator dataCacheGen;
  
  private List<WrappedEntity> DBEntity;
  
  public void generateORMLiteDataAccessLayer(final List<WrappedEntity> db, final IFileSystemAccess fsa) {
    this.DBEntity = db;
    DeviceType _device = GeneratorData.getDevice();
    boolean _equals = Objects.equal(_device, DeviceType.Android);
    if (_equals) {
      this.generateORMDataAccessLayer4Android(this.DBEntity, fsa);
    }
  }
  
  private void generateORMDataAccessLayer4Android(final List<WrappedEntity> entities, final IFileSystemAccess fsa) {
    int _size = this.DBEntity.size();
    boolean _greaterThan = (_size > 0);
    if (_greaterThan) {
      this.helperGen.generateDatabaseHelper(entities, fsa);
      this.dbFactoryGen.generateDatabaseFactory(entities, fsa);
      this.daoFactoryGen.generateDAOFactory(entities, fsa);
      IProject _project = GeneratorData.getProject();
      ORMLiteJarProvider.copyJarFiles(_project);
    }
    for (final WrappedEntity we : entities) {
      {
        this.daoInterfaceGen.generateDAOInterface(we, fsa);
        this.daoGen.generateDAO(we, fsa);
      }
    }
    boolean _isCache = GeneratorData.isCache();
    if (_isCache) {
      this.dataCacheGen.generateDataCache(entities, fsa);
      this.dataCacheGen.generateGenericDAOInterface(fsa);
      this.dataCacheGen.generateGenericDAO(fsa);
    }
  }
}
