package hu.bme.mit.mobilegen.datamodel.generator.database.ormlite;

import com.google.common.base.Objects;
import hu.bme.mit.mobilegen.datamodel.datamodel.Association;
import hu.bme.mit.mobilegen.datamodel.datamodel.ConnectionDirection;
import hu.bme.mit.mobilegen.datamodel.datamodel.ConnectionType;
import hu.bme.mit.mobilegen.datamodel.datamodel.Entity;
import hu.bme.mit.mobilegen.datamodel.datamodel.PersistentType;
import hu.bme.mit.mobilegen.datamodel.datamodel.Property;
import hu.bme.mit.mobilegen.datamodel.generator.database.IDatabaseGeneratorUtility;
import hu.bme.mit.mobilegen.datamodel.helper.WrappedEntity;
import java.util.List;
import org.eclipse.emf.common.util.EList;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.xbase.lib.StringExtensions;

@SuppressWarnings("all")
public class ORMLiteGeneratorUtility implements IDatabaseGeneratorUtility {
  public CharSequence classAnnotations(final Entity e) {
    StringConcatenation _builder = new StringConcatenation();
    {
      boolean _isAbstract = e.isAbstract();
      boolean _not = (!_isAbstract);
      if (_not) {
        _builder.append("@DatabaseTable(tableName = \"");
        String _name = e.getName();
        String _lowerCase = _name.toLowerCase();
        _builder.append(_lowerCase, "");
        _builder.append("\")");
        _builder.newLineIfNotEmpty();
      }
    }
    return _builder;
  }
  
  public CharSequence propertyAnnotations(final Property p) {
    StringConcatenation _builder = new StringConcatenation();
    {
      boolean _and = false;
      boolean _isTransient = p.isTransient();
      boolean _not = (!_isTransient);
      if (!_not) {
        _and = false;
      } else {
        boolean _isStatic = p.isStatic();
        boolean _not_1 = (!_isStatic);
        _and = _not_1;
      }
      if (_and) {
        _builder.append("@DatabaseField(columnName = ");
        String _name = p.getName();
        String _upperCase = _name.toUpperCase();
        _builder.append(_upperCase, "");
        _builder.append("_FIELD_NAME");
        {
          boolean _isUnique = p.isUnique();
          if (_isUnique) {
            _builder.append(", unique = true");
          }
        }
        {
          boolean _isCantBeNull = p.isCantBeNull();
          if (_isCantBeNull) {
            _builder.append(", canBeNull = false");
          }
        }
        {
          boolean _isIndexed = p.isIndexed();
          if (_isIndexed) {
            _builder.append(", index = true");
          }
        }
        _builder.append(")");
        _builder.newLineIfNotEmpty();
      }
    }
    return _builder;
  }
  
  public CharSequence associationAnnotations(final Association a) {
    StringConcatenation _builder = new StringConcatenation();
    {
      boolean _and = false;
      boolean _isTransient = a.isTransient();
      boolean _not = (!_isTransient);
      if (!_not) {
        _and = false;
      } else {
        boolean _isStatic = a.isStatic();
        boolean _not_1 = (!_isStatic);
        _and = _not_1;
      }
      if (_and) {
        {
          ConnectionType _connectionType = a.getConnectionType();
          boolean _equals = Objects.equal(_connectionType, ConnectionType.MANY);
          if (_equals) {
            _builder.append("@ForeignCollectionField(foreignFieldName = \"");
            String _inverseName = a.getInverseName();
            _builder.append(_inverseName, "");
            _builder.append("\")");
            _builder.newLineIfNotEmpty();
          } else {
            _builder.append("@DatabaseField(foreign = true, columnName = ");
            String _name = a.getName();
            String _upperCase = _name.toUpperCase();
            _builder.append(_upperCase, "");
            _builder.append("_ID_FIELD_NAME");
            {
              boolean _or = false;
              boolean _or_1 = false;
              ConnectionDirection _connectionDir = a.getConnectionDir();
              boolean _equals_1 = Objects.equal(_connectionDir, ConnectionDirection.ONE_TO_ONE_UNI_DIRECTION);
              if (_equals_1) {
                _or_1 = true;
              } else {
                ConnectionDirection _connectionDir_1 = a.getConnectionDir();
                boolean _equals_2 = Objects.equal(_connectionDir_1, ConnectionDirection.ONE_TO_ONE_BI_DIRECTION);
                _or_1 = _equals_2;
              }
              if (_or_1) {
                _or = true;
              } else {
                ConnectionDirection _connectionDir_2 = a.getConnectionDir();
                boolean _equals_3 = Objects.equal(_connectionDir_2, ConnectionDirection.ONE_TO_ONE_INVERSE_DIRECTION);
                _or = _equals_3;
              }
              if (_or) {
                _builder.append(", unique = true");
              }
            }
            _builder.append(")");
            _builder.newLineIfNotEmpty();
          }
        }
      }
    }
    return _builder;
  }
  
  public CharSequence propertyID(final Entity e) {
    StringConcatenation _builder = new StringConcatenation();
    {
      boolean _isExtends = e.isExtends();
      boolean _not = (!_isExtends);
      if (_not) {
        _builder.append("@DatabaseField(columnName = \"id\", generatedId = true)");
        _builder.newLine();
        _builder.append("private int id;");
        _builder.newLine();
      }
    }
    return _builder;
  }
  
  public CharSequence associationListDeclaration(final Association a) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("protected ForeignCollection<");
    Entity _connectTo = a.getConnectTo();
    String _name = _connectTo.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    _builder.append(_firstUpper, "");
    _builder.append("> ");
    String _name_1 = a.getName();
    String _firstLower = StringExtensions.toFirstLower(_name_1);
    _builder.append(_firstLower, "");
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  public CharSequence associationListGetter(final Association a) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("public ForeignCollection<");
    Entity _connectTo = a.getConnectTo();
    String _name = _connectTo.getName();
    _builder.append(_name, "");
    _builder.append("> get");
    String _name_1 = a.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name_1);
    _builder.append(_firstUpper, "");
    _builder.append("(){");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("return this.");
    String _name_2 = a.getName();
    String _firstLower = StringExtensions.toFirstLower(_name_2);
    _builder.append(_firstLower, "\t");
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  public CharSequence associationListSetter(final Association a) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("public void set");
    String _name = a.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    _builder.append(_firstUpper, "");
    _builder.append("(ForeignCollection<");
    Entity _connectTo = a.getConnectTo();
    String _name_1 = _connectTo.getName();
    _builder.append(_name_1, "");
    _builder.append("> ");
    String _name_2 = a.getName();
    String _firstLower = StringExtensions.toFirstLower(_name_2);
    _builder.append(_firstLower, "");
    _builder.append("){");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("this.");
    String _name_3 = a.getName();
    String _firstLower_1 = StringExtensions.toFirstLower(_name_3);
    _builder.append(_firstLower_1, "\t");
    _builder.append(" = ");
    String _name_4 = a.getName();
    String _firstLower_2 = StringExtensions.toFirstLower(_name_4);
    _builder.append(_firstLower_2, "\t");
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  public CharSequence idGetter(final Entity e) {
    StringConcatenation _builder = new StringConcatenation();
    {
      boolean _isExtends = e.isExtends();
      boolean _not = (!_isExtends);
      if (_not) {
        _builder.append("//");
        _builder.newLine();
        _builder.append("public int getId() {");
        _builder.newLine();
        _builder.append("\t");
        _builder.append("return id;");
        _builder.newLine();
        _builder.append("}");
        _builder.newLine();
      }
    }
    return _builder;
  }
  
  public CharSequence fieldNames(final Entity e) {
    StringConcatenation _builder = new StringConcatenation();
    {
      EList<Property> _property = e.getProperty();
      for(final Property f : _property) {
        {
          boolean _isTransient = f.isTransient();
          boolean _not = (!_isTransient);
          if (_not) {
            _builder.append("public static final String ");
            String _name = f.getName();
            String _upperCase = _name.toUpperCase();
            _builder.append(_upperCase, "");
            _builder.append("_FIELD_NAME = \"");
            String _name_1 = f.getName();
            String _lowerCase = _name_1.toLowerCase();
            _builder.append(_lowerCase, "");
            _builder.append("\";");
            _builder.newLineIfNotEmpty();
          }
        }
      }
    }
    {
      EList<Association> _association = e.getAssociation();
      for(final Association f_1 : _association) {
        {
          boolean _isTransient_1 = f_1.isTransient();
          boolean _not_1 = (!_isTransient_1);
          if (_not_1) {
            _builder.append("public static final String ");
            String _name_2 = f_1.getName();
            String _upperCase_1 = _name_2.toUpperCase();
            _builder.append(_upperCase_1, "");
            _builder.append("_ID_FIELD_NAME = \"");
            String _name_3 = f_1.getName();
            String _lowerCase_1 = _name_3.toLowerCase();
            _builder.append(_lowerCase_1, "");
            _builder.append("_id\";");
            _builder.newLineIfNotEmpty();
          }
        }
      }
    }
    return _builder;
  }
  
  public void collectEntityGENImports(final List<String> imports, final WrappedEntity we) {
    boolean field = false;
    boolean collection = false;
    Entity _entity = we.getEntity();
    EList<Property> _property = _entity.getProperty();
    for (final Property p : _property) {
      boolean _and = false;
      boolean _isTransient = p.isTransient();
      boolean _not = (!_isTransient);
      if (!_not) {
        _and = false;
      } else {
        boolean _isStatic = p.isStatic();
        boolean _not_1 = (!_isStatic);
        _and = _not_1;
      }
      if (_and) {
        field = true;
      }
    }
    Entity _entity_1 = we.getEntity();
    EList<Association> _association = _entity_1.getAssociation();
    for (final Association a : _association) {
      boolean _and_1 = false;
      boolean _isTransient_1 = a.isTransient();
      boolean _not_2 = (!_isTransient_1);
      if (!_not_2) {
        _and_1 = false;
      } else {
        boolean _isStatic_1 = a.isStatic();
        boolean _not_3 = (!_isStatic_1);
        _and_1 = _not_3;
      }
      if (_and_1) {
        ConnectionType _connectionType = a.getConnectionType();
        boolean _equals = Objects.equal(_connectionType, ConnectionType.MANY);
        if (_equals) {
          collection = true;
        } else {
          field = true;
        }
      }
    }
    if (field) {
      imports.add("com.j256.ormlite.field.DatabaseField");
    }
    if (collection) {
      imports.add("com.j256.ormlite.dao.ForeignCollection");
      imports.add("com.j256.ormlite.field.ForeignCollectionField");
    }
  }
  
  public void collectEntityImports(final List<String> imports, final WrappedEntity we) {
    boolean _and = false;
    Entity _entity = we.getEntity();
    PersistentType _persistentType = _entity.getPersistentType();
    boolean _equals = Objects.equal(_persistentType, PersistentType.DB);
    if (!_equals) {
      _and = false;
    } else {
      Entity _entity_1 = we.getEntity();
      boolean _isAbstract = _entity_1.isAbstract();
      boolean _not = (!_isAbstract);
      _and = _not;
    }
    if (_and) {
      imports.add("com.j256.ormlite.table.DatabaseTable");
    }
  }
}
