package hu.bme.mit.mobilegen.datamodel.generator.serialize;

import com.google.common.base.Objects;
import hu.bme.mit.mobilegen.datamodel.datamodel.Entity;
import hu.bme.mit.mobilegen.datamodel.generator.DeviceType;
import hu.bme.mit.mobilegen.datamodel.generator.GeneratorConstants;
import hu.bme.mit.mobilegen.datamodel.generator.GeneratorData;
import hu.bme.mit.mobilegen.datamodel.helper.WrappedEntity;
import hu.bme.mit.mobilegen.datamodel.helper.WrappedModel;
import hu.bme.mit.mobilegen.datamodel.logger.Log;
import java.util.ArrayList;
import java.util.List;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.generator.IFileSystemAccess;
import org.eclipse.xtext.xbase.lib.StringExtensions;

@SuppressWarnings("all")
public class SerializeGenerator {
  private List<WrappedEntity> wes;
  
  private List<String> imports;
  
  public void generateSerializationUnit(final WrappedModel wm, final IFileSystemAccess fsa) {
    List<WrappedEntity> _serialized = wm.getSerialized();
    this.wes = _serialized;
    this.collectImports();
    int _size = this.wes.size();
    boolean _greaterThan = (_size > 0);
    if (_greaterThan) {
      DeviceType _device = GeneratorData.getDevice();
      boolean _equals = Objects.equal(_device, DeviceType.Android);
      if (_equals) {
        Log.info("Generating SerializationUnit.java");
        CharSequence _generateSerializationUnit = this.generateSerializationUnit();
        fsa.generateFile("SerializationUnit.java", GeneratorConstants.SRC_GEN_SER, _generateSerializationUnit);
      }
    }
  }
  
  private boolean collectImports() {
    boolean _xblockexpression = false;
    {
      ArrayList<String> _arrayList = new ArrayList<String>();
      this.imports = _arrayList;
      for (final WrappedEntity we : this.wes) {
        String _packageName = GeneratorData.getPackageName();
        String _plus = (_packageName + ".entities.");
        Entity _entity = we.getEntity();
        String _name = _entity.getName();
        String _plus_1 = (_plus + _name);
        this.imports.add(_plus_1);
      }
      this.imports.add("java.io.FileInputStream");
      this.imports.add("java.io.FileOutputStream");
      this.imports.add("java.io.IOException");
      this.imports.add("java.io.ObjectInputStream");
      this.imports.add("java.io.ObjectOutputStream");
      _xblockexpression = this.imports.add("android.content.Context");
    }
    return _xblockexpression;
  }
  
  private CharSequence generateSerializationUnit() {
    StringConcatenation _builder = new StringConcatenation();
    CharSequence _classHeader = this.classHeader();
    _builder.append(_classHeader, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _packageDeclaration = this.packageDeclaration();
    _builder.append(_packageDeclaration, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _classImports = this.classImports();
    _builder.append(_classImports, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("//");
    _builder.newLine();
    CharSequence _classDeclaration = this.classDeclaration();
    _builder.append(_classDeclaration, "");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence classHeader() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//------------------------- Geneated Java Class File For SerializationUnit ---------------------------------");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence packageDeclaration() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("package ");
    String _packageName = GeneratorData.getPackageName();
    _builder.append(_packageName, "");
    _builder.append(".");
    _builder.append(GeneratorConstants.SRC_GEN_SER, "");
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence classImports() {
    StringConcatenation _builder = new StringConcatenation();
    {
      for(final String f : this.imports) {
        _builder.append("import ");
        _builder.append(f, "");
        _builder.append(";");
        _builder.newLineIfNotEmpty();
      }
    }
    return _builder;
  }
  
  private CharSequence classJavaDoc() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("/**");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <!-- begin-user-doc -->");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* This Class contains the representation of the model object \'<em><b></b></em>\'.");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* For each Entity the generator creates an EntityGEN.java file,");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* which contains EntityGEN class with every Property and Association for the Entity.");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* This Java file will be override, with each generation.");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* The generator creates an Entity.java file, with the Entity class,");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* which extends form EntityGEN. This file normally (if the Entity is not deleted)");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* won\'t be overrided, so this file can be modified between the generations.");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* ");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* This is The Entity.java file. It is created at the first generation, after that,");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* it can be modified, it won\'t be overrided, until the Entity is renamed, or the");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* Entity is deleted.");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* </p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <!-- end-user-doc -->");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* The following features are supported:");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <ul>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getCache <em>Cache</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getPersistentType <em>Persistent Type</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#isAbstract <em>Abstract</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getName <em>Name</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getSuperType <em>Super Type</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getRelationship <em>Relationship</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getProperty <em>Property</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* </ul>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* </p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* @see hu.bme.hellga.onlab.OnlabPackage#getEntity()");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* @model");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* @generated");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*/");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence classDeclaration() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("public class SerializationUnit {");
    _builder.newLine();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    CharSequence _serialization = this.serialization();
    _builder.append(_serialization, "\t");
    _builder.newLineIfNotEmpty();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence serialization() {
    StringConcatenation _builder = new StringConcatenation();
    {
      for(final WrappedEntity f : this.wes) {
        Entity _entity = f.getEntity();
        CharSequence _serialize = this.serialize(_entity);
        _builder.append(_serialize, "");
        _builder.newLineIfNotEmpty();
        Entity _entity_1 = f.getEntity();
        CharSequence _deserialize = this.deserialize(_entity_1);
        _builder.append(_deserialize, "");
        _builder.newLineIfNotEmpty();
      }
    }
    return _builder;
  }
  
  private CharSequence serialize(final Entity e) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//");
    _builder.newLine();
    _builder.append("public static boolean serialize");
    String _name = e.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    _builder.append(_firstUpper, "");
    _builder.append("(String filename, ");
    String _name_1 = e.getName();
    String _firstUpper_1 = StringExtensions.toFirstUpper(_name_1);
    _builder.append(_firstUpper_1, "");
    _builder.append(" ");
    String _name_2 = e.getName();
    String _firstLower = StringExtensions.toFirstLower(_name_2);
    _builder.append(_firstLower, "");
    _builder.append(", Context ctx){");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("try {");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("FileOutputStream f = ctx.openFileOutput(filename, Context.MODE_PRIVATE);");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("ObjectOutputStream out = new ObjectOutputStream(f);");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("out.writeObject(");
    String _name_3 = e.getName();
    String _firstLower_1 = StringExtensions.toFirstLower(_name_3);
    _builder.append(_firstLower_1, "\t\t");
    _builder.append(");");
    _builder.newLineIfNotEmpty();
    _builder.append("\t\t");
    _builder.append("out.close();");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("f.close();");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("}catch(IOException ex) {");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("return false;");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("return true;");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence deserialize(final Entity e) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//");
    _builder.newLine();
    _builder.append("public static ");
    String _name = e.getName();
    String _firstUpper = StringExtensions.toFirstUpper(_name);
    _builder.append(_firstUpper, "");
    _builder.append(" deserialize");
    String _name_1 = e.getName();
    String _firstUpper_1 = StringExtensions.toFirstUpper(_name_1);
    _builder.append(_firstUpper_1, "");
    _builder.append("(String filename, Context ctx){");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    String _name_2 = e.getName();
    String _firstUpper_2 = StringExtensions.toFirstUpper(_name_2);
    _builder.append(_firstUpper_2, "\t");
    _builder.append(" ");
    String _name_3 = e.getName();
    String _firstLower = StringExtensions.toFirstLower(_name_3);
    _builder.append(_firstLower, "\t");
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("try {");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("FileInputStream f = ctx.openFileInput(filename);");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("ObjectInputStream in = new ObjectInputStream(f);");
    _builder.newLine();
    _builder.append("\t\t");
    String _name_4 = e.getName();
    String _firstLower_1 = StringExtensions.toFirstLower(_name_4);
    _builder.append(_firstLower_1, "\t\t");
    _builder.append(" = (");
    String _name_5 = e.getName();
    String _firstUpper_3 = StringExtensions.toFirstUpper(_name_5);
    _builder.append(_firstUpper_3, "\t\t");
    _builder.append(")in.readObject();");
    _builder.newLineIfNotEmpty();
    _builder.append("\t\t");
    _builder.append("in.close();");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("f.close();");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("}catch(IOException ex) {");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("return null;");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("catch(ClassNotFoundException ex) {");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("return null;");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("return ");
    String _name_6 = e.getName();
    String _firstLower_2 = StringExtensions.toFirstLower(_name_6);
    _builder.append(_firstLower_2, "\t");
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    return _builder;
  }
}
