package hu.bme.mit.mobilegen.datamodel.generator.sharedpreferences;

import com.google.common.base.Objects;
import hu.bme.mit.mobilegen.datamodel.generator.DeviceType;
import hu.bme.mit.mobilegen.datamodel.generator.GeneratorConstants;
import hu.bme.mit.mobilegen.datamodel.generator.GeneratorData;
import hu.bme.mit.mobilegen.datamodel.helper.WrappedEntity;
import hu.bme.mit.mobilegen.datamodel.helper.WrappedModel;
import hu.bme.mit.mobilegen.datamodel.logger.Log;
import java.util.List;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.generator.IFileSystemAccess;

@SuppressWarnings("all")
public class SharedPreferencesGenerator {
  private List<WrappedEntity> wes;
  
  public void generateSharedPreferencesUnit(final WrappedModel wm, final IFileSystemAccess fsa) {
    List<WrappedEntity> _sharedPreferences = wm.getSharedPreferences();
    this.wes = _sharedPreferences;
    int _size = this.wes.size();
    boolean _greaterThan = (_size > 0);
    if (_greaterThan) {
      DeviceType _device = GeneratorData.getDevice();
      boolean _equals = Objects.equal(_device, DeviceType.Android);
      if (_equals) {
        Log.info("Generating SharedPreferencesUnit.java");
        CharSequence _generateSharedPreferencesUnit = this.generateSharedPreferencesUnit();
        fsa.generateFile("SharedPreferencesUnit.java", GeneratorConstants.SRC_GEN_PREFS, _generateSharedPreferencesUnit);
      }
    }
  }
  
  private CharSequence generateSharedPreferencesUnit() {
    StringConcatenation _builder = new StringConcatenation();
    CharSequence _classHeader = this.classHeader();
    _builder.append(_classHeader, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _packageDeclaration = this.packageDeclaration();
    _builder.append(_packageDeclaration, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _classImports = this.classImports();
    _builder.append(_classImports, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("//");
    _builder.newLine();
    CharSequence _classDeclaration = this.classDeclaration();
    _builder.append(_classDeclaration, "");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence classHeader() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//------------------------- Geneated Java Class File For SerializationUnit ---------------------------------");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence packageDeclaration() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("package ");
    String _packageName = GeneratorData.getPackageName();
    _builder.append(_packageName, "");
    _builder.append(".");
    _builder.append(GeneratorConstants.SRC_GEN_PREFS, "");
    _builder.append(";");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence classImports() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("import android.content.Context;");
    _builder.newLine();
    _builder.append("import android.content.SharedPreferences;");
    _builder.newLine();
    _builder.append("import android.content.SharedPreferences.Editor;");
    _builder.newLine();
    _builder.append("import java.util.Set;");
    _builder.newLine();
    _builder.append("import java.util.HashSet;");
    _builder.newLine();
    _builder.append("import java.util.Map;");
    _builder.newLine();
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence classJavaDoc() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("/**");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <!-- begin-user-doc -->");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* This Class contains the representation of the model object \'<em><b></b></em>\'.");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* For each Entity the generator creates an EntityGEN.java file,");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* which contains EntityGEN class with every Property and Association for the Entity.");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* This Java file will be override, with each generation.");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* The generator creates an Entity.java file, with the Entity class,");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* which extends form EntityGEN. This file normally (if the Entity is not deleted)");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* won\'t be overrided, so this file can be modified between the generations.");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* ");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* This is The Entity.java file. It is created at the first generation, after that,");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* it can be modified, it won\'t be overrided, until the Entity is renamed, or the");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* Entity is deleted.");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* </p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <!-- end-user-doc -->");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* The following features are supported:");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* <ul>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getCache <em>Cache</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getPersistentType <em>Persistent Type</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#isAbstract <em>Abstract</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getName <em>Name</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getSuperType <em>Super Type</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getRelationship <em>Relationship</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*   <li>{@link hu.bme.hellga.onlab.Entity#getProperty <em>Property</em>}</li>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* </ul>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* </p>");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* @see hu.bme.hellga.onlab.OnlabPackage#getEntity()");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* @model");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("* @generated");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*/");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence classDeclaration() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("public class SharedPreferencesUnit {");
    _builder.newLine();
    _builder.append("\t");
    _builder.newLine();
    _builder.append("\t");
    CharSequence _sharedpreferences = this.sharedpreferences();
    _builder.append(_sharedpreferences, "\t");
    _builder.newLineIfNotEmpty();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence sharedpreferences() {
    StringConcatenation _builder = new StringConcatenation();
    CharSequence _putBoolean = this.putBoolean();
    _builder.append(_putBoolean, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _putFloat = this.putFloat();
    _builder.append(_putFloat, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _putInt = this.putInt();
    _builder.append(_putInt, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _putLong = this.putLong();
    _builder.append(_putLong, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _putString = this.putString();
    _builder.append(_putString, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _putStrings = this.putStrings();
    _builder.append(_putStrings, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _boolean = this.getBoolean();
    _builder.append(_boolean, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _float = this.getFloat();
    _builder.append(_float, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _int = this.getInt();
    _builder.append(_int, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _long = this.getLong();
    _builder.append(_long, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _string = this.getString();
    _builder.append(_string, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _strings = this.getStrings();
    _builder.append(_strings, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    CharSequence _all = this.getAll();
    _builder.append(_all, "");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  private CharSequence putBoolean() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//");
    _builder.newLine();
    _builder.append("public static void putBoolean(String preferenceName, String key, boolean value, Context ctx){");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("SharedPreferences sp = ctx.getSharedPreferences(preferenceName, Context.MODE_PRIVATE);");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("Editor editor = sp.edit();");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("editor.putBoolean(key, value);");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("editor.commit();");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence putFloat() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//");
    _builder.newLine();
    _builder.append("public static void putFloat(String preferenceName, String key, float value, Context ctx){");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("SharedPreferences sp = ctx.getSharedPreferences(preferenceName, Context.MODE_PRIVATE);");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("Editor editor = sp.edit();");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("editor.putFloat(key, value);");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("editor.commit();");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence putInt() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//");
    _builder.newLine();
    _builder.append("public static void putInt(String preferenceName, String key, int value, Context ctx){");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("SharedPreferences sp = ctx.getSharedPreferences(preferenceName, Context.MODE_PRIVATE);");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("Editor editor = sp.edit();");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("editor.putInt(key, value);");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("editor.commit();");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence putLong() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//");
    _builder.newLine();
    _builder.append("public static void putLong(String preferenceName, String key, long value, Context ctx){");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("SharedPreferences sp = ctx.getSharedPreferences(preferenceName, Context.MODE_PRIVATE);");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("Editor editor = sp.edit();");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("editor.putLong(key, value);");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("editor.commit();");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence putString() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//");
    _builder.newLine();
    _builder.append("public static void putString(String preferenceName, String key, String value, Context ctx){");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("SharedPreferences sp = ctx.getSharedPreferences(preferenceName, Context.MODE_PRIVATE);");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("Editor editor = sp.edit();");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("editor.putString(key, value);");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("editor.commit();");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence putStrings() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//");
    _builder.newLine();
    _builder.append("public static void putStringSet(String preferenceName, String key, Set<String> values, Context ctx){");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("SharedPreferences sp = ctx.getSharedPreferences(preferenceName, Context.MODE_PRIVATE);");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("Editor editor = sp.edit();");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("editor.putStringSet(key, values);");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("editor.commit();");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence getBoolean() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//");
    _builder.newLine();
    _builder.append("public static boolean getBoolean(String preferenceName, String key, Context ctx){");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("SharedPreferences sp = ctx.getSharedPreferences(preferenceName, Context.MODE_PRIVATE);");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("return sp.getBoolean(key, false);");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence getFloat() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//");
    _builder.newLine();
    _builder.append("public static float getFloat(String preferenceName, String key, Context ctx){");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("SharedPreferences sp = ctx.getSharedPreferences(preferenceName, Context.MODE_PRIVATE);");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("return sp.getFloat(key, 0);");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence getInt() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//");
    _builder.newLine();
    _builder.append("public static int getInt(String preferenceName, String key, Context ctx){");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("SharedPreferences sp = ctx.getSharedPreferences(preferenceName, Context.MODE_PRIVATE);");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("return sp.getInt(key, 0);");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence getLong() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//");
    _builder.newLine();
    _builder.append("public static long getLong(String preferenceName, String key, Context ctx){");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("SharedPreferences sp = ctx.getSharedPreferences(preferenceName, Context.MODE_PRIVATE);");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("return sp.getLong(key, 0);");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence getString() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//");
    _builder.newLine();
    _builder.append("public static String getString(String preferenceName, String key, Context ctx){");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("SharedPreferences sp = ctx.getSharedPreferences(preferenceName, Context.MODE_PRIVATE);");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("return sp.getString(key, \"\");");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence getStrings() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//");
    _builder.newLine();
    _builder.append("public static Set<String> getStringSet(String preferenceName, String key, Context ctx){");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("SharedPreferences sp = ctx.getSharedPreferences(preferenceName, Context.MODE_PRIVATE);");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("return sp.getStringSet(key, new HashSet<String>());");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    return _builder;
  }
  
  private CharSequence getAll() {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("//");
    _builder.newLine();
    _builder.append("public static Map<String, ?> getAll(String preferenceName, Context ctx){");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("SharedPreferences sp = ctx.getSharedPreferences(preferenceName, Context.MODE_PRIVATE);");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("return sp.getAll();");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    return _builder;
  }
}
